# Generate automatically. Do not edit.

commit 66d6b42ef8dd84fcd8e199ac9f23f822f1a058c9
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-10-31

    Release 0.25.2
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 NEWS         | 5 +++++
 configure.ac | 2 +-
 meson.build  | 2 +-
 3 files changed, 7 insertions(+), 2 deletions(-)

commit 72ed0c2ab27b0ccbeec3ae08054eb674f49abdba
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-27

    tests: Run tests using SoftHSM after installation
    
    This makes the unit tests self-contained so all possible code paths
    are exercised without optional packages installed.  The integration
    tests against SoftHSM can still run after installation, through "make
    installcheck" or running the scripts manually.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .github/actions/basic-autotools/action.yaml        |  12 +-
 .github/actions/basic-meson/action.yaml            |  17 +-
 Makefile.am                                        |  14 ++
 meson_options.txt                                  |   4 +
 meson_post_install_test.sh                         |  15 ++
 p11-kit/Makefile.am                                |  16 +-
 .../{softhsm2.module => fourteen.module}           |   2 +-
 p11-kit/meson.build                                |  13 +-
 p11-kit/mock-module-ep12.c                         | 203 +++++++++++++++++++++
 p11-kit/test-generate-keypair.sh                   |  77 +++-----
 p11-kit/test-import-public.sh                      |  79 ++------
 p11-kit/test-lists.sh                              |  17 ++
 p11-kit/test-softhsm2.sh                           | 180 ++++++++++++++++++
 trust/Makefile.am                                  |   8 +-
 trust/meson.build                                  |  19 ++
 trust/test-extract.sh                              |   5 +
 trust/test-trust.sh                                |   0
 17 files changed, 552 insertions(+), 129 deletions(-)

commit cdc4720d29466e717aa694a85a7aee86ebb94172
Author: Erdem Meydanli <meydanli@amazon.com>
Date:   2023-10-26

    fix: improper comparison
    
    Compare the return value of the readpassphrase function to NULL.
    
    Signed-off-by: Erdem Meydanli <meydanli@amazon.com>

 p11-kit/tty.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8e21f76e5e5bd6d647bb56782183227d8829f552
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-26

    pkcs11-json: Make regeneration robuster
    
    Previously, when common/pkcs11.h is updated and castxml is not
    installed on the system, an empty pkcs11.json is created.  This makes
    the build process abort in that case.
    
    This also fixes the path of pkcs11.json referred to by
    p11-kit/Makefile.am, and only includes necessary files in the
    distribution.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 Makefile.am             |  2 +-
 p11-kit/Makefile.am     | 20 ++++++++++----------
 subprojects/pkcs11-json |  2 +-
 3 files changed, 12 insertions(+), 12 deletions(-)

commit 3ee322327b37d9137f3c2c8a9df267ddc7a44678
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-10-25

    Release 0.25.1
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 NEWS         | 13 +++++++++++++
 configure.ac |  2 +-
 meson.build  |  2 +-
 3 files changed, 15 insertions(+), 2 deletions(-)

commit 96a8b145a33f95eae52d7d31d0d7ed1674c68423
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-10-24

    Revise documentation of the object and profile sub-commands
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 doc/manual/p11-kit.xml | 99 +++++++++++++++++++++++++++++++++-----------------
 1 file changed, 65 insertions(+), 34 deletions(-)

commit bd75edd1aeb964b124b1b96e8d5c8cea0db6eacc
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-10-25

    Add --login option to delete-object command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/delete-object.c | 41 +++++++++++++++++++++++++++++++++++++----
 1 file changed, 37 insertions(+), 4 deletions(-)

commit 6bacb564458a3bb3b2de5a5dfded809a2e348d6b
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-04

    Add command for importing objects into a PKCS#11 token
    
    The import-object command allows users to import certificates or
    public keys into a pkcs#11 token by providing a PEM file.
    
    usage: p11-kit import-object --file=<file.pem> [--label=<label>]
    [--login] pkcs11:token
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/p11-kit       |   2 +-
 doc/manual/p11-kit.xml        |  19 +-
 p11-kit/Makefile.am           |   3 +
 p11-kit/import-object.c       | 615 ++++++++++++++++++++++++++++++++++++++++++
 p11-kit/meson.build           |   5 +
 p11-kit/p11-kit.c             |   4 +
 p11-kit/test-import-public.sh | 151 +++++++++++
 po/POTFILES.in                |   1 +
 8 files changed, 798 insertions(+), 2 deletions(-)

commit cced2d9a4772cb126974a69354b6a9845105407a
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-19

    iter: Add option to stop at token with active session
    
    The commit fd7c819eff1de40619ba0231dc8819af76df72a6 introduced a
    slight backward incompatibility to the P11KitIter behavior when
    iterating with P11_KIT_ITER_WITH_TOKENS: previously it stopped before
    opening a token, while now it stops after that.
    
    This adds a compatibility measure so those two are distinguishable
    with an explicit flag P11_KIT_ITER_WITH_SESSIONS and a kind
    P11_KIT_ITER_KIND_SESSION.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/add-profile.c      |  2 +-
 p11-kit/delete-profile.c   |  2 +-
 p11-kit/generate-keypair.c |  2 +-
 p11-kit/iter.c             | 31 ++++++++++++++++++++++---------
 p11-kit/iter.h             |  2 ++
 p11-kit/list-profiles.c    |  2 +-
 6 files changed, 28 insertions(+), 13 deletions(-)

commit e5f0be33f5d39ad117e1cb84de5a8ac1ebe75548
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-06

    p11-kit commands: Add --login option
    
    Previously those tools determined whether a login is necessary by
    checking the presence of "pin-value" query attribute in the URI.  It
    was too implicit and against modern security practice.  This instead
    asks users to specify --login option and if no "pin-value" is given,
    it tries to read a PIN from the terminal.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/add-profile.c            | 32 +++++++++++++++++++---
 p11-kit/delete-profile.c         | 32 +++++++++++++++++++---
 p11-kit/export-object.c          | 41 ++++++++++++++++++++++++++---
 p11-kit/generate-keypair.c       | 34 +++++++++++++++++++++---
 p11-kit/list-objects.c           | 42 ++++++++++++++++++++++++++---
 p11-kit/list-profiles.c          | 37 +++++++++++++++++++++++---
 p11-kit/test-generate-keypair.sh | 10 +++----
 p11-kit/test-objects.sh          | 57 +++++++++++++++++++++++++++++++++++++++-
 8 files changed, 257 insertions(+), 28 deletions(-)

commit 751118077ae093c33a093a9a0f634406b2e97c13
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-04

    p11-kit: Support PIN prompting from tty
    
    This adds support for prompting PIN on the terminal, through the
    readpassphrase function borrowed from libbsd.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/Makefile.am      |   6 ++
 common/compat.h         |  21 +++++
 common/meson.build      |  10 +++
 common/readpassphrase.c | 208 ++++++++++++++++++++++++++++++++++++++++++++++++
 configure.ac            |   2 +
 meson.build             |   3 +-
 p11-kit/Makefile.am     |  19 ++---
 p11-kit/meson.build     |   4 +
 p11-kit/pin.c           |   2 +-
 p11-kit/tty.c           |  78 ++++++++++++++++++
 p11-kit/tty.h           |  48 +++++++++++
 11 files changed, 385 insertions(+), 16 deletions(-)

commit 466da61d3ec8a1dbbc7f48eab8efb4d6f56d2a41
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-05

    p11-kit commands: Stop calling C_Login manually
    
    This is now done in P11KitIter as needed.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/add-profile.c      | 34 +++++++++-------------------------
 p11-kit/delete-profile.c   | 34 +++++++++-------------------------
 p11-kit/generate-keypair.c | 34 +++++++++-------------------------
 p11-kit/list-profiles.c    | 34 +++++++++-------------------------
 4 files changed, 36 insertions(+), 100 deletions(-)

commit fd7c819eff1de40619ba0231dc8819af76df72a6
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-05

    iter: Plumb PIN retrieval through pin-source
    
    This make P11KitIter use the P11KitPin interface to retrieve PIN if
    the "pin-source" attribute is available in the matching URI.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/iter.c      | 92 +++++++++++++++++++++++++++++++++++++++++++----------
 p11-kit/test-iter.c | 92 +++++++++++++++++++++++++++++++++++++++++++++++------
 po/POTFILES.in      |  1 +
 3 files changed, 159 insertions(+), 26 deletions(-)

commit 605232952fa4b4b9f0d7ac8d79afa97f992136a5
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-10-04

    Add list-tokens into po/POTFILES.in and autocompletion
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/p11-kit | 2 +-
 po/POTFILES.in          | 1 +
 2 files changed, 2 insertions(+), 1 deletion(-)

commit 168fdc2b6a9d5aa82a86b417ddf4bba9ef150e05
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-10-05

    Fix some cppcheck errors
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/compat.c       | 15 +++++++++------
 p11-kit/rpc-message.c |  6 +++---
 p11-kit/test-iter.c   | 16 ++++++++--------
 p11-kit/test-mock.c   | 18 +++++++++---------
 4 files changed, 29 insertions(+), 26 deletions(-)

commit 1cfbac317f2029a3a3a1c4cc65c49488efd0cd1e
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-10-04

    Fix CI warnings and errors
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 .github/actions/basic-meson/action.yaml |  2 +-
 build/cross_file_mingw64.txt            |  2 +-
 common/test-hash.c                      | 12 ++++++------
 3 files changed, 8 insertions(+), 8 deletions(-)

commit 1cec78401c814c589f2dd826de8eaf6c599a4608
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-01

    ci: Update base image and pull in additional packages
    
    This updates the base image to Fedora 38 from Fedora 34, and install
    the p11-kit-devel and softhsm packages, which are needed to test the
    p11-kit generate-keypair command.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 ci/Dockerfile | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit fc6d0e281ef3401a619dc1e6f6bbe2751c27b8b1
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-04

    p11-kit generate-keypair: Support EdDSA key generation
    
    This adds support for generating EdDSA keys with the p11-kit
    generate-keypair command.  Aside from that tests are added using
    SoftHSM to exercise all the supported algorithms.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/Makefile.am                              |  2 +
 p11-kit/fixtures/package-modules/softhsm2.module |  4 ++
 p11-kit/generate-keypair.c                       | 11 ++-
 p11-kit/meson.build                              |  4 ++
 p11-kit/test-generate-keypair.sh                 | 92 ++++++++++++++++++++++++
 p11-kit/test-server.sh                           |  1 +
 6 files changed, 113 insertions(+), 1 deletion(-)

commit e2c932038a2c4384d25d24cd5b249b9c84eb12a6
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-01

    p11-kit list-tokens: New subcommand
    
    This adds a new subcommand "list-tokens" to the p11-kit command, which
    is similar to "list-modules" but only prints tokens.  This would make
    scripting tasks easier.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 doc/manual/p11-kit.xml      |  19 +++++
 p11-kit/Makefile.am         |   4 +
 p11-kit/list-tokens.c       | 196 ++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/lists.c             |   9 +-
 p11-kit/meson.build         |   5 ++
 p11-kit/p11-kit.c           |   4 +
 p11-kit/test-list-tokens.sh |  82 ++++++++++++++++++
 7 files changed, 317 insertions(+), 2 deletions(-)

commit 64e5fe3457b9d69ef8bec6de58de7e8dd5b4f056
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-10-01

    lists: Refactor iteration and printing logic of modules and tokens
    
    This splits the logic to iterate over modules and tokens and print the
    details into two functions: the iteration and printing of CK_INFO and
    CK_TOKEN_INFO structures, so that the printing
    function (print_token_info) can be used for `p11-kit list-tokens`.
    
    This also makes slot listing more flexible to allow more than 256
    slots.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/lists.c | 204 ++++++++++++++++++++++++++++++++++++--------------------
 1 file changed, 133 insertions(+), 71 deletions(-)

commit daabb9f2f6e2443e4ce3155ac75341c924175b50
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-21

    Fix meson warnings
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/meson.build |  2 +-
 doc/manual/meson.build      |  2 +-
 meson.build                 | 14 ++++++++++----
 3 files changed, 12 insertions(+), 6 deletions(-)

commit 6bb52b48c77758dbe8b09d15e8d79f4578cfda99
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-10-03

    Add more tests for profile commands
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/test-profiles.sh | 140 +++++++++++++++++++++++++++++++++++++++++++++--
 1 file changed, 135 insertions(+), 5 deletions(-)

commit c507a5d911f17e1c64c9aeca93b8a45410a61d92
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-10-03

    Add/delete-profile should fail if there is no matching token
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/delete-profile.c | 89 ++++++++++++++++++++++++++++++++++++-----------
 p11-kit/list-profiles.c  | 90 +++++++++++++++++++++++++++++++++++++++++-------
 2 files changed, 145 insertions(+), 34 deletions(-)

commit aedbab2c0f9b23dcc8780ba0f4b189d9b24532b4
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-10-02

    Add CI test for building without ASN.1
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 .github/actions/basic-autotools/action.yaml |  6 ++++++
 .github/workflows/test.yaml                 | 27 +++++++++++++++++++++++++++
 Makefile.am                                 |  1 +
 3 files changed, 34 insertions(+)

commit 1392bfcf4e76de01401f15c29551b9fdfc0263f3
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-22

    Add tests for p11-kit profile commands
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/persist.c                                 |   3 +
 p11-kit/Makefile.am                              |  55 ++--
 p11-kit/fixtures/package-modules/thirteen.module |   4 +
 p11-kit/meson.build                              |  13 +-
 p11-kit/mock-module-ep11.c                       | 211 ++++++++++++++++
 p11-kit/mock-module-ep9.c                        |   1 -
 p11-kit/test-lists.sh                            |  17 ++
 p11-kit/test-objects.sh                          |  52 +---
 p11-kit/test-profiles.sh                         | 309 ++++++++++++++++++++++-
 trust/Makefile.am                                |   6 +-
 10 files changed, 595 insertions(+), 76 deletions(-)

commit 85a0ac8c67f873771ea7d48e625fbcf044601ae2
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-22

    Move persist files to Common subdirectory
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/Makefile.am          | 2 ++
 common/meson.build          | 1 +
 {trust => common}/persist.c | 0
 {trust => common}/persist.h | 0
 {trust => common}/types.h   | 0
 po/POTFILES.in              | 2 +-
 trust/Makefile.am           | 3 ---
 trust/meson.build           | 2 --
 8 files changed, 4 insertions(+), 6 deletions(-)

commit f7a89e5cfe36f642a3f6004e29fd1160933c8f08
Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   2023-09-22

    list-mechanisms: initial implementation
    
    Resolves: #563
    Signed-off-by: Alexander Sosedkin <asosedkin@redhat.com>

 bash-completion/p11-kit         |   2 +-
 doc/manual/p11-kit.xml          |  16 +++
 p11-kit/Makefile.am             |   4 +
 p11-kit/list-mechanisms.c       | 284 ++++++++++++++++++++++++++++++++++++++++
 p11-kit/meson.build             |   5 +
 p11-kit/p11-kit.c               |   4 +
 p11-kit/test-list-mechanisms.sh |  65 +++++++++
 po/POTFILES.in                  |   1 +
 8 files changed, 380 insertions(+), 1 deletion(-)

commit 7d659c1ac7f6153381af042f8fa26485b208483a
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-09-25

    .dir-locals.el: Update indentation settings for C and shell-script
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .dir-locals.el | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 5b13c85909eef2b38859b7fb5a2abc0e33107280
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-26

    Test for nonexistent tokens in p11-kit commands
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/test-init.sh.in   |  4 ++--
 p11-kit/test-objects.sh  | 35 ++++++++++++++++++++++++++++++++++-
 p11-kit/test-profiles.sh | 19 ++++++++++++++++++-
 3 files changed, 54 insertions(+), 4 deletions(-)

commit 202c1c143620fea5dfecd5fa721aef7a8656142b
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-22

    p11-kit tool: make "no matching object/token" error user friendly
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/add-profile.c      | 5 ++++-
 p11-kit/delete-object.c    | 5 ++++-
 p11-kit/generate-keypair.c | 5 ++++-
 3 files changed, 12 insertions(+), 3 deletions(-)

commit 2d697bfa2903d4f11c56b5aa44e6cdf8c040d944
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-22

    Don't check for slot == 0 as 0 is a valid slot ID
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/add-profile.c      | 5 -----
 p11-kit/generate-keypair.c | 5 -----
 2 files changed, 10 deletions(-)

commit 0b280a0e9ca3b2c6b6738f85a944ee57b9179ed0
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-09-21

    export-object: Recover public key from algorithm specific attributes
    
    Some tokens such as SoftHSMv2 omits CKA_PUBLIC_KEY_INFO when it can be
    derived from algorithm specific attributes, such as CKA_MODULUS and
    CKA_PUBLIC_EXPONENT for RSA.  This adds support for it if libtasn1 is
    available at compile time.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/oid.h                                       |   3 +
 common/pkix.asn                                    |   4 +
 p11-kit/Makefile.am                                |  23 +-
 p11-kit/export-object.c                            | 421 ++++++++++++++++++---
 p11-kit/fixtures/package-modules/twelve.module     |   4 +
 .../fixtures/package-modules/win32/twelve.module   |   4 +
 p11-kit/meson.build                                |  13 +-
 p11-kit/mock-module-ep10.c                         | 194 ++++++++++
 p11-kit/test-export-public.sh                      |  90 +++++
 p11-kit/test-lists.sh                              |  17 +
 p11-kit/test-objects.sh                            |  35 +-
 11 files changed, 749 insertions(+), 59 deletions(-)

commit d8cc241187775e18de86caf446e9160299e6f157
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-09-21

    build: Move common files for handling ASN.1 to common
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 Makefile.am                   |  1 +
 common/Makefile.am            | 47 +++++++++++++++++++++++++++++++
 {trust => common}/asn1.c      |  0
 {trust => common}/asn1.h      |  0
 {trust => common}/basic.asn   |  0
 common/meson.build            | 64 +++++++++++++++++++++++++++++++++++++++++++
 {trust => common}/oid.c       |  0
 {trust => common}/oid.h       |  0
 {trust => common}/openssl.asn |  0
 {trust => common}/pkix.asn    |  0
 {trust => common}/test-asn1.c |  1 -
 {trust => common}/test-oid.c  |  0
 meson.build                   |  2 ++
 trust/Makefile.am             | 32 ++--------------------
 trust/meson.build             | 27 ++----------------
 15 files changed, 119 insertions(+), 55 deletions(-)

commit e8872bfdc4b12735bbc0433a59fc0a7ddfd68bbb
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-21

    list-objects: nicer printing of flags
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/list-objects.c    | 39 +++++++++++++++++++++++++--------------
 p11-kit/mock-module-ep9.c |  4 ++++
 p11-kit/test-objects.sh   | 16 ++++++++--------
 3 files changed, 37 insertions(+), 22 deletions(-)

commit 4d33a6267a8f646ed08ee066afe579036341b8ed
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-21

    Add missing copyable and destroyable flags into the constants
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/constants.c | 2 ++
 1 file changed, 2 insertions(+)

commit 231878de9d8463b55a935e0c55f5f1108196e665
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-20

    Use only token URI as profiles arent storage objects
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/delete-profile.c | 2 +-
 p11-kit/list-profiles.c  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 42e93d7dca2885ba2da3c53daf70845466cf4f94
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-19

    delete-object: remove only first match on a token
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/delete-object.c | 14 ++++++++++----
 1 file changed, 10 insertions(+), 4 deletions(-)

commit f1b7d0ee6c8ecb827164578ef9fba5b667936e97
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-19

    delete-profile: match only a single token
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/delete-profile.c | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit 691235df5b41c0144a27649627e7a3e7c5bd77bb
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-19

    Allow login in list-profiles and delete-profiles commands
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/delete-profile.c | 2 +-
 p11-kit/list-profiles.c  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 0c51f30b8d00cd79ededf6d1e3f0baf98a924281
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-18

    Rework add-profile
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/add-profile.c | 114 ++++++++++++++++++++++++++++----------------------
 1 file changed, 63 insertions(+), 51 deletions(-)

commit 42b1025e67d318cc57aff2d8169e6168ef29a085
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-18

    Fix add-profile command to create token objects
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/add-profile.c | 2 ++
 1 file changed, 2 insertions(+)

commit 0a11e88cd61a551bf5ea5028aa0b0de4cd1c7445
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-18

    Small error message fixups
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/add-profile.c      | 8 ++++----
 p11-kit/delete-object.c    | 4 ++--
 p11-kit/delete-profile.c   | 8 ++++----
 p11-kit/export-object.c    | 4 ++--
 p11-kit/generate-keypair.c | 4 ++--
 p11-kit/list-objects.c     | 6 +++---
 p11-kit/list-profiles.c    | 7 +++----
 7 files changed, 20 insertions(+), 21 deletions(-)

commit 79fe36c8b2d8880a4fbde4cad0c3781d0f3917c4
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-09-18

    list-modules: Do not embed module-name and module-path in URL
    
    module-name and module-path are query attributes, which are to modify
    the default settings (RFC 7512 section 2.4).  As p11-kit manages the
    default configuration, it shouldn't print them as part of the token
    URL.  This instead prints the absolute path of each module in a
    separate field of the output.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/print.c        |   4 +-
 p11-kit/Makefile.am   |   2 +
 p11-kit/lists.c       |  33 ++++++++--------
 p11-kit/meson.build   |   4 ++
 p11-kit/test-lists.sh | 105 ++++++++++++++++++++++++++++++++++++++++++++++++++
 5 files changed, 128 insertions(+), 20 deletions(-)

commit 6d0e5564f6ca1d128591d812b094ba16d6e23c2d
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-09-18

    tests: Check exit status of p11-kit commands in shell-script tests
    
    As we no longer call `set -e`, exit status of each command invocation
    should be checked manually.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/test-objects.sh  | 28 +++++++++++++++++++++-------
 p11-kit/test-profiles.sh |  4 +++-
 2 files changed, 24 insertions(+), 8 deletions(-)

commit ca5ed350a48013fbd7de32d28ce63a34d9d18276
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-15

    Add test for p11-kit generate-keypair command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/test-objects.sh | 15 ++++++++++++++-
 1 file changed, 14 insertions(+), 1 deletion(-)

commit ef0bfeac6dedfacc80fa97371b727efd0a1a588b
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-04

    Add command to generate keypair on a PKCS#11 token
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/p11-kit    |   2 +-
 common/compat.c            |  10 +
 common/compat.h            |  13 +-
 doc/manual/p11-kit.xml     |  41 ++++
 p11-kit/Makefile.am        |   3 +
 p11-kit/generate-keypair.c | 457 +++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/meson.build        |   5 +-
 p11-kit/p11-kit.c          |  44 +++--
 po/POTFILES.in             |   1 +
 9 files changed, 549 insertions(+), 27 deletions(-)

commit d85df9e2bd1c3c907e67b5cf276e6b724be933fd
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-11

    Prevent printing empty date in list-objects
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/list-objects.c | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 65b2e473e1922d0faabb4c58830153573907cdcd
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-09-14

    tests: Port shell-script tests to using test-init.sh
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/test-messages.sh |  43 ++++++++------
 p11-kit/test-objects.sh  | 146 ++++++++++++++++++++++-------------------------
 p11-kit/test-profiles.sh |  40 +++++++------
 p11-kit/test-server.sh   | 122 +++++++++++++++++++--------------------
 4 files changed, 176 insertions(+), 175 deletions(-)

commit ef2e9fd46ccd0d7895359f02149657236eb12e7d
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-09-14

    build: Move test-init.sh from trust to common
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/meson.build                | 17 +++++++++++++++++
 {trust => common}/test-init.sh.in |  0
 configure.ac                      |  2 +-
 trust/Makefile.am                 |  4 ++--
 trust/test-extract.sh             |  7 ++++++-
 trust/test-trust.sh               |  7 ++++++-
 6 files changed, 32 insertions(+), 5 deletions(-)

commit 70b7ee8372fec89e1faea09fd673c3f4c6cb3a1d
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-01

    Add test for exporting public key
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/mock-module-ep9.c | 121 ++++++++++++++++++++++++++++------------------
 p11-kit/test-objects.sh   |  62 +++++++++++++++++-------
 2 files changed, 119 insertions(+), 64 deletions(-)

commit a16d77a075a9f9222ff55fac3ccac0a945776898
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-04

    x
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/export-object.c | 12 +++++-------
 1 file changed, 5 insertions(+), 7 deletions(-)

commit d035c8c2f9821abb0731ab4c81e6589da9952c23
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-09-01

    Add ability to export public keys into export-object command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/export-object.c | 24 ++++++++++++++++--------
 1 file changed, 16 insertions(+), 8 deletions(-)

commit e732f987851a024d22d7369895ba7bbb0ae11b14
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-09-02

    proxy: Generate wrappers with script
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .gitignore                            |    1 +
 p11-kit/Makefile.am                   |   23 +-
 p11-kit/gen-wrappers.py               |   32 +-
 p11-kit/meson.build                   |   12 +
 p11-kit/proxy.c                       | 1517 +--------------------------------
 p11-kit/templates/proxy-excludes.list |   14 +
 p11-kit/templates/proxy-wrappers.py   |  100 +++
 7 files changed, 175 insertions(+), 1524 deletions(-)

commit 81bed3ddc5c3c740cee93cbb35282f56457e53e4
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-09-02

    pkcs11-json: Update git submodule
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 subprojects/pkcs11-json | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 30c302ac6d7b86e0d294b01aeceeaf052bcb99f6
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-08-31

    p11-kit list-objects: Use p11_attrs to access attributes by name
    
    This way we don't need to maintain the order of attributes as a magic
    number.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/list-objects.c | 105 ++++++++++++++++++++++++-------------------------
 1 file changed, 51 insertions(+), 54 deletions(-)

commit ecdc85302717d0f6f4f3c8d2a569089f9a7eeb52
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-08-31

    p11-kit list-objects: Use p11_buffer to safely allocate memory
    
    This makes use of p11_buffer to safely allocate buffer for attribute
    retrieval, taking into account of integer overflow and terminating NUL
    byte.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/list-objects.c | 16 ++++++++++------
 1 file changed, 10 insertions(+), 6 deletions(-)

commit 11394d91ec05ff63f5f7201bb9c2098d707fe4e4
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-08-29

    Add test for export-object command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/mock.h             |  1 +
 p11-kit/mock-module-ep9.c | 51 +++++++++++++++++++++++++++++++++++
 p11-kit/test-objects.sh   | 69 ++++++++++++++++++++++++++++++++++++-----------
 3 files changed, 106 insertions(+), 15 deletions(-)

commit 7726337b8b9779ac21d1b842c0cf2dd3f2f38897
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-08-09

    Add command to export objects matching PKCS#11 URI
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/p11-kit |   2 +-
 doc/manual/p11-kit.xml  |  17 ++++
 p11-kit/Makefile.am     |   2 +
 p11-kit/export-object.c | 242 ++++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/meson.build     |   1 +
 p11-kit/p11-kit.c       |   4 +
 po/POTFILES.in          |   1 +
 7 files changed, 268 insertions(+), 1 deletion(-)

commit b4d4fc4b3dd97dd160e8a8439bb4af25b8cdcff7
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-08-25

    Move pem.h and base64.h to common subdirectory
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/Makefile.am         | 2 ++
 {trust => common}/base64.c | 0
 {trust => common}/base64.h | 0
 common/meson.build         | 2 ++
 {trust => common}/pem.c    | 0
 {trust => common}/pem.h    | 0
 trust/Makefile.am          | 2 --
 trust/meson.build          | 2 --
 8 files changed, 4 insertions(+), 4 deletions(-)

commit a3549f82c8769f41a7cee8f2198354939e28c05c
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-08-29

    Dont pass NULL to p11_kit_modules_finalize/release
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/add-profile.c    | 4 ++--
 p11-kit/delete-object.c  | 4 ++--
 p11-kit/delete-profile.c | 4 ++--
 p11-kit/list-objects.c   | 4 ++--
 p11-kit/list-profiles.c  | 4 ++--
 5 files changed, 10 insertions(+), 10 deletions(-)

commit 93f1ccff3c91557ae6c523729e75cef69548c6e1
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-08-29

    Add test for list-objects command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/Makefile.am     |   2 +
 p11-kit/meson.build     |   4 ++
 p11-kit/test-objects.sh | 149 ++++++++++++++++++++++++++++++++++++++++++++++++
 3 files changed, 155 insertions(+)

commit 602c9040afe136af2b14743b210bea4ab33c30f8
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-08-29

    Print URI for storage objects in list-objects command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/list-objects.c | 120 +++++++++++++++++++++++++++++++++++++++++++++----
 1 file changed, 112 insertions(+), 8 deletions(-)

commit 585d6af8088a4d40ffc2f2c25c9a840b7e65eede
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-08-28

    Allow all types of URIs to be used in p11-kit commands
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/delete-object.c  | 2 +-
 p11-kit/delete-profile.c | 2 +-
 p11-kit/list-objects.c   | 2 +-
 p11-kit/list-profiles.c  | 2 +-
 4 files changed, 4 insertions(+), 4 deletions(-)

commit 9ff72077b8baee36c44dcbf0d6286c167c1d898b
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-08-29

    Update pkcs11-json submodule
    
    This fixes the issue when running meson setup with "castxml"
    installed:
    
      Executing subproject pkcs11-json
    
      pkcs11-json| Project name: pkcs11-json
      pkcs11-json| Project version: undefined
      pkcs11-json| Program castxml found: YES (/usr/bin/castxml)
    
      subprojects/pkcs11-json/meson.build:6:2: ERROR: Unknown variable "pkcs11_json_input".
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 meson.build             | 3 ++-
 subprojects/pkcs11-json | 2 +-
 2 files changed, 3 insertions(+), 2 deletions(-)

commit 6b7ffded7e20d39de1bb61fbfc4fb4731e9e8d74
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-08-24

    pkcs11-json: Make use of Meson subprojects feature
    
    This moves the pkcs11-json submodule under "subprojects", following
    the Meson subprojects convention.  This allows the submodule to be
    automatically initialized when running meson setup.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .gitmodules             |  2 +-
 Makefile.am             |  4 ++--
 meson.build             |  4 +++-
 p11-kit/Makefile.am     | 16 ++++++++--------
 pkcs11-json             |  1 -
 subprojects/pkcs11-json |  1 +
 6 files changed, 15 insertions(+), 13 deletions(-)

commit 92055a93d59d72c0c65baf2e85520a408ae884bf
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-08-12

    virtual: Factor out code generation templates
    
    This makes the code generation script more generic by factoring out
    templates into separate files.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .gitignore                              |   2 +
 configure.ac                            |   2 +-
 p11-kit/Makefile.am                     |  51 +++--
 p11-kit/gen-fixed-closures.py           |  43 ++++
 p11-kit/gen-virtual.py                  | 363 --------------------------------
 p11-kit/gen-wrappers.py                 | 145 +++++++++++++
 p11-kit/meson.build                     |  54 +++--
 p11-kit/templates/base-wrappers.py      |  40 ++++
 p11-kit/templates/binding-wrappers.py   |  29 +++
 p11-kit/templates/fixed-wrappers.py     | 117 ++++++++++
 p11-kit/templates/stack-wrappers.py     |  29 +++
 p11-kit/templates/virtual-excludes.list |   5 +
 p11-kit/virtual.c                       |   3 +-
 13 files changed, 483 insertions(+), 400 deletions(-)

commit b6411d7a62c1d228042ccf663487253eea4cd84b
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-08-14

    common: Avoid naming clash on MinGW
    
    The symbol "interface" is defined differently in a header included by
    default on MinGW, which prevents the use of it in a function signature
    in pkcs11.h.  To mitigate that, this renames it to "interface_".
    
    In the source there are more places where "interface" is used, though
    it shouldn't be a problem as WIN32_LEAN_AND_MEAN is set in compat.h.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/pkcs11.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 91bec95e9ddbf9ba89dce13513e939bebd92ffce
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-08-02

    virtual: Auto-generate boilerplate functions from JSON
    
    To avoid a lot of code repetitions in p11-kit/virtual.c, this
    introduces a mechanism to generate those from pkcs11.h, through a JSON
    based intermediate data format.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .github/workflows/codeql.yml |    2 +
 .github/workflows/test.yaml  |   18 +
 .gitignore                   |    2 +-
 .gitmodules                  |    3 +
 Makefile.am                  |    6 +-
 configure.ac                 |    2 +
 meson.build                  |    7 +
 p11-kit/Makefile.am          |   55 +-
 p11-kit/gen-virtual-fixed.sh |   28 -
 p11-kit/gen-virtual.py       |  363 +++++
 p11-kit/meson.build          |   38 +-
 p11-kit/test-managed.c       |    1 -
 p11-kit/virtual-fixed.h      | 1600 ------------------
 p11-kit/virtual.c            | 3666 +-----------------------------------------
 pkcs11-json                  |    1 +
 15 files changed, 520 insertions(+), 5272 deletions(-)

commit f88faf99b32fb04b6810ae347fecdbfc59ddc825
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-08-01

    Add command to delete objects matching PKCS#11 URI
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/p11-kit |   2 +-
 doc/manual/p11-kit.xml  |  16 +++++
 p11-kit/Makefile.am     |   2 +
 p11-kit/delete-object.c | 160 ++++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/meson.build     |   1 +
 p11-kit/p11-kit.c       |   4 ++
 po/POTFILES.in          |   1 +
 7 files changed, 185 insertions(+), 1 deletion(-)

commit d1d4b0ac316a27c739ff91e6c4153f1154e96e5a
Author: Xi Ruoyao <xry111@xry111.site>
Date:   2023-07-27

    Fix probing of C_GetInterface
    
    `p11_dl_symbol (dl, "C_GetInterface")` uses dlsym() to find
    C_GetInterface in the loaded pkcs11 module.  For legacy (pre-3.0) pkcs11
    modules, C_GetInterface is not defined in the module.  But according to
    the documentation of dlsym():
    
        The search performed by dlsym() is breadth first through the
        dependency tree of these shared objects.
    
    So if a pkcs11 module links to libp11-kit.so, the C_GetInterface
    implementation in libp11-kit.so itself will be found.  This
    C_GetInterface will return the metadata of p11-kit-proxy.so, causing
    "Refuse to load the p11-kit-proxy.so as a registered module".
    
    To solve the issue, if p11_dl_symbol() returns the C_GetInterface in
    libp11-kit.so itself, we should ignore it and continue trying
    C_GetFunctionList.

 p11-kit/modules.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit 4d58e40b49d40ac663c77ec694d9636ab6d99943
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-07-22

    list-objects: Print CKA_ID in hexadecimal format
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/hex.c           |  4 ++++
 common/hex.h           |  5 ++++-
 p11-kit/list-objects.c | 23 ++++++++++++++++++++++-
 3 files changed, 30 insertions(+), 2 deletions(-)

commit bbbbd4ba5c9a411229cf4c6d064231ae3d9f18a1
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-07-22

    hex: Factor out hex-encoding logic to a separate file
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/Makefile.am |  1 +
 common/hex.c       | 62 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 common/hex.h       | 41 ++++++++++++++++++++++++++++++++++++
 common/meson.build |  1 +
 p11-kit/lists.c    | 28 +-----------------------
 5 files changed, 106 insertions(+), 27 deletions(-)

commit d98392beb309570c228090866d77e500bc9e30db
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-07-13

    Add command to list objects of a token
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/p11-kit |   2 +-
 common/constants.c      |  11 ++
 common/constants.h      |   2 +
 common/test-constants.c |   1 +
 doc/manual/p11-kit.xml  |  17 +++
 p11-kit/Makefile.am     |   2 +
 p11-kit/iter.c          |  17 +++
 p11-kit/iter.h          |   1 +
 p11-kit/list-objects.c  | 309 ++++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/meson.build     |   1 +
 p11-kit/p11-kit.c       |   4 +
 po/POTFILES.in          |   1 +
 12 files changed, 367 insertions(+), 1 deletion(-)

commit b13629f365f77a633f112c7e02c75b777d378be4
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-07-18

    Print URIs for modules and tokens in list-modules command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/lists.c | 39 +++++++++++++++++++++++++++++++++++----
 1 file changed, 35 insertions(+), 4 deletions(-)

commit 1db2915466d45b2489120bdcefaf320b1e8e8fdd
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-07-17

    Fix the usage text for list-modules command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/lists.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7aa6251bf4ce36d027d53c9c96bb05f90ef7eb5b
Author: Adam Sampson <ats@offog.org>
Date:   2023-07-02

    Define _GNU_SOURCE when testing for strerror_r
    
    The Meson check for GNU/XSI strerror_r didn't inherit the project
    options that include _GNU_SOURCE (unlike the autoconf version), so the
    result didn't match how the code that uses it will be compiled. Add
    _GNU_SOURCE explicitly as with the following checks.
    
    Signed-off-by: Adam Sampson <ats@offog.org>

 meson.build | 1 +
 1 file changed, 1 insertion(+)

commit 3ba2c55dfdc8ff20de369f07f6c57d08718d3add
Author: Adam Sampson <ats@offog.org>
Date:   2023-07-02

    Check for GNU strerror_r using the compiler only
    
    The new test that was added to distinguish GNU/XSI strerror_r ran a
    compiled program, which doesn't work when cross-compiling. The only
    difference at compile time is that the GNU version returns char * and
    the XSI version returns int, so detect it by compiling a program that
    dereferences the return value.
    
    Signed-off-by: Adam Sampson <ats@offog.org>

 configure.ac | 19 +++++++------------
 meson.build  | 10 +++++-----
 2 files changed, 12 insertions(+), 17 deletions(-)

commit 76be1cfbf16277b2d607048c6899e633d4543527
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-29

    Add Zoltan Fridrichs OpenPGP key to README.md
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a8cce8bd8065bbf80bd47219f85f0cd9cf27dd0c
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-28

    Release 0.25.0
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 NEWS         | 22 ++++++++++++++++++++++
 configure.ac |  2 +-
 meson.build  |  2 +-
 3 files changed, 24 insertions(+), 2 deletions(-)

commit f992846c467f272c67dceb566bf13258a9bce054
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-28

    Suppress memory test warning
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/test-tests.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit 74e7f8278c44d37a085d53b7ef09edff897212a3
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-04-09

    client: Support PKCS#11 3.0
    
    This exports C_GetInterfaceList and C_GetInterface from the client
    module.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/client.c | 192 +++++++++++++++++++++++++++++++++++++++++++++----------
 1 file changed, 160 insertions(+), 32 deletions(-)

commit 8d9049b284690cae18c029ee7f7dbc3c3f3b2fe6
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-04-09

    proxy: Refactor get_interface_inlock
    
    This adds a minor refactoring to get_interface_inlock:
    - CK_RV for the return value instead of int
    - Use "goto cleanup" instead of a chain of "if (rv == CKR_OK)"
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/proxy.c | 101 +++++++++++++++++++++++++++++++++-----------------------
 1 file changed, 59 insertions(+), 42 deletions(-)

commit ccbe143d523fdbdabe4b163df0ca0a75ef9f3b72
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-22

    Handle both XSI and GNU versions of strerror_r
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/compat.c  | 61 ++++++++++++++++++++++++++++----------------------------
 common/compat.h  | 12 ++++-------
 common/debug.c   |  2 +-
 common/message.c |  2 +-
 configure.ac     | 20 ++++++++++++++++++-
 meson.build      | 20 ++++++++++++++++++-
 6 files changed, 74 insertions(+), 43 deletions(-)

commit 5b7977a37442782e09a7d51adb7f8b0eb8c80ec3
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-26

    Fix memory leak inside p11_kit_remote_serve_tokens
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/rpc-server.c | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit ff485b883c753651eb34a7811e2c26ba308733cf
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-27

    Allow overwriting files in CI Macos testcase
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 .github/workflows/test.yaml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 4d93a4363fdb2f54a84b5405a924b1e2726f07ca
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-27

    Suppress ASAN error when running p11tool in test-server.sh
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/test-server.sh | 10 ++++------
 1 file changed, 4 insertions(+), 6 deletions(-)

commit 7dbc2687364805ee6c2478fa69ecdfeb89648d61
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-20

    Remove travis configuration
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 .travis.yml                         | 35 -----------------------------
 .travis/autotools/after_failure.sh  |  3 ---
 .travis/autotools/after_success.sh  | 13 -----------
 .travis/autotools/before_install.sh |  9 --------
 .travis/autotools/install.sh        | 14 ------------
 .travis/autotools/script.sh         | 44 -------------------------------------
 .travis/cppcheck/after_failure.sh   |  3 ---
 .travis/cppcheck/before_install.sh  |  9 --------
 .travis/cppcheck/install.sh         | 14 ------------
 .travis/cppcheck/script.sh          |  3 ---
 .travis/freebsd/after_failure.sh    |  3 ---
 .travis/freebsd/before_install.sh   |  5 -----
 .travis/freebsd/script.sh           |  6 -----
 .travis/linux/after_failure.sh      |  3 ---
 .travis/linux/after_success.sh      | 11 ----------
 .travis/linux/before_install.sh     | 11 ----------
 .travis/linux/install.sh            | 14 ------------
 .travis/linux/script.sh             | 25 ---------------------
 .travis/osx/after_failure.sh        |  3 ---
 .travis/osx/before_install.sh       |  5 -----
 .travis/osx/script.sh               |  6 -----
 21 files changed, 239 deletions(-)

commit 8fbd5da6da944a2f2f7d5c08e7625c3c35dfbfe8
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-20

    Install gnutls-utils in CI
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 ci/Dockerfile | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a4cfb7be53e2dec082693609aecb48fe0af8bb20
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-20

    Add test for p11-kit-client.so
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/test-server.sh | 34 +++++++++++++++++++++++++++-------
 1 file changed, 27 insertions(+), 7 deletions(-)

commit d7c318845405fa7ea33154082b437e4a87ee3699
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-16

    Fix bug in base_C_MessageSignFinal
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/virtual.c | 2 ++
 1 file changed, 2 insertions(+)

commit cb531a61afc0e3c0f2174fa1bf026e993c76ea89
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-09

    Make the proxy_module extension in pkg-config .pc file adaptable
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 configure.ac            | 3 +++
 p11-kit/meson.build     | 2 +-
 p11-kit/p11-kit-1.pc.in | 2 +-
 3 files changed, 5 insertions(+), 2 deletions(-)

commit 51ea28418c0bf2a11e2a6f226b77d17b2ba25573
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-08

    Tests: add space padding to label in InitToken
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/mock.c         | 2 +-
 p11-kit/test-filter.c | 8 ++++----
 p11-kit/test-mock.c   | 8 ++++----
 3 files changed, 9 insertions(+), 9 deletions(-)

commit b1eebfd6aa63fb98f362bd94b9d07dcefb2b3104
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-08

    log_C_InitToken: add support to print space padded strings
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/log.c | 19 ++++++++++---------
 1 file changed, 10 insertions(+), 9 deletions(-)

commit b2dd8d5c73dab8e0f074b32d7bb393817964fb1d
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-01

    RPC: add C_InitToken2 that uses space padded label
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 configure.ac          |  2 +-
 meson_options.txt     |  2 +-
 p11-kit/rpc-client.c  | 47 +++++++++++++++++++++++++++++++++++------
 p11-kit/rpc-message.h |  4 ++++
 p11-kit/rpc-server.c  | 58 +++++++++++++++++++++++++++++++++++++++++++++++++--
 5 files changed, 103 insertions(+), 10 deletions(-)

commit 84869381c80ecb258ffdabf214faac71eb584577
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-01

    Fix hard-coded TRUST_SO path in trust/frob-multi-init.c
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 trust/frob-multi-init.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 98a114703e665520bb439919faaac4cdb0b39d03
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-01

    Set stdin and stdout to binary mode on Windows
    
    Co-authored-by: bhuztez <bhuztez@gmail.com>
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/remote.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit 1d248b48648aca649fb33c877fa0623b75ce459f
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-06-01

    Small format fix in p11-kit/modules.c
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/modules.c | 31 ++++++++++---------------------
 1 file changed, 10 insertions(+), 21 deletions(-)

commit 71dcd6735c4154ca9dfb18c52405e5f611276e0e
Author: Nathan Barrett-Morrison <nathan.morrison@timesys.com>
Date:   2022-11-07

    Add in the ability to dynamically adjust module and configuration paths at run-time via system environmental exports
    
    Background: While trying to integrate PKCS11+HSM into a build system (Yocto Project), we wanted the build system to be able to use the HSM directly.  However, The Yocto Project creates a sandboxed environment for each package which uses p11-kit during compilation.  This means that the p11-kit modules and configurations cannot be found from within these sandboxed directories, as their paths are non-determinable at compile time.  OpenSSL appears to use OPENSSL_CONF for this sort of dynamic configuration, so I've followed their lead and incorporated a similar p11_kit_getenv() method.

 configure.ac      |  9 +++++++++
 meson.build       |  5 +++++
 meson_options.txt |  4 ++++
 p11-kit/modules.c | 48 ++++++++++++++++++++++++++++++++++++++++++++++--
 4 files changed, 64 insertions(+), 2 deletions(-)

commit 8a305a06a2fee8ab4f04c97ed56031d196b45e35
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-05-31

    print: New interface p11_list_printer
    
    This introduces a new type p11_list_printer, which abstracts a
    pretty-printer for nested key value pairs.  It maintains the context
    of the current printing operation, including indentation and header
    colors, so we don't need to spell out the actual presentation
    in the call sites.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 common/print.c  | 109 ++++++++++++++++++++++++++++++++++++++++++++++++--------
 common/print.h  |  47 +++++++++++++++---------
 p11-kit/lists.c |  53 ++++++++++++++++-----------
 trust/list.c    |  19 +++++-----
 4 files changed, 170 insertions(+), 58 deletions(-)

commit 1b14bfa49c1da1f6c6037e6c60f92a76d92a2464
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-05-24

    Add colors to p11-kit command-line tools
    
    - adds URL highlighting to trust list command
    - adds colors to trust list command
    - adds colors to p11-kit list-modules command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/Makefile.am   |   1 +
 common/meson.build   |   1 +
 common/print.c       | 109 +++++++++++++++++++++++++++++++++++++++++++++++++++
 common/print.h       |  77 ++++++++++++++++++++++++++++++++++++
 p11-kit/lists.c      |  41 +++++++++----------
 trust/check-format.c |  16 +++-----
 trust/list.c         |  18 +++++----
 7 files changed, 222 insertions(+), 41 deletions(-)

commit 2fbe188c53737715fbda9d0e595141b67338cc24
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-05-07

    Add command to add profiles to a token
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/p11-kit |   2 +-
 doc/manual/p11-kit.xml  |  16 +++
 p11-kit/Makefile.am     |   2 +
 p11-kit/add-profile.c   | 259 ++++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/meson.build     |   1 +
 p11-kit/p11-kit.c       |   4 +
 po/POTFILES.in          |   1 +
 7 files changed, 284 insertions(+), 1 deletion(-)

commit 6be43acfeb4a1dffdbb134e1a1c869437c4189d5
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-05-23

    Fix profile argument parsing in delete-profile
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/delete-profile.c | 11 ++++++-----
 1 file changed, 6 insertions(+), 5 deletions(-)

commit 51399b7e80223a9f3921d713fd1c6626f34adbbc
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-05-23

    Test p11_constant_profiles
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/test-constants.c | 1 +
 1 file changed, 1 insertion(+)

commit 6f6c04d6607d4cd5dd0eb0677a36a55ff6131b4e
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-05-07

    libffi: Fix handling of pulCount parameter of C_GetInterfaceList
    
    When C_GetInterfaceList is called with NULL pInterfaceList, It doesn't
    make any sense to check the content of pulCount.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/virtual.c | 5 +----
 1 file changed, 1 insertion(+), 4 deletions(-)

commit e5a62d894647a21a9a93fc82c2daa64f5b22e4a4
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-05-04

    Add command to delete profiles from a token
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/p11-kit  |   2 +-
 doc/manual/p11-kit.xml   |  17 ++++
 p11-kit/Makefile.am      |   2 +
 p11-kit/delete-profile.c | 211 +++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/meson.build      |   1 +
 p11-kit/p11-kit.c        |   4 +
 po/POTFILES.in           |   1 +
 7 files changed, 237 insertions(+), 1 deletion(-)

commit 60a917f2192bcbdac7786a9db1845ec579e71df0
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-04-27

    Test the p11-kit list-profiles command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 .gitignore                                     |  1 +
 p11-kit/Makefile.am                            | 31 ++++++++++++-
 p11-kit/fixtures/package-modules/eleven.module |  4 ++
 p11-kit/meson.build                            | 15 +++++-
 p11-kit/mock-module-ep9.c                      | 63 ++++++++++++++++++++++++++
 p11-kit/test-profiles.sh                       | 30 ++++++++++++
 6 files changed, 141 insertions(+), 3 deletions(-)

commit 038b4d8a529863cd48e579b96e4f8a9de1113521
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-04-26

    Add command to list token profiles
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/p11-kit |   2 +-
 common/constants.c      |  10 +++
 common/constants.h      |   2 +
 doc/manual/p11-kit.xml  |  17 +++++
 p11-kit/Makefile.am     |   1 +
 p11-kit/list-profiles.c | 176 ++++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/meson.build     |   1 +
 p11-kit/p11-kit.c       |   4 ++
 po/POTFILES.in          |   1 +
 9 files changed, 213 insertions(+), 1 deletion(-)

commit 3f2c94f872fea556c1f33904d818bfa87acaa61b
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-04-30

    meson: Add missing libintl check
    
    On certain non-glibc systems, gettext functions are defined in a
    separate library (libintl, typically from GNU gettext).  Our autotools
    infrastructure has this check, though it was omitted during the
    porting to Meson.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/meson.build  | 4 ++--
 meson.build         | 7 +++++++
 p11-kit/meson.build | 4 ++--
 trust/meson.build   | 2 +-
 4 files changed, 12 insertions(+), 5 deletions(-)

commit e2bf7767075c83d948f9585cff4f2fe70d195e30
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-04-30

    .github/workflows: Use meson for macOS build
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .github/workflows/test.yaml | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 2eb8bb85e2b1cc50064b0a388df3108805b3f424
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-04-29

    .github/actions: Use wrapper script for build environment setup
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .github/actions/basic-autotools/action.yaml | 42 +++++------------------------
 .github/actions/basic-meson/action.yaml     | 32 +++++++++-------------
 .github/workflows/test.yaml                 |  3 +++
 build/run-wrapper.sh                        | 17 ++++++++++++
 build/setup-wrapper.sh                      | 23 ++++++++++++++++
 5 files changed, 62 insertions(+), 55 deletions(-)

commit 9474b469311683188e80d3f05ddcb00d413f4283
Author: Clemens Lang <cllang@redhat.com>
Date:   2023-04-17

    conf: Remove unused variable
    
    This fixes a warning printed by clang on macOS:
    
    | ../p11-kit/conf.c:411:6: warning: variable 'count' set but not used [-Wunused-but-set-variable]
    |         int count = 0;
    |             ^
    
    Signed-off-by: Clemens Lang <cllang@redhat.com>

 p11-kit/conf.c | 2 --
 1 file changed, 2 deletions(-)

commit 8a4348e8468d08d992cb7d22a4d887d0191383f6
Author: Clemens Lang <cllang@redhat.com>
Date:   2023-04-17

    build: Use .so as module suffix on macOS
    
    macOS uses .so as filename extension for loadable modules. For some
    reason, meson does not use this by default, but uses .dylib. This
    inconsistency between the autoconf build system (which uses .so) and the
    meson build system caused the tests to fail, because the mock modules
    would not be found by the tests.
    
    This is a bug in meson, as loadable modules (filetype BUNDLE in otool
    -hv output) should have an .so extension on macOS. See [1,2] for
    discussion in meson.
    
    Port the same fix that was used by the GNOME developers in gtk [3,4] and
    glib-networking [5]. See also a similar fix in glib [6].
    
    [1]: https://github.com/mesonbuild/meson/issues/1160
    [2]: https://github.com/mesonbuild/meson/issues/3053
    [3]: https://gitlab.gnome.org/GNOME/gtk/-/issues/3645
    [4]: https://gitlab.gnome.org/GNOME/gtk/-/merge_requests/3162
    [5]: https://gitlab.gnome.org/GNOME/glib-networking/-/merge_requests/1
    [6]: https://gitlab.gnome.org/GNOME/glib/-/merge_requests/280
    
    Signed-off-by: Clemens Lang <cllang@redhat.com>

 p11-kit/meson.build | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 2bea671227e8ca1f643871ed5c986cadcd01f7b7
Author: Clemens Lang <cllang@redhat.com>
Date:   2023-04-17

    build: Fix linker errors on macOS
    
    This fixes a few linker errors on macOS due to an undefined
    p11_library_mutex symbol:
    
    | cc  -o p11-kit/p11-kit-server-testable p11-kit/p11-kit-server-testable.p/server.c.o -Wl,-dead_strip_dylibs -Wl,-headerpad_max_install_names -Wl,-undefined,error -Wl,-rpath,/opt/local/lib p11-kit/libp11-kit-testable.a common/libp11-library.a common/libp11-common.a common/libp11-tool.a /opt/local/lib/libffi.dylib
    | Undefined symbols for architecture x86_64:
    |   "_p11_library_mutex", referenced from:
    |       _p11_kit_be_quiet in libp11-kit-testable.a(util.c.o)
    |       _p11_kit_be_loud in libp11-kit-testable.a(util.c.o)
    |       _p11_kit_set_progname in libp11-kit-testable.a(util.c.o)
    | ld: symbol(s) not found for architecture x86_64
    
    Fix these by using meson's link_whole feature where required. Note that
    instead of declaring a sepearate dependency with link_whole, we could
    have used .as_link_whole() on the existing dependency object, but that
    would have required bumping the minimum meson version to 0.56. We
    decided not to do this for not for compatibility reasons.
    
    Signed-off-by: Clemens Lang <cllang@redhat.com>

 common/meson.build  |  3 +++
 p11-kit/meson.build | 21 ++++++++++++++++++---
 trust/meson.build   | 24 ++++++++++++++++++++++--
 3 files changed, 43 insertions(+), 5 deletions(-)

commit 8c19b2a37569faea62890bd893969b6ae352be7d
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-13

    .github/workflows/test.yaml: Exercise libffi closure usage
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 .github/workflows/test.yaml | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit f892ff6845a1150035f6c432c9b3b9f72c1ff663
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-13

    virtual: Fix libffi type signatures for PKCS#11 3.0 functions
    
    There were some mismatches between the type signatures of `binding_*`
    functions and the `BindingInfo` definitions, causing test failures
    when compiled without fixed closures.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/virtual.c | 45 +++++++++++++++++++++++++--------------------
 1 file changed, 25 insertions(+), 20 deletions(-)

commit 2037e70b0a728f4b142906507877b5789368bc7f
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-13

    build: Allow disabling fixed closures
    
    This allows the user to disable pre-generated closures, by setting the
    number of closures to 0 (i.e., `-Dclosures=0` with Meson or
    `--with-closures=0` with Autotools).
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 configure.ac        | 4 ++--
 meson.build         | 4 ++--
 p11-kit/meson.build | 2 +-
 3 files changed, 5 insertions(+), 5 deletions(-)

commit 36709702edf92f9baa9c043f55b2566f8ca2dd01
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-12

    tests: Fix mingw test failures
    
    This updates the module configuration files in the Windows fixture
    directory with Unix version.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/Makefile.am                                |  1 +
 .../fixtures/package-modules/win32/four-v3.module  |  5 +++++
 p11-kit/fixtures/package-modules/win32/four.module |  5 +++--
 p11-kit/fixtures/package-modules/win32/six.module  |  7 +++++++
 .../fixtures/system-modules/two-duplicate.module   |  2 +-
 p11-kit/fixtures/system-modules/win32/one.module   |  1 -
 .../system-modules/win32/two-duplicate.module      |  2 +-
 p11-kit/fixtures/user-modules/win32/one.module     |  4 +++-
 p11-kit/test-conf.c                                | 22 +++++++++++-----------
 9 files changed, 32 insertions(+), 17 deletions(-)

commit bffe7c2a1531973f649c045b6614b5f76c9259fb
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-12

    .github/actions/basic-meson: Skip test when built with scan-build
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 .github/actions/basic-meson/action.yaml | 1 +
 1 file changed, 1 insertion(+)

commit 563dcd1462a06a8604bd967058fe4b9bd994cf59
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-12

    .github/workflows/test.yaml: Fix typo in WINEPATH
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 .github/workflows/test.yaml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 81ace6551b10f8a00e0e0a48b58109f117de0dba
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-11

    .github/actions: Don't swallow error exit code when printing logs
    
    This preserves the exit code of the test run, around the log file
    inspection.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 .github/actions/basic-autotools/action.yaml | 5 +++++
 .github/actions/basic-meson/action.yaml     | 7 ++++++-
 2 files changed, 11 insertions(+), 1 deletion(-)

commit 49c1ec46a78e6d7661415e80c182c15a0c8335a6
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-12

    build: Pacify clang-analyzer warnings
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 common/test-compat.c | 6 ++++--
 common/test-tests.c  | 9 ++++++++-
 p11-kit/proxy.c      | 2 +-
 p11-kit/test-conf.c  | 6 ++++--
 p11-kit/test-proxy.c | 1 +
 trust/digest.c       | 4 ++++
 trust/index.c        | 3 +++
 trust/module.c       | 4 +++-
 trust/test-jks.c     | 2 ++
 9 files changed, 30 insertions(+), 7 deletions(-)

commit ce32cfdb140275ddc189ee27da426603b89c5485
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-12

    mock: Fix cancel operation with NULL mechanism to C_Message*Init
    
    Previously, when the mechanism parameter was NULL and the
    corresponding operation was not active, the code didn't return
    immediately and went on with the regular operation, which in turn
    resulted in a NULL pointer dereference.  Spotted by clang-analyzer.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 common/mock.c       | 74 +++++++++++++++++++++++++++++++----------------------
 common/pkcs11.h     |  1 +
 p11-kit/test-mock.c |  4 +--
 3 files changed, 46 insertions(+), 33 deletions(-)

commit 4af2309c265c81d0aee4f20ea9f4f47fd1e175a6
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-12

    virtual: Add missing return to binding_C_GetInterface*
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/virtual.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit cbfa5c8c5ac482aab8305fdc76de5d5a0b9969bc
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-12

    tests: Fix memleaks and use reallocarray if possible
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/test-mock.c    | 2 ++
 p11-kit/test-proxy3.c  | 3 ++-
 p11-kit/test-virtual.c | 3 ++-
 3 files changed, 6 insertions(+), 2 deletions(-)

commit b7b4a96ba23670e6e6b910aef0c1cbd9c26accdb
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-12

    tests: Skip tests using setuid'ed executable under ASan
    
    The test-compat and test-conf tests call out external executables with
    a setuid bit set, which doesn't work well under ASan.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 common/test-compat.c | 12 ++++++++++++
 p11-kit/test-conf.c  | 12 ++++++++++++
 2 files changed, 24 insertions(+)

commit bcd02f71b536effd9116efe2bfe971e6cfb24c35
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-12

    trust: Fix memleak in the enumerate command when loading extensions
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 trust/enumerate.c | 1 +
 1 file changed, 1 insertion(+)

commit 707cc0325232c574ca1d9ed2eeec0f5e01fc5549
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-10-12

    pkcs11.h: Add ChaCha20/Salsa20 and Poly1305 mechanisms
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/pkcs11.h | 54 ++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 54 insertions(+)

commit 0668d65951407808c349fd9ded9e21a079459068
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-04-09

    trust: Lower Cryptoki version from 3.0 to 2.40
    
    The trust module currently stays at Cryptoki version 2.40, while 3.0
    was advertised through the version field in CK_FUNCTION_LIST and
    C_GetInfo.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 trust/module.c | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 161444f36b81425501747e5533026e21b5834001
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-04-11

    Add bash-completion for check-format command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/trust | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 3680147da31e44900f578b49179bef9ddbf4537e
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-04-11

    Add bash-completion for print-config command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 bash-completion/p11-kit | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 29c5a123038ff91ed1584de79741b35ed34f659a
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-04-11

    Add documentation for print-config command
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 doc/manual/p11-kit.xml | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit eb6eeb68da6a48295cd4f68044e83d7111250eec
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-06

    compat: Provide stub isatty if it does not exist
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 common/compat.c      | 10 ++++++++++
 common/compat.h      | 10 ++++++++++
 configure.ac         |  1 +
 meson.build          |  1 +
 trust/check-format.c |  1 -
 5 files changed, 22 insertions(+), 1 deletion(-)

commit d86d022f805165b464d5809019ed4d4a24732c93
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-06

    lexer: Keep track of line numbers
    
    This adds the new field "line" to p11_lexer so any errors are printed
    with the line numbers where they happen.  Also make the header to use
    appropriate types for sizes and token types.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 common/lexer.c  | 19 +++++++++++++++----
 common/lexer.h  | 15 ++++++++-------
 trust/persist.c |  4 ++++
 3 files changed, 27 insertions(+), 11 deletions(-)

commit 1da4600354f0c375cc8352b3ef01f1ad81ee71a0
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-04-06

    trust: Use the same parser code for parsing and checking
    
    The trust check-format command used a dedicated parsing code for the
    .p11-kit format, which behaves differently from the original parsing
    code: sometimes it is stricter (e.g., PEM block), while other times it
    is not (e.g., constant names and OIDs). This makes it use the same
    single parser to align with the original behavior.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 trust/check-format.c | 386 +++++----------------------------------------------
 trust/persist.c      |  57 ++++++++
 trust/persist.h      |   7 +
 3 files changed, 95 insertions(+), 355 deletions(-)

commit 52f91915a7ec3cacb7921a6f66dfbe304a7f2404
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-04-02

    rpc: Do not use CRYPTOKI_GNU symbols in our code base
    
    These are only defined if CRYPTOKI_GNU is set by the applications.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/rpc-message.c | 26 +++++++++++++-------------
 1 file changed, 13 insertions(+), 13 deletions(-)

commit 1b58663a2b35f16d3856a370cb4e3cd61f15e1c1
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-04-02

    Add AES-GCM mechanism parameters for message-based encryption
    
    When used with C_MessageEncrypt and C_MessageDecrypt, CKM_AES_GCM
    takes different parameters than CK_GCM_PARAMS.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/pkcs11.h | 48 ++++++++++++++++++++++++++++++++++++++++++++----
 1 file changed, 44 insertions(+), 4 deletions(-)

commit 3b0a772e8b99f5c52417c3e31ed0db5dd092ec22
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-15

    Add check-format command to trust tool
    
    The trust check-format command serves to quickly check the validity of .p11-kit files
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 doc/manual/trust.xml |  24 +++
 po/POTFILES.in       |   1 +
 trust/Makefile.am    |   1 +
 trust/check-format.c | 512 +++++++++++++++++++++++++++++++++++++++++++++++++++
 trust/check-format.h |  43 +++++
 trust/meson.build    |   1 +
 trust/trust.c        |   2 +
 7 files changed, 584 insertions(+)

commit 439c2e84899f7ab4d852ea409b6a39f313b94b0c
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-29

    Add test for profile objects
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/test-iter.c | 68 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 68 insertions(+)

commit d574df11e2127b38f4527b548974f6ba25918d2c
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-29

    Add support for profile objects in mock
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/mock.c   | 23 +++++++++++++++++++++++
 common/mock.h   |  2 ++
 common/pkcs11.h | 13 ++++++++++++-
 3 files changed, 37 insertions(+), 1 deletion(-)

commit 8b98b0d524c633ba85f9ddcd4c2291c7050f9187
Author: Benjamin Herrenschmidt <benh@kernel.crashing.org>
Date:   2023-03-29

    server: Fix umask setting when --group is specified
    
    p11-kit server previously set umask(066) unconditionally before chown
    and that resulted in removing group read/write bits, even if --group
    is specified.  This fixes the logic to respect --group and also allows
    it to be specified without --user.
    
    Originally reported in:
    https://lists.freedesktop.org/archives/p11-glue/2023-January/000725.html
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/server.c | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit 66e8c9edcf57f84e27d302e127a59dfaa662fad5
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-21

    Add pkcs#11 3.0 tests to transport tests
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/Makefile.am           |   6 +
 p11-kit/meson.build           |   3 +-
 p11-kit/test-transport-base.c | 449 ++++++++++++++++++++++++++++++++++++++++++
 p11-kit/test-transport.c      | 419 +--------------------------------------
 p11-kit/test-transport3.c     |  45 +++++
 5 files changed, 507 insertions(+), 415 deletions(-)

commit 7470b5616130fccfe18271e7b48c7829ad1012d7
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-22

    Separate low-level message handling tests from test-rpc
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/Makefile.am        |   4 +
 p11-kit/meson.build        |   1 +
 p11-kit/test-rpc-message.c | 855 +++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/test-rpc.c         | 656 ----------------------------------
 4 files changed, 860 insertions(+), 656 deletions(-)

commit 6fd1eca04dda7bc147d24eeb033b44edd508bacd
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-21

    Add pkcs#11 3.0 tests for rpc module
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/fixtures/package-modules/four-v3.module |   2 +-
 p11-kit/fixtures/package-modules/four.module    |   2 +-
 p11-kit/test-rpc.c                              | 133 ++++++++++++++----------
 3 files changed, 79 insertions(+), 58 deletions(-)

commit 577f04fcf0c52b06546aad440ff5c85f76ce6493
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-21

    Add pkcs#11 3.0 tests for log module
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/Makefile.am                             |   4 +
 p11-kit/fixtures/package-modules/four-v3.module |   2 +-
 p11-kit/fixtures/package-modules/four.module    |   2 +-
 p11-kit/meson.build                             |   1 +
 p11-kit/test-log3.c                             | 115 ++++++++++++++++++++++++
 5 files changed, 122 insertions(+), 2 deletions(-)

commit 993d66a4c05db11cab5e6e155953d453825f1143
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-22

    Make version parameter of test_mock_add_tests const
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/test-mock.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 47f2df8614ec5b036b9def78110f810081957c20
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-03-18

    tests: Make test-managed succeed without libffi
    
    The test_max_session_load test was assuming that the closure
    assignment would succeed even if the fixed closures are exhausted,
    thanks to the fallback mechanism when libffi is enabled.  This
    conditionalizes the test with WITH_FFI and do not exceed the limit if
    libffi is enabled.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/test-managed.c | 14 +++++++++++++-
 1 file changed, 13 insertions(+), 1 deletion(-)

commit 7cf6e71052b78c936dabe10510f23da734a6a9ca
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-03-17

    virtual: workaround -Wundef in <ffi.h> on macOS 12
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/virtual.c | 14 ++++++++++++++
 1 file changed, 14 insertions(+)

commit 7b27efbce33c2b1e16f4f5ce2f658edb28b8f2b9
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-03-17

    trust: Properly propagate loaded object count
    
    While the caller calculates the sum of loaded objects,
    loader_load_path didn't return the correct number of objects when
    reading from a directory.  Also protect against potential signed
    integer overflows when calculating the total.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 trust/token.c | 64 ++++++++++++++++++++++++++++++++++++++++++-----------------
 1 file changed, 46 insertions(+), 18 deletions(-)

commit a0e919ad93cb39b4183457930e36fd9402961b6b
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-03-15

    .github/workflows/test.yaml: Switch to using macOS 12 image
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 .github/workflows/test.yaml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 324ebf96146c096cc3bb9965fd87cf9d54087ce6
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-16

    Add pkcs#11 3.0 tests for proxy module
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/Makefile.am                             |   4 +
 p11-kit/fixtures/package-modules/four-v3.module |   5 +
 p11-kit/fixtures/package-modules/four.module    |   4 +-
 p11-kit/meson.build                             |   1 +
 p11-kit/test-proxy3.c                           | 270 ++++++++++++++++++++++++
 5 files changed, 282 insertions(+), 2 deletions(-)

commit f99496ac0449d45319818c3ace2d287fd3223d79
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-16

    Add test for get_interface pkcs#11 3.0 function to test-virtual
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/test-virtual.c | 46 ++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 46 insertions(+)

commit c70f0d1deb9c685cd87a2faee024545c9724ca48
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-16

    Update test-mock to support pkcs#11 3.0 tests
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/test-log.c       |   2 +-
 p11-kit/test-managed.c   |   2 +-
 p11-kit/test-mock.c      | 652 ++++++++++++++++++++++++++++++++++++++++++++++-
 p11-kit/test-proxy.c     |   2 +-
 p11-kit/test-rpc.c       |   2 +-
 p11-kit/test-transport.c |   2 +-
 6 files changed, 656 insertions(+), 6 deletions(-)

commit c2919ee2a4c1c5231f4e4b43c577b2ec8ba6cda5
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-03-21

    mock: Export C_GetInterface{,List} from the module
    
    Also stop using vs_module_defs for the modules, as it is easier to
    just declare functions with __declspec(dllexport).
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/Makefile.am    | 1 -
 p11-kit/meson.build    | 9 ++-------
 p11-kit/p11-module.def | 2 --
 p11-kit/p11-module.map | 2 ++
 trust/meson.build      | 4 +---
 5 files changed, 5 insertions(+), 13 deletions(-)

commit 5ed3ed02678ee14e8870b4df72b69d9d1cf17454
Author: Daiki Ueno <ueno@gnu.org>
Date:   2023-03-18

    proxy: Check requested interface version upon GetInterface
    
    Following up the commit 040ab19faaec28203c673599f51815c7d146f929, this
    adds a missing check on interface version requested at GetInterface,
    and also a NULL check on pVersion.  Reported by Zoltán Fridrich.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/proxy.c | 21 +++++++++++++++++----
 1 file changed, 17 insertions(+), 4 deletions(-)

commit 80d25c5ec55243f5d74ec109cd8cbe54352ea9a8
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-16

    Add pkcs#11 3.0 mock modules for testing
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/Makefile.am          |  17 +++++
 p11-kit/meson.build          |   3 +
 p11-kit/mock-module-v3-ep.c  | 138 +++++++++++++++++++++++++++++++++++++++
 p11-kit/mock-module-v3-ep2.c | 136 ++++++++++++++++++++++++++++++++++++++
 p11-kit/mock-module-v3-ep4.c | 152 +++++++++++++++++++++++++++++++++++++++++++
 5 files changed, 446 insertions(+)

commit 54bfa28536d5c05deec675cc0a85a6e1fd4a51bf
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-16

    Add PKCS#11 3.0 support to mock module
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/mock.c | 1600 +++++++++++++++++++++++++++++++++++++++++++++++++--------
 common/mock.h |  421 ++++++++++++++-
 2 files changed, 1809 insertions(+), 212 deletions(-)

commit 7fe7e5d95d9197e7f52aab314468d424acc6ac88
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-09

    Add PKCS#11 3.0 support to RPC
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/client.c      |   6 +-
 p11-kit/rpc-client.c  | 398 +++++++++++++++++++++++++++++++++++++++++++++-
 p11-kit/rpc-message.h |  46 ++++++
 p11-kit/rpc-server.c  | 433 ++++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 875 insertions(+), 8 deletions(-)

commit 040ab19faaec28203c673599f51815c7d146f929
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-03-09

    proxy: Simplify interface lookup logic
    
    This plumbs proxy around CK_INTERFACE instead of CK_FUNCTION_LIST.
    That way we can eliminate global `interfaces` as well as reduce the
    number of wrapped functions created by C_GetInterface.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/proxy.c | 122 +++++++++++++++++++-------------------------------------
 1 file changed, 42 insertions(+), 80 deletions(-)

commit bff5c3d29e02573c801cededaef480ef26862b76
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-09

    Add PKCS#11 3.0 support to log
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/log.c | 425 ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 425 insertions(+)

commit 466a31b960ba690b5f09d0d68604c3ce05e8c71a
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2021-06-15

    Add PKCS#11 3.0 support to proxy

 common/pkcs11i.h                |  171 +++++-
 doc/manual/p11-kit-proxy.xml    |    8 +-
 doc/manual/p11-kit-sections.txt |    2 +
 p11-kit/Makefile.am             |    6 +-
 p11-kit/gen-virtual-fixed.sh    |    2 +-
 p11-kit/libp11-kit-0.dll.def    |    2 +
 p11-kit/libp11-kit.map          |    2 +
 p11-kit/modules.c               |   45 +-
 p11-kit/proxy.c                 |  668 +++++++++++++++++++++-
 p11-kit/test-proxy.c            |    8 +-
 p11-kit/virtual-fixed.h         |  600 +++++++++++++++++---
 p11-kit/virtual.c               | 1176 ++++++++++++++++++++++++++++++++++++++-
 12 files changed, 2558 insertions(+), 132 deletions(-)

commit 095e521285e86900bc161c883c26d38cc1e8166e
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-03-03

    README.md: Remove no longer existing LGTM.com badges
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 README.md | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b5ba02c0a81d793a9119ef42194866d6174a83cd
Author: LGTM Migrator <lgtm-migrator@users.noreply.github.com>
Date:   2022-12-08

    Add CodeQL workflow for GitHub code scanning
    
    This is based on the template except that it uses Meson explicitly
    instead of the autobuild action.
    
    Modified-by: Daiki Ueno <dueno@redhat.com>

 .github/workflows/codeql.yml | 46 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 46 insertions(+)

commit eb183496b913b8cdfb73e6aa35eaad6ccd218388
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2023-03-03

    Add mechanism definitions for pkcs#11 3.0
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 common/pkcs11.h | 3 +++
 1 file changed, 3 insertions(+)

commit d3d333f9aa037badd360036da3766e9f58a45dbc
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2021-05-25

    pkcs11: Add PKCS#11 3.0 functions and update it to 3.0
    
    The changes are based on the OpenSC's pkcs11.h
    
    Signed-off-by: Jakub Jelen <jjelen@redhat.com>

 common/mock.h   |   2 +-
 common/pkcs11.h | 358 ++++++++++++++++++++++++++++++++++++++++++++------------
 2 files changed, 287 insertions(+), 73 deletions(-)

commit 0492597089e41464d9e8669e20969688618a5be3
Author: Daiki Ueno <dueno@redhat.com>
Date:   2023-03-02

    rpc-server: Check pointer value returned by proto_read_byte_array
    
    The commit b58b725f30ea833ce8ff08879f616b32be44cbdb added a case where
    proto_read_byte_array may return non-zero length while the pointer
    location is set to NULL.  This is to accommodate the change in
    rpc_C_Initialize.
    
    Spotted by oss-fuzz:
    https://bugs.chromium.org/p/oss-fuzz/issues/detail?id=56504
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/rpc-server.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 8fd7fc528dd83521d5fec7f8261789cac9d65ea8
Author: Clemens Lang <cllang@redhat.com>
Date:   2023-02-01

    rpc: Fix two off-by-one errors identified by asan
    
    Reads after the end of the array happen when removing elements as well
    as if the last element was removed. Note that the new if is required
    because memmove() expects a size_t as length, so we must ensure that it
    can not be negative.
    
    The full AddressSanitizer report is:
    
    | =================================================================
    | ==27174==ERROR: AddressSanitizer: heap-buffer-overflow on address 0x616000000bb0 at pc 0x00010f8b618d bp 0x7ff7b0b5c3c0 sp 0x7ff7b0b5bb80
    | READ of size 560 at 0x616000000bb0 thread T0
    |     #0 0x10f8b618c in wrap_memcpy+0x16c (libclang_rt.asan_osx_dynamic.dylib:x86_64h+0x1f18c)
    |     #1 0x111a9bac5 in rpc_C_GetMechanismList+0x18c (p11-kit-client.so:x86_64+0x18ac5)
    |     #2 0x111823534 in p11prov_GetMechanismList interface.gen.c:138
    |     #3 0x11184e404 in get_slot_mechanisms session.c:113
    |     #4 0x11184c3ba in p11prov_init_slots session.c:226
    |     #5 0x111843fed in p11prov_module_init provider.c:1035
    |     #6 0x1118417a9 in OSSL_provider_init provider.c:1102
    |     #7 0x11080ee97 in provider_activate+0x117 (libcrypto.3.dylib:x86_64+0x12be97)
    |     #8 0x11080eced in ossl_provider_activate+0x42 (libcrypto.3.dylib:x86_64+0x12bced)
    |     #9 0x11080db4a in provider_conf_init+0x2a2 (libcrypto.3.dylib:x86_64+0x12ab4a)
    |     #10 0x11075ae36 in CONF_modules_load+0x37b (libcrypto.3.dylib:x86_64+0x77e36)
    |     #11 0x11075b0c9 in CONF_modules_load_file_ex+0x78 (libcrypto.3.dylib:x86_64+0x780c9)
    |     #12 0x11075b899 in ossl_config_int+0x36 (libcrypto.3.dylib:x86_64+0x78899)
    |     #13 0x110806ac9 in ossl_init_config_ossl_+0xa (libcrypto.3.dylib:x86_64+0x123ac9)
    |     #14 0x7ff818b4acc4 in __pthread_once_handler+0x40 (libsystem_pthread.dylib:x86_64+0x2cc4)
    |     #15 0x7ff818b61725 in _os_once_callout+0x11 (libsystem_platform.dylib:x86_64+0x1725)
    |     #16 0x7ff818b4ac72 in pthread_once+0x49 (libsystem_pthread.dylib:x86_64+0x2c72)
    |     #17 0x11081126c in CRYPTO_THREAD_run_once+0x8 (libcrypto.3.dylib:x86_64+0x12e26c)
    |     #18 0x11080691d in OPENSSL_init_crypto+0x446 (libcrypto.3.dylib:x86_64+0x12391d)
    |     #19 0x10f6032dc in OPENSSL_init_ssl+0x79 (libssl.3.dylib:x86_64+0x102dc)
    |     #20 0x10f3c6287 in main+0x62 (openssl:x86_64+0x100024287)
    |     #21 0x115f5252d in start+0x1cd (dyld:x86_64+0x552d)
    |
    | 0x616000000bb0 is located 0 bytes to the right of 560-byte region [0x616000000980,0x616000000bb0)
    | allocated by thread T0 here:
    |     #0 0x10f8e1ed0 in wrap_malloc+0xa0 (libclang_rt.asan_osx_dynamic.dylib:x86_64h+0x4aed0)
    |     #1 0x111f1432f in CRYPTO_malloc+0x8f (libcrypto.3.dylib:x86_64+0x16332f)
    |     #2 0x11184e1a8 in get_slot_mechanisms session.c:107
    |     #3 0x11184c3ba in p11prov_init_slots session.c:226
    |     #4 0x111843fed in p11prov_module_init provider.c:1035
    |     #5 0x1118417a9 in OSSL_provider_init provider.c:1102
    |     #6 0x11080ee97 in provider_activate+0x117 (libcrypto.3.dylib:x86_64+0x12be97)
    |     #7 0x11080eced in ossl_provider_activate+0x42 (libcrypto.3.dylib:x86_64+0x12bced)
    |     #8 0x11080db4a in provider_conf_init+0x2a2 (libcrypto.3.dylib:x86_64+0x12ab4a)
    |     #9 0x11075ae36 in CONF_modules_load+0x37b (libcrypto.3.dylib:x86_64+0x77e36)
    |     #10 0x11075b0c9 in CONF_modules_load_file_ex+0x78 (libcrypto.3.dylib:x86_64+0x780c9)
    |     #11 0x11075b899 in ossl_config_int+0x36 (libcrypto.3.dylib:x86_64+0x78899)
    |     #12 0x110806ac9 in ossl_init_config_ossl_+0xa (libcrypto.3.dylib:x86_64+0x123ac9)
    |     #13 0x7ff818b4acc4 in __pthread_once_handler+0x40 (libsystem_pthread.dylib:x86_64+0x2cc4)
    |     #14 0x7ff818b61725 in _os_once_callout+0x11 (libsystem_platform.dylib:x86_64+0x1725)
    |     #15 0x7ff818b4ac72 in pthread_once+0x49 (libsystem_pthread.dylib:x86_64+0x2c72)
    |     #16 0x11081126c in CRYPTO_THREAD_run_once+0x8 (libcrypto.3.dylib:x86_64+0x12e26c)
    |     #17 0x11080691d in OPENSSL_init_crypto+0x446 (libcrypto.3.dylib:x86_64+0x12391d)
    |     #18 0x10f6032dc in OPENSSL_init_ssl+0x79 (libssl.3.dylib:x86_64+0x102dc)
    |     #19 0x10f3c6287 in main+0x62 (openssl:x86_64+0x100024287)
    |     #20 0x115f5252d in start+0x1cd (dyld:x86_64+0x552d)
    |
    | SUMMARY: AddressSanitizer: heap-buffer-overflow (libclang_rt.asan_osx_dynamic.dylib:x86_64h+0x1f18c) in wrap_memcpy+0x16c
    | Shadow bytes around the buggy address:
    |   0x1c2c00000120: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
    |   0x1c2c00000130: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
    |   0x1c2c00000140: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
    |   0x1c2c00000150: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
    |   0x1c2c00000160: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
    | =>0x1c2c00000170: 00 00 00 00 00 00[fa]fa fa fa fa fa fa fa fa fa
    |   0x1c2c00000180: fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa fa
    |   0x1c2c00000190: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
    |   0x1c2c000001a0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
    |   0x1c2c000001b0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
    |   0x1c2c000001c0: 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00 00
    | Shadow byte legend (one shadow byte represents 8 application bytes):
    |   Addressable:           00
    |   Partially addressable: 01 02 03 04 05 06 07
    |   Heap left redzone:       fa
    |   Freed heap region:       fd
    |   Stack left redzone:      f1
    |   Stack mid redzone:       f2
    |   Stack right redzone:     f3
    |   Stack after return:      f5
    |   Stack use after scope:   f8
    |   Global redzone:          f9
    |   Global init order:       f6
    |   Poisoned by user:        f7
    |   Container overflow:      fc
    |   Array cookie:            ac
    |   Intra object redzone:    bb
    |   ASan internal:           fe
    |   Left alloca redzone:     ca
    |   Right alloca redzone:    cb
    | ==27174==ABORTING
    | Abort trap: 6
    
    Signed-off-by: Clemens Lang <cllang@redhat.com>
    Modified-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/rpc-client.c | 11 +++++++----
 1 file changed, 7 insertions(+), 4 deletions(-)

commit b58b725f30ea833ce8ff08879f616b32be44cbdb
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2021-06-15

    rpc-server: Fix reading NULL byte arrays
    
    The proto_read_byte_array() is used in IN_BYTE_ARRAY. Its client
    counterpart is using p11_rpc_message_write_byte_array(), which ads
    uint32 item with the array size after 0 byte, but this was never
    read here causing message corruption errors.

 p11-kit/rpc-server.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit a51ed5d9186d819d13c628c968f2837a1e61796c
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2021-06-15

    test-mock: Test operations on private objects

 p11-kit/test-mock.c | 103 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 103 insertions(+)

commit 25ac7415a547b1db2baccc143c9a4d2b1cee3c57
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2021-06-15

    test-mock: Use assert_num_equal for easier debugging

 p11-kit/test-mock.c | 280 ++++++++++++++++++++++++++--------------------------
 1 file changed, 140 insertions(+), 140 deletions(-)

commit 852ccd8d1cfcd39a478b721de10238086adea425
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2021-06-15

    Test more use cases of PK operations
    
    This increase test coverage and captures more corner cases of
    parameters and return values handling.
    
    Namely:
     * NULL mechanism cancels operation, but it was considered here as
       bad arguments
     * Some queries for buffer sizes were incorrectly finalizing the
       operations
     * Changed the internal operation identification to use CK_FLAGS as
       suggested by specs
     * Verify operation was not correcly finalized when the signature was
       not valid in mock
     * The log and rpc modules were not handling the NULL mech correctly

 common/mock.c         | 206 +++++++++++++++++++++++++++++++++++++++-----------
 p11-kit/log.c         |  14 ++--
 p11-kit/rpc-client.c  |   9 ++-
 p11-kit/rpc-message.c |   5 ++
 p11-kit/rpc-server.c  |  78 +++++++++++--------
 p11-kit/test-mock.c   | 189 +++++++++++++++++++++++++++++++++++++++++++--
 6 files changed, 414 insertions(+), 87 deletions(-)

commit 1afb06e107937478beb97ae90c32a737e7dc85b2
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2021-05-25

    pkcs11: Fix typo in the parameter name
    
    Signed-off-by: Jakub Jelen <jjelen@redhat.com>

 common/pkcs11.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ac43f1edd029d0e94bc944eb33342c69a0580cc7
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2021-06-09

    test-modules: Remove duplicate test_no_duplicates (just named otherwise)
    
    This was introduced as part of c01b59e (Check exhaustion of fixed
    closures ) which looks like it did not test the original issue.

 p11-kit/test-modules.c | 36 ------------------------------------
 1 file changed, 36 deletions(-)

commit d39043f7c6e44247b5b1a237888e80b2a4d9c2b2
Author: Florian Weimer <fweimer@redhat.com>
Date:   2022-12-12

    Fix meson/configure _Thread_local checks for C99 compatibility
    
    The type was missing from the definition, which happens to work
    in current compilers for historic reasons.  Implicit ints were
    actually removed from C in 1999.

 configure.ac | 2 +-
 meson.build  | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit da081beb2765d55a39f3c8e309b51b590d5efe1f
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2022-12-02

    po: Add p11-kit/print-config.c to POTFILES.in
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 po/POTFILES.in | 1 +
 1 file changed, 1 insertion(+)

commit a8fad5451241f0df7e2433b8aefdd3f23441b97e
Author: Zoltan Fridrich <zfridric@redhat.com>
Date:   2022-11-28

    Add command to print merged configuration
    
    Signed-off-by: Zoltan Fridrich <zfridric@redhat.com>

 p11-kit/Makefile.am    |   4 ++
 p11-kit/meson.build    |   7 +--
 p11-kit/p11-kit.c      |   4 ++
 p11-kit/print-config.c | 137 +++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 149 insertions(+), 3 deletions(-)

commit 5056a43b1360a4e098b71766449af862bfa8f1b3
Author: David Korczynski <david@adalogics.com>
Date:   2022-11-23

    ci: Add CIFuzz workflow

 .github/workflows/cifuzz.yml | 26 ++++++++++++++++++++++++++
 1 file changed, 26 insertions(+)

commit e3b3ced300e53d96a4688bfd682f828c40b9ec81
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-10-30

    .github/workflows/test.yaml: Enable CI on macOS
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .github/actions/basic-autotools/action.yaml | 43 +++++++++++++++++++++++------
 .github/workflows/test.yaml                 | 16 +++++++++++
 trust/test-extract.sh                       |  9 +++---
 3 files changed, 55 insertions(+), 13 deletions(-)

commit e7d1c91dc1c618d4c7cab7f8c2a614720f552ed8
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-10-19

    server: Check SHELL only when neither --sh nor --csh is specified
    
    Previously C shell syntax is used for printing environment variable
    setup even if --sh is given when SHELL is csh.
    
    Reported in:
    https://github.com/p11-glue/p11-kit/issues/437
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/server.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 8c917c0588d728edb665e96bb7b9f8e15b5978dd
Author: Balázs Úr <balazs@urbalazs.hu>
Date:   2022-10-20

    po: Fix warning and fatal error in Sinhala translation

 po/si.po | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit c92e95f9799d5716bdbddd06e48ab319cdb484c7
Author: Balázs Úr <balazs@urbalazs.hu>
Date:   2022-10-19

    po: Update translations from Transifex

 po/LINGUAS        |    1 +
 po/ar.po          | 1106 +++++++++++++++++++++++++++++++++++++++-
 po/as.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/ast.po         | 1260 ++++++++++++++++++++++++++++++++++++++++++----
 po/az.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/bg.po          | 1103 +++++++++++++++++++++++++++++++++++++++-
 po/bn_IN.po       | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/ca.po          | 1103 +++++++++++++++++++++++++++++++++++++++-
 po/ca@valencia.po | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/cs.po          | 1108 ++++++++++++++++++++++++++++++++++++++++-
 po/cy.po          | 1104 +++++++++++++++++++++++++++++++++++++++-
 po/da.po          | 1124 ++++++++++++++++++++++++++++++++++++++++-
 po/de.po          | 1123 ++++++++++++++++++++++++++++++++++++++++-
 po/el.po          | 1101 +++++++++++++++++++++++++++++++++++++++-
 po/en_GB.po       | 1101 +++++++++++++++++++++++++++++++++++++++-
 po/eo.po          | 1101 +++++++++++++++++++++++++++++++++++++++-
 po/es.po          | 1140 +++++++++++++++++++++++++++++++++++++++++-
 po/et.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/eu.po          | 1146 ++++++++++++++++++++++++++++++++++++++++--
 po/fa.po          | 1105 +++++++++++++++++++++++++++++++++++++++-
 po/fi.po          | 1201 ++++++++++++++++++++++++++++++++++++++++++--
 po/fo.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/fr.po          | 1107 ++++++++++++++++++++++++++++++++++++++++-
 po/fur.po         | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/ga.po          | 1105 +++++++++++++++++++++++++++++++++++++++-
 po/gl.po          | 1101 +++++++++++++++++++++++++++++++++++++++-
 po/gu.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/he.po          | 1104 +++++++++++++++++++++++++++++++++++++++-
 po/hi.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/hr.po          | 1177 +++++++++++++++++++++++++++++++++++++++++--
 po/hu.po          | 1201 ++++++++++++++++++++++++++++++++++++++++++--
 po/ia.po          | 1103 +++++++++++++++++++++++++++++++++++++++-
 po/id.po          | 1120 ++++++++++++++++++++++++++++++++++++++++-
 po/it.po          | 1107 ++++++++++++++++++++++++++++++++++++++++-
 po/ja.po          | 1107 ++++++++++++++++++++++++++++++++++++++++-
 po/ka.po          | 1125 ++++++++++++++++++++++++++++++++++++++++-
 po/kk.po          | 1103 +++++++++++++++++++++++++++++++++++++++-
 po/kn.po          | 1101 +++++++++++++++++++++++++++++++++++++++-
 po/ko.po          | 1109 ++++++++++++++++++++++++++++++++++++++++-
 po/lt.po          | 1150 ++++++++++++++++++++++++++++++++++++++++--
 po/lv.po          | 1107 ++++++++++++++++++++++++++++++++++++++++-
 po/ml.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/mr.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/ms.po          | 1098 +++++++++++++++++++++++++++++++++++++++-
 po/nb.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/nl.po          | 1101 +++++++++++++++++++++++++++++++++++++++-
 po/nn.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/oc.po          | 1101 +++++++++++++++++++++++++++++++++++++++-
 po/or.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/pa.po          | 1128 ++++++++++++++++++++++++++++++++++++++++-
 po/pl.po          | 1116 ++++++++++++++++++++++++++++++++++++++++-
 po/pt.po          | 1105 +++++++++++++++++++++++++++++++++++++++-
 po/pt_BR.po       | 1131 ++++++++++++++++++++++++++++++++++++++++-
 po/ro.po          | 1103 +++++++++++++++++++++++++++++++++++++++-
 po/ru.po          | 1107 ++++++++++++++++++++++++++++++++++++++++-
 po/si.po          | 1438 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 po/sk.po          | 1108 ++++++++++++++++++++++++++++++++++++++++-
 po/sl.po          | 1106 +++++++++++++++++++++++++++++++++++++++-
 po/sq.po          | 1103 +++++++++++++++++++++++++++++++++++++++-
 po/sr.po          | 1106 +++++++++++++++++++++++++++++++++++++++-
 po/sr@latin.po    | 1103 +++++++++++++++++++++++++++++++++++++++-
 po/sv.po          | 1142 +++++++++++++++++++++++++++++++++++++++++-
 po/ta.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/te.po          | 1103 +++++++++++++++++++++++++++++++++++++++-
 po/th.po          | 1098 +++++++++++++++++++++++++++++++++++++++-
 po/tr.po          | 1145 ++++++++++++++++++++++++++++++++++++++++--
 po/uk.po          | 1133 ++++++++++++++++++++++++++++++++++++++++-
 po/vi.po          | 1098 +++++++++++++++++++++++++++++++++++++++-
 po/wa.po          | 1099 +++++++++++++++++++++++++++++++++++++++-
 po/zh_CN.po       | 1103 +++++++++++++++++++++++++++++++++++++++-
 po/zh_HK.po       | 1102 +++++++++++++++++++++++++++++++++++++++-
 po/zh_TW.po       | 1260 ++++++++++++++++++++++++++++++++++++++++++----
 72 files changed, 78677 insertions(+), 899 deletions(-)

commit 870ef2048aadca2655462b6221b1b305ee53bb08
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-10-18

    modules: Make logging message more translatable
    
    Reported and fix suggested by Balázs Úr in:
    https://github.com/p11-glue/p11-kit/issues/435
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/modules.c | 10 +++++++---
 1 file changed, 7 insertions(+), 3 deletions(-)

commit 42aff7709a1f9eafc434e2d994c7283b26d9820f
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-08-01

    Revert "ci: Switch to using Gcovr instead of LCOV"
    
    This reverts commit 2edebe3b674d364430981771cb402e8a1a412e45.
    
    It turned out that neither Gcovr supports LCOV output format that
    Coveralls GH action requires, nor Coveralls GH action supports JSON
    format produced by gcovr --coveralls.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 ci/Dockerfile | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2edebe3b674d364430981771cb402e8a1a412e45
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-07-31

    ci: Switch to using Gcovr instead of LCOV
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 ci/Dockerfile | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7b1ef9e559e7f7bb2c743abed7688b621cda9f88
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-07-29

    trust: Remove condition that always evaluates to true
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 trust/base64.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 6e26a15d832c1bfaa6261c6ebccaa687d61683a6
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-07-29

    trust: Make loop invariant more explicit in load_attached_extensions
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 trust/enumerate.c | 31 +++++++++++++++++--------------
 1 file changed, 17 insertions(+), 14 deletions(-)

commit 7b111c0c4babc9697473ff612a601171e373d2e2
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-07-29

    trust: Use fstat/fchmod instead of stat/chmod
    
    This prevents a race condition when the underlying file being changed
    in between the calls.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 trust/save.c | 31 +++++++++++++++++++++++--------
 1 file changed, 23 insertions(+), 8 deletions(-)

commit 1046e0ae686037b7cd3d7e5c9ab447c449d70ba9
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-07-29

    compat: Fix detection of O_BINARY and O_CLOEXEC
    
    Previously those macros were defined as 0 unless <fcntl.h> was
    included before "compat.h".
    
    Reported and fix suggested by Kevin Adler in:
    https://github.com/p11-glue/p11-kit/issues/425
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/compat.h | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 23e97903b0945e7819854059873547d583439af8
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-07-29

    trust: Replace deprecated node_asn and ASN1_ARRAY_TYPE macro usage
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 trust/asn1.c            | 30 +++++++++++++++---------------
 trust/asn1.h            | 12 ++++++------
 trust/builder.c         | 22 +++++++++++-----------
 trust/enumerate.c       |  4 ++--
 trust/enumerate.h       |  2 +-
 trust/extract-openssl.c | 18 +++++++++---------
 trust/frob-bc.c         |  4 ++--
 trust/frob-cert.c       |  4 ++--
 trust/frob-eku.c        |  4 ++--
 trust/frob-ext.c        |  4 ++--
 trust/frob-ku.c         |  4 ++--
 trust/frob-oid.c        |  4 ++--
 trust/parser.c          | 16 ++++++++--------
 trust/persist.c         |  6 +++---
 trust/test-asn1.c       |  6 +++---
 trust/test-oid.c        |  4 ++--
 trust/test-x509.c       |  4 ++--
 trust/x509.c            | 16 ++++++++--------
 trust/x509.h            |  6 +++---
 19 files changed, 85 insertions(+), 85 deletions(-)

commit d1782b694f75f4a7c1449b2d006df7aeaffbb576
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-07-27

    pkcs11-gnu: Enable testing with <p11-kit/pkcs11x.h>
    
    This ensures that programs using <p11-kit/pkcs11x.h> can be compiled
    with CRYPTOKI_GNU.  The previous coverage was partial as pkcs11-gnu.c
    didn't include "pkcs11x.h" and Meson didn't supply -DCRYPTOKI_GNU=1.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/meson.build  | 3 +++
 p11-kit/p11-kit.h    | 5 +++++
 p11-kit/pkcs11-gnu.c | 5 +++++
 3 files changed, 13 insertions(+)

commit 7675f8672ffcf7641fd048533747937d30fb8e8e
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-06-19

    common/pkcs11x.h: Support CRYPTOKI_GNU for IBM vendor mechanisms
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/pkcs11x.h | 20 +++++++++++++++++---
 1 file changed, 17 insertions(+), 3 deletions(-)

commit b8578017339dd5898967c1d806e340e09fdc44dd
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-06-19

    README.md: Remove status badge for Travis CI which is no longer used
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ce5a4f3bace5890f28cadc6abd5749054825ab09
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-05-31

    build: Use SHLEXT instead of hard-coding ".so"
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/test-conf.c      | 16 ++++++++--------
 p11-kit/test-transport.c |  2 +-
 2 files changed, 9 insertions(+), 9 deletions(-)

commit cb9314886798e3f20ce4e914fc0599738ce97586
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-05-31

    build: Make sure to append EXEEXT when spawning our own executables
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/p11-kit.c        | 2 +-
 p11-kit/test-server.c    | 3 ++-
 p11-kit/test-transport.c | 2 +-
 trust/extract.c          | 3 ++-
 4 files changed, 6 insertions(+), 4 deletions(-)

commit 6add9dc45f44eff9691f347dad43986d832ae90d
Author: Frederik Boster <frederik@boster.de>
Date:   2022-06-02

    #379 Fix support for epoch time 0 in JKS for reproducibility

 trust/extract-jks.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7ea59012c2c81473132211e29ea8ebcc1ce31d09
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-11

    Add support for CKM_AES_GCM
    
    It takes a CK_GCM_PARAMS structure as mechanism parameter.
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 p11-kit/rpc-message.c | 70 +++++++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/rpc-message.h |  9 +++++++
 2 files changed, 79 insertions(+)

commit 3c0be1d42d0568550797d86355cd03204e4c4eb6
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-11

    Add support for CKM_AES_CTR
    
    It takes a CK_AES_CTR_PARAMS structure as mechanism parameter.
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 p11-kit/rpc-message.c | 62 +++++++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/rpc-message.h |  9 ++++++++
 2 files changed, 71 insertions(+)

commit 506b9414999edfc993e9142b4bad068060c587bf
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-08

    rpc: Handle special cases for buffer and length
    
    When the buffer is not NULL, but the length is zero then treat this as an
    empty message. Serialize this in a special way so that the server can
    restore the same situation.
    
    Example: Terminate an operation via C_XxxFinal, but there is no more
    data for the final part. A call to C_XxxFinal with buffer=NULL and length=0
    would be treated as a size query, and would not terminate the operation.
    So the way to terminate the operation without more data is to specify
    buffer!=NULL but length=0.
    
    When sending a byte array, and the buffer is NULL, and the length is
    zero, don't treat this is invalid, but as empty message.
    
    Example: C_XxxUpdate with an empty message.
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 p11-kit/rpc-client.c  | 2 +-
 p11-kit/rpc-message.c | 2 +-
 p11-kit/rpc-server.c  | 6 ++++++
 3 files changed, 8 insertions(+), 2 deletions(-)

commit b72aa478baaa29c6ee4342d1a194938590f389df
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-08

    Add support for CKM_DH_PKCS_DERIVE
    
    It takes the the public value of the other party as mechanism parameter.
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 p11-kit/rpc-message.c | 41 +++++++++++++++++++++++++++++++++++++++++
 p11-kit/rpc-message.h | 11 +++++++++++
 2 files changed, 52 insertions(+)

commit 7235af663b95e3e0a7c035d3de7f26c0c6a4810e
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-08

    Add support for MAC and HMAC general mechanisms
    
    The take a mechanism parameter of type CK_MAC_GENERAL_PARAMS which
    is a CK_ULONG.
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 p11-kit/rpc-message.c | 59 +++++++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/rpc-message.h | 11 ++++++++++
 2 files changed, 70 insertions(+)

commit ac0da8239de4184dab2d48a4350503ef278db2a4
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-08

    Add support for missing AES and DES/DES3 mechanisms
    
    They take a 16 byte (AES) or 8 byte (DES/DES3) IV as mechanism parameter.
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 p11-kit/rpc-message.c | 95 +++++++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/rpc-message.h | 18 ++++++++++
 2 files changed, 113 insertions(+)

commit 242e5db070f7b17cf3d2e86b40b77f2e999ea3da
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-08

    Add other SHA variants, also for RSA and EC signatures
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 p11-kit/rpc-message.c | 26 ++++++++++++++++++++++++++
 1 file changed, 26 insertions(+)

commit c4ade85343b9cbe128e105839e454d2423c00c98
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-08

    Fix support of CKA_DERIVE_TEMPLATE
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 p11-kit/rpc-message.c | 1 +
 1 file changed, 1 insertion(+)

commit 218e9719b5a47a65fbf6131a5b69825948c1d4e0
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-08

    client: Allow zero part length at C_SignUpdate
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 p11-kit/rpc-client.c | 2 --
 1 file changed, 2 deletions(-)

commit d07a8ffc0f287bef66295fffcbe9c7ccba711ef0
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-07

    Add support for serializing CK_ECDH1_DERIVE_PARAMS mech param
    
    Used by CKM_ECDH1_DERIVE, CKM_IBM_EC_X25519 and CKM_IBM_EC_X448.
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 p11-kit/rpc-message.c | 79 ++++++++++++++++++++++++++++++++++++++++++++++++++-
 p11-kit/rpc-message.h | 11 +++++++
 2 files changed, 89 insertions(+), 1 deletion(-)

commit 4059f174042fc76be0b258b27061e351306a74ff
Author: Ingo Franzki <ifranzki@linux.ibm.com>
Date:   2022-04-07

    Add IBM specific mechanism and attributes
    
    Signed-off-by: Ingo Franzki <ifranzki@linux.ibm.com>

 common/attrs.c        | 17 ++++++++++
 common/constants.c    | 38 +++++++++++++++++++++++
 common/pkcs11x.h      | 51 ++++++++++++++++++++++++++++++
 p11-kit/rpc-message.c | 86 ++++++++++++++++++++++++++++++++++++++++++++++++++-
 p11-kit/rpc-message.h | 12 +++++++
 5 files changed, 203 insertions(+), 1 deletion(-)

commit 72335286ff1183ec17c5002a7df8d1eceeef55ec
Author: 13362041868 <490514142@qq.com>
Date:   2022-04-26

    The usage string of p11_tool_desc usages in trust/dump.c should uses "trust dump" p11_tool_desc usages[] = { { 0, "usage: trust dump--filter=" }

 trust/dump.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit e06aa5dd1a74de9bb2a1d30dd72b4c0ea34fac9d
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-02-04

    meson: revert the p11_system_config_modules pkg-config variable
    
    For compatibility reasons, we keep p11_system_config_modules pointing
    to p11_package_config_modules in the pkg-config file.
    
    Spotted by Debarshi Ray in:
    https://github.com/p11-glue/p11-kit/pull/377#pullrequestreview-872572645
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/meson.build | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit dd0590d4e583f107e3e9fafe9ed754149da335d0
Author: Daiki Ueno <ueno@gnu.org>
Date:   2022-01-17

    Release 0.24.1
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 NEWS         | 7 +++++++
 configure.ac | 2 +-
 meson.build  | 2 +-
 3 files changed, 9 insertions(+), 2 deletions(-)

commit 4589625f3038d85cada8555fc457ad30ca2bfd06
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-05-30

    common: Support copying attribute array recursively
    
    This enables p11_attrs_build to build an attribute list with arrays of
    attributes indicated with CKF_ARRAY_ATTRIBUTE.  A couple of new
    internal functions have been added: p11_attr_copy and p11_attr_clear.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/attrs.c      | 80 +++++++++++++++++++++++++++++++++++++++++++++--------
 common/attrs.h      |  3 ++
 common/test-attrs.c | 36 ++++++++++++++++++++++++
 3 files changed, 107 insertions(+), 12 deletions(-)

commit b9da18d6994b3a718248f59f1f080d4f6fe97b8c
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-06-01

    common: Add assert_ptr_cmp
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/test.h | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit 9f01a8a45ba913a9b65894cef9369b6010005096
Author: Eli Schwartz <eschwartz@archlinux.org>
Date:   2022-01-11

    gtkdoc: remove dependencies on custom target files
    
    Sadly, the `dependencies` kwarg does not actually do what it seems to be
    trying to be used for, here. It is for listing dependency or library
    objects whose compiler flags should be added to gtkdoc-scangobj.
    
    It will not actually add ninja target dependencies. The similar kwarg in
    other meson functions (e.g. genmarshal and compile_schemas) that *do*
    allow adding target dependencies, is `depend_files`.
    
    Older versions of meson simply did nothing in an if/elif/elif block
    where these custom_targets never matched anything, and were thus
    silently ignored.
    
    Meson 0.61 type-validates the arguments and rejects CustomTarget as
    invalid:
    
    ```
    doc/manual/meson.build:72:8: ERROR: gnome.gtkdoc keyword argument 'dependencies' was of type array[CustomTarget | PkgConfigDependency] but should have been array[Dependency | SharedLibrary | StaticLibrary]
    ```
    
    Fixes #406

 doc/manual/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 04f85857b3029fd28c7c731aef89f61b22e846d3
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-11-26

    doc: Replace occurrence of black list with blocklist
    
    This is a follow-up of 47fabc2366d917e255241c41a6cfc179af372644.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 doc/manual/pkcs11.conf.xml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit fd7c4e7e9496a7b4b2a26430e8969f27fb38457e
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-10-16

    build: Suppress cppcheck false-positive on array bounds
    
    Cppcheck 2.6 reports the following errors, when loops on arrays depend
    on a sentinel:
    
     trust/builder.c:1103,error,arrayIndexOutOfBounds,Array 'schema->attrs[32]' accessed at index 9998, which is out of bounds.
     trust/builder.c:1136,error,arrayIndexOutOfBounds,Array 'schema->attrs[32]' accessed at index 9998, which is out of bounds.
     trust/builder.c:1301,error,arrayIndexOutOfBounds,Array 'ku_attribute_map[8]' accessed at index 9998, which is out of bounds.
     trust/builder.c:1385,error,arrayIndexOutOfBounds,Array 'eku_attribute_map[9]' accessed at index 9998, which is out of bounds.
    
    This adds an extra check to those loop conditions.  While it is
    redundant, this should be harmless as it is not in the performance
    critical path.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 trust/builder.c | 14 ++++++++++----
 1 file changed, 10 insertions(+), 4 deletions(-)

commit 2d34226781e89c23cef13833a3db25b1d59d9b07
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-10-16

    ci: Use Docker image from the same repository
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .github/workflows/test.yaml | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit c643379626e6ea1d22ab406aafc0beed35b81ab3
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-10-16

    ci: Integrate Docker image building to GitHub workflow
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 .github/workflows/build-image.yml | 39 +++++++++++++++++++++++++++++++++++++++
 ci/Dockerfile                     |  9 +++++++++
 2 files changed, 48 insertions(+)

commit 0bc75cae1057b03e3d790c741adf97ac9b4dbe92
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-09-18

    rpc: Fallback to version 0 if server does not support negotiation
    
    Old servers without support for version negotiation cannot handle
    version bytes other than 0 and will close the connection if a version
    byte greater than 0 is received.  This adds a fallback mechanism to
    reconnect and reauthenticate with version 0 in that situation for
    backward compatibility.
    
    Suggested by Owen Taylor.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/rpc-client.c    | 16 ++++++++++++++++
 p11-kit/rpc-transport.c |  2 +-
 2 files changed, 17 insertions(+), 1 deletion(-)

commit fdf3f1f28b946ee737b55b4313f8a7f7a02143f3
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-08-24

    build: Port e850e03be65ed573d0b69ee0408e776c08fad8a3 to meson
    
    Also expand the comment in configure.ac.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 configure.ac        | 7 ++++---
 p11-kit/meson.build | 6 ++++++
 2 files changed, 10 insertions(+), 3 deletions(-)

commit e850e03be65ed573d0b69ee0408e776c08fad8a3
Author: Emmanuel Dreyfus <manu@netbsd.org>
Date:   2021-08-24

    Link libp11-kit so that it cannot unload
    
    libp11-kit installs a pthread_atfork() callback to count forks. If the
    library gets unloaded, a stale pointer is called on the next fork(),
    leading to a crash.
    
    This fix adds -z nodelete linker flag so that libp11-kit cannot be
    unloaded. Unfortunately, that only fixes the problem for GNU ld.
    More additionnal flags will be required for other linkers.

 configure.ac        | 13 +++++++++++++
 p11-kit/Makefile.am |  1 +
 2 files changed, 14 insertions(+)

commit 509c1c949751c554e6244f2b42f1ce905e02f47d
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-07-22

    trust: Use dngettext for plurals
    
    Suggested by Rafael Fontenelle in:
    https://github.com/p11-glue/p11-kit/issues/380
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 trust/anchor.c | 10 ++++++----
 1 file changed, 6 insertions(+), 4 deletions(-)

commit 4769c479a3c41d68a293d007dd9e17a763001239
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-06-04

    rpc: Support protocol version negotiation
    
    This works as follows:
    - a couple of build-time constants have been added to represent the
      minimal and maximum supported protocol versions
    - the client sends the maximum supported version upon connection
      establishment (when C_Initialize is called for first time from the
      client process)
    - the server checks the version sent from the client; if it is lower
      than the minimum supported version of the server, sends an error
    - otherwise, the server responds with either of smaller value between
      the version sent from the client and the maximum supported version of
      the server
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 configure.ac            | 36 ++++++++++++++++++++++++++++++++++++
 meson.build             | 10 ++++++++++
 meson_options.txt       |  8 ++++++++
 p11-kit/rpc-client.c    |  6 +++++-
 p11-kit/rpc-server.c    | 27 ++++++++++++++++++---------
 p11-kit/rpc-transport.c | 18 ++++++++++++++----
 p11-kit/rpc.h           |  4 +++-
 p11-kit/test-rpc.c      |  4 +++-
 8 files changed, 97 insertions(+), 16 deletions(-)

commit 2237f95b27e19f5f967c70ba8862a821e1e7de33
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-06-04

    rpc: Separate authentication step from transaction
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/rpc-client.c    |  4 ++++
 p11-kit/rpc-transport.c | 61 ++++++++++++++++++++++++++++++-------------------
 p11-kit/rpc.h           |  2 ++
 p11-kit/test-rpc.c      | 30 ++++++++++++++++--------
 4 files changed, 64 insertions(+), 33 deletions(-)

commit 576bba3c34d6994e8b02051d94e6446bb0631ca1
Author: Issam E. Maghni <issam.e.maghni@mailbox.org>
Date:   2021-06-16

    Meson: p11_system_config_modules instead of p11_package_config_modules

 p11-kit/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a36228a06ad87ea6fe429a8c4705d68b2780e0d9
Author: Issam E. Maghni <issam.e.maghni@mailbox.org>
Date:   2021-06-15

    shell: test -a|o is not POSIX

 configure.ac           | 2 +-
 p11-kit/test-server.sh | 4 ++--
 2 files changed, 3 insertions(+), 3 deletions(-)

commit 79a0a3f235e44c174dd8efe5e2fe942812d18179
Author: Issam E. Maghni <issam.e.maghni@mailbox.org>
Date:   2021-06-13

    Meson: Add libtasn1 to trust programs

 trust/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 40d3ab265bff4cca10f1e0b7ed60f037511ee477
Author: Đoàn Trần Công Danh <congdanhqx@gmail.com>
Date:   2021-06-10

    meson: optionalise glib's development files for gtk_doc
    
    In p11-kit, only installation prefix of glib is required to build gtk-doc.
    
    In some distro, those development files are splitted into separated
    package.  Pulling those development files in will pull its development
    dependencies, too.
    
    Let's give our users an option to build gtk-doc without development
    files of glib.

 doc/manual/meson.build | 5 ++++-
 meson_options.txt      | 4 ++++
 2 files changed, 8 insertions(+), 1 deletion(-)

commit 34826623f58399b24c21f1788e2cdaea34521b7b
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-06-03

    common: Only check strndup behavior when replacement is used
    
    Otherwise GCC 11 complains with -Wstringop-overread.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/test-compat.c | 6 ++++++
 1 file changed, 6 insertions(+)

commit 9832f8b0ce334d269f2c6037ba5daf48057f3bcf
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-06-03

    Release 0.24.0
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 NEWS         | 9 +++++++++
 configure.ac | 2 +-
 meson.build  | 2 +-
 3 files changed, 11 insertions(+), 2 deletions(-)

commit bd0970c8925bc7fb523d4c06088a4b4e031f31cf
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-12-11

    Release 0.23.22

 NEWS         | 10 ++++++++++
 configure.ac |  2 +-
 meson.build  |  2 +-
 3 files changed, 12 insertions(+), 2 deletions(-)

commit 0dd01822166eaa1addc7300fd0dba25ef66e9083
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-06-03

    rpc: Tighten attribute array check with manual enumeration
    
    CKF_ARRAY_ATTRIBUTE is not sufficient to tell if the attribute is
    an array of attributes, because the flag is also set for
    CKA_ALLOWED_MECHANISMS, which is an array of CK_MECHANISM_TYPE
    (unsigned long).  Moreover, our vendor prefix 0x58444700UL masks
    the bit.
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/attrs.h       | 10 ++++++++++
 p11-kit/rpc-client.c |  3 ++-
 p11-kit/rpc-server.c |  3 ++-
 3 files changed, 14 insertions(+), 2 deletions(-)

commit 96c7b934d1a41e85f8b0e6dfce527fd055773f65
Author: Claes Nästén <pekdon@gmail.com>
Date:   2021-04-30

    Check for SUN_LEN and provide fallback
    
    SUN_LEN is not available on Solaris 10, provide a fallback.

 common/compat.h | 10 ++++++++++
 configure.ac    |  2 +-
 meson.build     |  1 +
 3 files changed, 12 insertions(+), 1 deletion(-)

commit 6e7401e9e56b746c25acacb537187acbf53303f5
Author: Claes Nästén <pekdon@gmail.com>
Date:   2021-04-30

    Do not define _XOPEN_SOURCE in compat.c on Solaris
    
    Defining _XOPEN_SOURCE 700 on Solaris makes the compile fail due to
    a feature check in sys/feature_tests.h, C99 compiler in combination
    with < XPG6 feature set is not supported.

 common/compat.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 3ec2e9ff9a56b4c0cc6aa52daeb55deca4b0a99e
Author: Claes Nästén <pekdon@gmail.com>
Date:   2021-04-30

    make autogen.sh a bit more portable
    
    cp -v does not work on Solaris 10, nor does $() with /bin/sh so instead
    go for non verbose as -e will echo the commands performed anyway and
    use backticks.

 autogen.sh | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit b3243a754763f6df19351593781b88e277a324bc
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-05-23

    rpc-server: Disable parsing CKF_ARRAY_ATTRIBUTE
    
    This is a temporary measure to avoid oss-fuzz failure.  When the
    attribute array is nested, the current internal API cannot determine
    the actual size of data that need to be stored, because ulValueLen is
    set to the attribute count times sizeof(CK_ATTRIBUTE).
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 p11-kit/rpc-client.c | 5 +++++
 p11-kit/rpc-server.c | 5 +++++
 2 files changed, 10 insertions(+)

commit 34b568727ff98ebb36f45a3d63c07f165c58219b
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-03-27

    Update README.md

 README.md | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 0ecce9f3b99f0f699ad46495f37eb541b17c691f
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-03-27

    README.md: Suggest using only meson sub-commands instead of ninja

 README.md | 9 +++++----
 1 file changed, 5 insertions(+), 4 deletions(-)

commit 3d9e39d0173b58e66554d9b61f08d09b7db5bf43
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-03-27

    p11-kit: Add missing <limits.h> include for SIZE_MAX
    
    Spotted by Jeffrey Walton in:
    https://github.com/p11-glue/p11-kit/issues/361

 p11-kit/lists.c | 1 +
 1 file changed, 1 insertion(+)

commit bff7e36649c97aaaac29b7b16021af75386bdaee
Author: Tomas Tomecek <ttomecek@redhat.com>
Date:   2021-03-10

    packit: drop synced_files
    
    packit's default is specfile + packit.yaml, so this can be omitted:
    
    https://packit.dev/docs/configuration/#synced_files
    
    Signed-off-by: Tomas Tomecek <ttomecek@redhat.com>

 .packit.yaml | 3 ---
 1 file changed, 3 deletions(-)

commit 4711af41a2b166c0ba8cb7b508ce865727ec12d2
Author: Tomas Tomecek <ttomecek@redhat.com>
Date:   2021-03-10

    packit: fedora renamed master branch to rawhide
    
    Signed-off-by: Tomas Tomecek <ttomecek@redhat.com>

 .packit.yaml | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit be8fc2ae73ef2ed2338d0f745b6233629e4330c4
Author: Yuri Chornoivan <yurchor@ukr.net>
Date:   2021-03-06

    Fix minor typo

 trust/enumerate.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit d0742257046f656882ed3068f608f0e192aee448
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-03-06

    po: Add trust/trust.c to POTFILES.in
    
    Pointed by Piotr Drąg.

 po/POTFILES.in | 1 +
 1 file changed, 1 insertion(+)

commit 4085803ef7ad55aa1e22ee598362134116566513
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-03-06

    po: Update POTFILES.in

 po/POTFILES.in | 28 ++++++++++++++++++++++++++++
 1 file changed, 28 insertions(+)

commit cdff966cd8dc51d1cca79892565e4dab66290625
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-03-05

    trust: Make more strings translatable

 trust/anchor.c          | 47 +++++++++++++++++++++++++++--------------------
 trust/builder.c         | 47 +++++++++++++++++++++++++++--------------------
 trust/dump.c            | 11 +++++++++--
 trust/enumerate.c       | 33 ++++++++++++++++++++-------------
 trust/extract-cer.c     | 15 +++++++++++----
 trust/extract-edk2.c    |  9 ++++++++-
 trust/extract-jks.c     | 21 ++++++++++++++-------
 trust/extract-openssl.c | 11 +++++++++--
 trust/extract-pem.c     | 11 +++++++++--
 trust/extract.c         | 23 +++++++++++++++--------
 trust/list.c            | 11 +++++++++--
 trust/module.c          | 13 ++++++++++---
 trust/parser.c          | 15 +++++++++++----
 trust/persist.c         |  9 ++++++++-
 trust/save.c            | 41 ++++++++++++++++++++++++-----------------
 trust/token.c           | 23 +++++++++++++++--------
 trust/trust.c           | 12 +++++++-----
 17 files changed, 233 insertions(+), 119 deletions(-)

commit 4fc5956fcbf354d42feb3d3c6b72af26fac94436
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-03-05

    p11-kit: Make more strings translatable

 p11-kit/conf.c          | 21 ++++++++-----
 p11-kit/filter.c        |  9 +++++-
 p11-kit/lists.c         | 15 ++++++---
 p11-kit/messages.c      |  2 +-
 p11-kit/modules.c       | 41 ++++++++++++++-----------
 p11-kit/p11-kit.c       | 18 ++++++++---
 p11-kit/remote.c        | 13 ++++++--
 p11-kit/rpc-client.c    | 27 +++++++++++------
 p11-kit/rpc-message.c   | 17 ++++++++---
 p11-kit/rpc-server.c    | 31 +++++++++++--------
 p11-kit/rpc-transport.c | 71 ++++++++++++++++++++++++-------------------
 p11-kit/server.c        | 81 +++++++++++++++++++++++++++----------------------
 12 files changed, 212 insertions(+), 134 deletions(-)

commit d1134f3aad404b1eda40d4889c74065d8bd4e2ec
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-03-05

    common: Enable message translation in p11_tool_main

 common/tool.c | 45 ++++++++++++++++++++++++++++++++++++---------
 1 file changed, 36 insertions(+), 9 deletions(-)

commit 2ccffb50013a930264e151109dc3055c3bf83205
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-03-05

    meson: Make sure to set PROJECT_NAME and ENABLE_NLS for 'nls' option
    
    Pointed out by Érico Nogueira Rolim in:
    https://github.com/p11-glue/p11-kit/issues/357

 meson.build | 5 +++++
 1 file changed, 5 insertions(+)

commit 58c8ef1a02f05c22c09afacb6efb53b4f85ddf1a
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-03-03

    build: Add fuzz/meson.build in the distribution

 fuzz/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit 3e7451ecdd5c9ebca06e685ded5ceb6fb177b6b2
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-02-08

    fuzz: Move the directory out of build/
    
    The "build/" directory is mainly used for the artifacts not shipped in
    the distribution (except "build/litter" and "build/m4", which are
    populated by autotools).

 Makefile.am                                                 |   2 +-
 {build/fuzz => fuzz}/Makefile.am                            |  10 +++++-----
 {build/fuzz => fuzz}/fuzz.h                                 |   0
 {build/fuzz => fuzz}/main.c                                 |   0
 {build/fuzz => fuzz}/meson.build                            |   0
 {build/fuzz => fuzz}/rpc.in/C_CloseAllSessions_slot_one     | Bin
 {build/fuzz => fuzz}/rpc.in/C_CloseAllSessions_slot_two     | Bin
 {build/fuzz => fuzz}/rpc.in/C_CloseSession                  | Bin
 {build/fuzz => fuzz}/rpc.in/C_CopyObject_attribute_array    | Bin
 {build/fuzz => fuzz}/rpc.in/C_CopyObject_byte               | Bin
 {build/fuzz => fuzz}/rpc.in/C_CopyObject_byte_array         | Bin
 {build/fuzz => fuzz}/rpc.in/C_CopyObject_date               | Bin
 {build/fuzz => fuzz}/rpc.in/C_CopyObject_date_empty         | Bin
 {build/fuzz => fuzz}/rpc.in/C_CopyObject_invalid            | Bin
 .../fuzz => fuzz}/rpc.in/C_CopyObject_mechanism_type_array  | Bin
 {build/fuzz => fuzz}/rpc.in/C_CopyObject_ulong              | Bin
 {build/fuzz => fuzz}/rpc.in/C_CreateObject_attribute_array  | Bin
 {build/fuzz => fuzz}/rpc.in/C_CreateObject_byte             | Bin
 {build/fuzz => fuzz}/rpc.in/C_CreateObject_byte_array       | Bin
 {build/fuzz => fuzz}/rpc.in/C_CreateObject_date             | Bin
 {build/fuzz => fuzz}/rpc.in/C_CreateObject_date_empty       | Bin
 {build/fuzz => fuzz}/rpc.in/C_CreateObject_invalid          | Bin
 .../rpc.in/C_CreateObject_mechanism_type_array              | Bin
 {build/fuzz => fuzz}/rpc.in/C_CreateObject_ulong            | Bin
 {build/fuzz => fuzz}/rpc.in/C_Decrypt                       | Bin
 {build/fuzz => fuzz}/rpc.in/C_DecryptDigestUpdate           | Bin
 {build/fuzz => fuzz}/rpc.in/C_DecryptFinal                  | Bin
 {build/fuzz => fuzz}/rpc.in/C_DecryptInit                   | Bin
 {build/fuzz => fuzz}/rpc.in/C_DecryptUpdate                 | Bin
 {build/fuzz => fuzz}/rpc.in/C_DecryptVerifyUpdate           | Bin
 {build/fuzz => fuzz}/rpc.in/C_DeriveKey                     | Bin
 {build/fuzz => fuzz}/rpc.in/C_DestroyObject                 | Bin
 {build/fuzz => fuzz}/rpc.in/C_Digest                        | Bin
 {build/fuzz => fuzz}/rpc.in/C_DigestEncryptUpdate           | Bin
 {build/fuzz => fuzz}/rpc.in/C_DigestFinal                   | Bin
 {build/fuzz => fuzz}/rpc.in/C_DigestInit                    | Bin
 {build/fuzz => fuzz}/rpc.in/C_DigestKey                     | Bin
 {build/fuzz => fuzz}/rpc.in/C_DigestUpdate                  | Bin
 {build/fuzz => fuzz}/rpc.in/C_Encrypt                       | Bin
 {build/fuzz => fuzz}/rpc.in/C_EncryptFinal                  | Bin
 {build/fuzz => fuzz}/rpc.in/C_EncryptInit                   | Bin
 {build/fuzz => fuzz}/rpc.in/C_EncryptUpdate                 | Bin
 {build/fuzz => fuzz}/rpc.in/C_Finalize                      | Bin
 {build/fuzz => fuzz}/rpc.in/C_FindObjects                   | Bin
 {build/fuzz => fuzz}/rpc.in/C_FindObjectsFinal              | Bin
 .../fuzz => fuzz}/rpc.in/C_FindObjectsInit_attribute_array  | Bin
 {build/fuzz => fuzz}/rpc.in/C_FindObjectsInit_byte          | Bin
 {build/fuzz => fuzz}/rpc.in/C_FindObjectsInit_byte_array    | Bin
 {build/fuzz => fuzz}/rpc.in/C_FindObjectsInit_date          | Bin
 {build/fuzz => fuzz}/rpc.in/C_FindObjectsInit_date_empty    | Bin
 {build/fuzz => fuzz}/rpc.in/C_FindObjectsInit_invalid       | Bin
 .../rpc.in/C_FindObjectsInit_mechanism_type_array           | Bin
 {build/fuzz => fuzz}/rpc.in/C_FindObjectsInit_ulong         | Bin
 {build/fuzz => fuzz}/rpc.in/C_GenerateKeyPair               | Bin
 {build/fuzz => fuzz}/rpc.in/C_GenerateKey_attribute_array   | Bin
 {build/fuzz => fuzz}/rpc.in/C_GenerateKey_byte              | Bin
 {build/fuzz => fuzz}/rpc.in/C_GenerateKey_byte_array        | Bin
 {build/fuzz => fuzz}/rpc.in/C_GenerateKey_date              | Bin
 {build/fuzz => fuzz}/rpc.in/C_GenerateKey_date_empty        | Bin
 {build/fuzz => fuzz}/rpc.in/C_GenerateKey_invalid           | Bin
 .../fuzz => fuzz}/rpc.in/C_GenerateKey_mechanism_type_array | Bin
 {build/fuzz => fuzz}/rpc.in/C_GenerateKey_ulong             | Bin
 {build/fuzz => fuzz}/rpc.in/C_GenerateRandom                | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetAttributeValue             | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetInfo                       | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetMechanismInfo              | Bin
 .../rpc.in/C_GetMechanismInfo_slot_one_capitalize           | Bin
 .../fuzz => fuzz}/rpc.in/C_GetMechanismInfo_slot_one_prefix | Bin
 .../rpc.in/C_GetMechanismInfo_slot_two_capitalize           | Bin
 .../fuzz => fuzz}/rpc.in/C_GetMechanismInfo_slot_two_prefix | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetMechanismList              | Bin
 .../fuzz => fuzz}/rpc.in/C_GetMechanismList_slot_one_buffer | Bin
 .../fuzz => fuzz}/rpc.in/C_GetMechanismList_slot_one_length | Bin
 .../fuzz => fuzz}/rpc.in/C_GetMechanismList_slot_two_buffer | Bin
 .../fuzz => fuzz}/rpc.in/C_GetMechanismList_slot_two_length | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetObjectSize                 | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetOperationState             | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetSessionInfo                | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetSlotInfo_slot_one          | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetSlotInfo_slot_two          | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetSlotList_all_buffer        | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetSlotList_all_length        | Bin
 .../fuzz => fuzz}/rpc.in/C_GetSlotList_token_present_buffer | Bin
 .../fuzz => fuzz}/rpc.in/C_GetSlotList_token_present_length | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetTokenInfo_slot_one         | Bin
 {build/fuzz => fuzz}/rpc.in/C_GetTokenInfo_slot_two         | Bin
 {build/fuzz => fuzz}/rpc.in/C_InitPIN                       | Bin
 {build/fuzz => fuzz}/rpc.in/C_InitToken_slot_one            | Bin
 {build/fuzz => fuzz}/rpc.in/C_InitToken_slot_two            | Bin
 {build/fuzz => fuzz}/rpc.in/C_Initialize                    | Bin
 {build/fuzz => fuzz}/rpc.in/C_Login                         | Bin
 {build/fuzz => fuzz}/rpc.in/C_Logout                        | Bin
 {build/fuzz => fuzz}/rpc.in/C_OpenSession_slot_one          | Bin
 {build/fuzz => fuzz}/rpc.in/C_OpenSession_slot_two          | Bin
 {build/fuzz => fuzz}/rpc.in/C_SeedRandom                    | Bin
 .../rpc.in/C_SetAttributeValue_attribute_array              | Bin
 {build/fuzz => fuzz}/rpc.in/C_SetAttributeValue_byte        | Bin
 {build/fuzz => fuzz}/rpc.in/C_SetAttributeValue_byte_array  | Bin
 {build/fuzz => fuzz}/rpc.in/C_SetAttributeValue_date        | Bin
 {build/fuzz => fuzz}/rpc.in/C_SetAttributeValue_date_empty  | Bin
 {build/fuzz => fuzz}/rpc.in/C_SetAttributeValue_invalid     | Bin
 .../rpc.in/C_SetAttributeValue_mechanism_type_array         | Bin
 {build/fuzz => fuzz}/rpc.in/C_SetAttributeValue_ulong       | Bin
 {build/fuzz => fuzz}/rpc.in/C_SetOperationState             | Bin
 {build/fuzz => fuzz}/rpc.in/C_SetPIN                        | Bin
 {build/fuzz => fuzz}/rpc.in/C_Sign                          | Bin
 {build/fuzz => fuzz}/rpc.in/C_SignEncryptUpdate             | Bin
 {build/fuzz => fuzz}/rpc.in/C_SignFinal                     | Bin
 {build/fuzz => fuzz}/rpc.in/C_SignInit                      | Bin
 {build/fuzz => fuzz}/rpc.in/C_SignRecover                   | Bin
 {build/fuzz => fuzz}/rpc.in/C_SignRecoverInit               | Bin
 {build/fuzz => fuzz}/rpc.in/C_SignUpdate                    | Bin
 {build/fuzz => fuzz}/rpc.in/C_UnwrapKey                     | Bin
 {build/fuzz => fuzz}/rpc.in/C_Verify                        | Bin
 {build/fuzz => fuzz}/rpc.in/C_VerifyFinal                   | Bin
 {build/fuzz => fuzz}/rpc.in/C_VerifyInit                    | Bin
 {build/fuzz => fuzz}/rpc.in/C_VerifyRecover                 | Bin
 {build/fuzz => fuzz}/rpc.in/C_VerifyRecoverInit             | Bin
 {build/fuzz => fuzz}/rpc.in/C_VerifyUpdate                  | Bin
 {build/fuzz => fuzz}/rpc.in/C_WaitForSlotEvent              | Bin
 {build/fuzz => fuzz}/rpc.in/C_WrapKey                       | Bin
 {build/fuzz => fuzz}/rpc_fuzzer.c                           |   2 +-
 {build/fuzz => fuzz}/run-afl.sh                             |   0
 meson.build                                                 |   2 +-
 124 files changed, 8 insertions(+), 8 deletions(-)

commit 6aa3ce13de298c9ecaa6628c6223002590ebbdf8
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-14

    Release all library/mock resources before exit

 build/fuzz/rpc_fuzzer.c | 2 ++
 1 file changed, 2 insertions(+)

commit cf304848641b32664c72da263400e90a3c9752ce
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-14

    Add separate oss-fuzz Makefile target
    
    OSS-Fuzz infrastructure requires some slightly different build commands,
    such as using $CXX to link, and using main() from $LIB_FUZZING_ENGINE.

 build/fuzz/Makefile.am | 15 ++++++++++++++-
 1 file changed, 14 insertions(+), 1 deletion(-)

commit 22de027e72d9d696715026d657283b732010691f
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-14

    Add build targets for future additional fuzzers
    
    This could simplify a future integration with OSS-Fuzz, and the future
    addition of a second fuzzer target.

 build/fuzz/Makefile.am |  5 ++++-
 build/fuzz/meson.build | 20 +++++++++++++-------
 2 files changed, 17 insertions(+), 8 deletions(-)

commit d3dc57f0d589e62cbba45011d68f6d7933c0a859
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-07

    Build fuzzer target from meson/ninja

 build/fuzz/meson.build | 17 +++++++++++++++++
 meson.build            |  1 +
 2 files changed, 18 insertions(+)

commit c5267ff2955bc2bff8bdac2d11f71d6ec5b0c4f1
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-07

    Explicit dependency for virtual-fixed-generated.h
    
    This is needed for `make build/fuzz/rpc_fuzzer` to work from a clean
    directory.

 p11-kit/Makefile.am | 2 ++
 1 file changed, 2 insertions(+)

commit ba745124bdd0c4b13027237f7b98679c262b7a88
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-07

    Build fuzzer target from automake

 .gitignore              |  1 +
 Makefile.am             |  1 +
 build/fuzz/Makefile.am  |  5 +++++
 build/fuzz/fuzz.h       | 16 ++++++++++++++++
 build/fuzz/main.c       |  2 +-
 build/fuzz/meson.build  |  0
 build/fuzz/rpc_fuzzer.c |  4 ++--
 build/fuzz/run-afl.sh   |  2 +-
 8 files changed, 27 insertions(+), 4 deletions(-)

commit bf35d3c5aad0dc11e93321fc4540ace8063f888a
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-07

    rpc_fuzzer: Clean up buffer before exit

 build/fuzz/rpc_fuzzer.c | 2 ++
 1 file changed, 2 insertions(+)

commit b1dd01b51eaf03cb3bb38fcdeb3ff461ab88f9b3
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-06

    New set of fuzzer seeds

 build/fuzz/rpc.in/C_CloseAllSessions_slot_one         | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_CloseAllSessions_slot_two         | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_CloseSession                      | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_CopyObject_attribute_array        | Bin 0 -> 55 bytes
 build/fuzz/rpc.in/C_CopyObject_byte                   | Bin 0 -> 42 bytes
 build/fuzz/rpc.in/C_CopyObject_byte_array             | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_CopyObject_date                   | Bin 0 -> 53 bytes
 build/fuzz/rpc.in/C_CopyObject_date_empty             | Bin 0 -> 45 bytes
 build/fuzz/rpc.in/C_CopyObject_invalid                | Bin 0 -> 37 bytes
 build/fuzz/rpc.in/C_CopyObject_mechanism_type_array   | Bin 0 -> 53 bytes
 build/fuzz/rpc.in/C_CopyObject_ulong                  | Bin 0 -> 49 bytes
 build/fuzz/rpc.in/C_CreateObject_attribute_array      | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_CreateObject_byte                 | Bin 0 -> 33 bytes
 build/fuzz/rpc.in/C_CreateObject_byte_array           | Bin 0 -> 37 bytes
 build/fuzz/rpc.in/C_CreateObject_date                 | Bin 0 -> 44 bytes
 build/fuzz/rpc.in/C_CreateObject_date_empty           | Bin 0 -> 36 bytes
 build/fuzz/rpc.in/C_CreateObject_invalid              | Bin 0 -> 28 bytes
 build/fuzz/rpc.in/C_CreateObject_mechanism_type_array | Bin 0 -> 44 bytes
 build/fuzz/rpc.in/C_CreateObject_ulong                | Bin 0 -> 40 bytes
 build/fuzz/rpc.in/C_Decrypt                           | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_DecryptDigestUpdate               | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_DecryptFinal                      | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_DecryptInit                       | Bin 0 -> 35 bytes
 build/fuzz/rpc.in/C_DecryptUpdate                     | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_DecryptVerifyUpdate               | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_DeriveKey                         | Bin 0 -> 51 bytes
 build/fuzz/rpc.in/C_DestroyObject                     | Bin 0 -> 26 bytes
 build/fuzz/rpc.in/C_Digest                            | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_DigestEncryptUpdate               | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_DigestFinal                       | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_DigestInit                        | Bin 0 -> 26 bytes
 build/fuzz/rpc.in/C_DigestKey                         | Bin 0 -> 26 bytes
 build/fuzz/rpc.in/C_DigestUpdate                      | Bin 0 -> 40 bytes
 build/fuzz/rpc.in/C_Encrypt                           | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_EncryptFinal                      | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_EncryptInit                       | Bin 0 -> 35 bytes
 build/fuzz/rpc.in/C_EncryptUpdate                     | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_Finalize                          | Bin 0 -> 8 bytes
 build/fuzz/rpc.in/C_FindObjects                       | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_FindObjectsFinal                  | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_FindObjectsInit_attribute_array   | Bin 0 -> 53 bytes
 build/fuzz/rpc.in/C_FindObjectsInit_byte              | Bin 0 -> 33 bytes
 build/fuzz/rpc.in/C_FindObjectsInit_byte_array        | Bin 0 -> 37 bytes
 build/fuzz/rpc.in/C_FindObjectsInit_date              | Bin 0 -> 44 bytes
 build/fuzz/rpc.in/C_FindObjectsInit_date_empty        | Bin 0 -> 36 bytes
 build/fuzz/rpc.in/C_FindObjectsInit_invalid           | Bin 0 -> 28 bytes
 .../rpc.in/C_FindObjectsInit_mechanism_type_array     | Bin 0 -> 44 bytes
 build/fuzz/rpc.in/C_FindObjectsInit_ulong             | Bin 0 -> 40 bytes
 build/fuzz/rpc.in/C_GenerateKeyPair                   | Bin 0 -> 58 bytes
 build/fuzz/rpc.in/C_GenerateKey_attribute_array       | Bin 0 -> 62 bytes
 build/fuzz/rpc.in/C_GenerateKey_byte                  | Bin 0 -> 42 bytes
 build/fuzz/rpc.in/C_GenerateKey_byte_array            | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_GenerateKey_date                  | Bin 0 -> 53 bytes
 build/fuzz/rpc.in/C_GenerateKey_date_empty            | Bin 0 -> 45 bytes
 build/fuzz/rpc.in/C_GenerateKey_invalid               | Bin 0 -> 37 bytes
 build/fuzz/rpc.in/C_GenerateKey_mechanism_type_array  | Bin 0 -> 53 bytes
 build/fuzz/rpc.in/C_GenerateKey_ulong                 | Bin 0 -> 49 bytes
 build/fuzz/rpc.in/C_GenerateRandom                    | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_GetAttributeValue                 | Bin 0 -> 40 bytes
 build/fuzz/rpc.in/C_GetInfo                           | Bin 0 -> 8 bytes
 build/fuzz/rpc.in/C_GetMechanismInfo                  | Bin 0 -> 26 bytes
 .../rpc.in/C_GetMechanismInfo_slot_one_capitalize     | Bin 0 -> 26 bytes
 build/fuzz/rpc.in/C_GetMechanismInfo_slot_one_prefix  | Bin 0 -> 26 bytes
 .../rpc.in/C_GetMechanismInfo_slot_two_capitalize     | Bin 0 -> 26 bytes
 build/fuzz/rpc.in/C_GetMechanismInfo_slot_two_prefix  | Bin 0 -> 26 bytes
 build/fuzz/rpc.in/C_GetMechanismList                  | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_GetMechanismList_slot_one_buffer  | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_GetMechanismList_slot_one_length  | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_GetMechanismList_slot_two_buffer  | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_GetMechanismList_slot_two_length  | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_GetObjectSize                     | Bin 0 -> 26 bytes
 build/fuzz/rpc.in/C_GetOperationState                 | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_GetSessionInfo                    | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_GetSlotInfo_slot_one              | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_GetSlotInfo_slot_two              | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_GetSlotList_all_buffer            | Bin 0 -> 16 bytes
 build/fuzz/rpc.in/C_GetSlotList_all_length            | Bin 0 -> 16 bytes
 build/fuzz/rpc.in/C_GetSlotList_token_present_buffer  | Bin 0 -> 16 bytes
 build/fuzz/rpc.in/C_GetSlotList_token_present_length  | Bin 0 -> 16 bytes
 build/fuzz/rpc.in/C_GetTokenInfo_slot_one             | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_GetTokenInfo_slot_two             | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_InitPIN                           | Bin 0 -> 32 bytes
 build/fuzz/rpc.in/C_InitToken_slot_one                | Bin 0 -> 47 bytes
 build/fuzz/rpc.in/C_InitToken_slot_two                | Bin 0 -> 47 bytes
 build/fuzz/rpc.in/C_Initialize                        | Bin 0 -> 66 bytes
 build/fuzz/rpc.in/C_Login                             | Bin 0 -> 33 bytes
 build/fuzz/rpc.in/C_Logout                            | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_OpenSession_slot_one              | Bin 0 -> 26 bytes
 build/fuzz/rpc.in/C_OpenSession_slot_two              | Bin 0 -> 26 bytes
 build/fuzz/rpc.in/C_SeedRandom                        | Bin 0 -> 40 bytes
 build/fuzz/rpc.in/C_SetAttributeValue_attribute_array | Bin 0 -> 55 bytes
 build/fuzz/rpc.in/C_SetAttributeValue_byte            | Bin 0 -> 42 bytes
 build/fuzz/rpc.in/C_SetAttributeValue_byte_array      | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_SetAttributeValue_date            | Bin 0 -> 53 bytes
 build/fuzz/rpc.in/C_SetAttributeValue_date_empty      | Bin 0 -> 45 bytes
 build/fuzz/rpc.in/C_SetAttributeValue_invalid         | Bin 0 -> 37 bytes
 .../rpc.in/C_SetAttributeValue_mechanism_type_array   | Bin 0 -> 53 bytes
 build/fuzz/rpc.in/C_SetAttributeValue_ulong           | Bin 0 -> 49 bytes
 build/fuzz/rpc.in/C_SetOperationState                 | Bin 0 -> 42 bytes
 build/fuzz/rpc.in/C_SetPIN                            | Bin 0 -> 43 bytes
 build/fuzz/rpc.in/C_Sign                              | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_SignEncryptUpdate                 | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_SignFinal                         | Bin 0 -> 23 bytes
 build/fuzz/rpc.in/C_SignInit                          | Bin 0 -> 35 bytes
 build/fuzz/rpc.in/C_SignRecover                       | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_SignRecoverInit                   | Bin 0 -> 35 bytes
 build/fuzz/rpc.in/C_SignUpdate                        | Bin 0 -> 40 bytes
 build/fuzz/rpc.in/C_UnwrapKey                         | Bin 0 -> 74 bytes
 build/fuzz/rpc.in/C_Verify                            | Bin 0 -> 63 bytes
 build/fuzz/rpc.in/C_VerifyFinal                       | Bin 0 -> 40 bytes
 build/fuzz/rpc.in/C_VerifyInit                        | Bin 0 -> 35 bytes
 build/fuzz/rpc.in/C_VerifyRecover                     | Bin 0 -> 46 bytes
 build/fuzz/rpc.in/C_VerifyRecoverInit                 | Bin 0 -> 35 bytes
 build/fuzz/rpc.in/C_VerifyUpdate                      | Bin 0 -> 40 bytes
 build/fuzz/rpc.in/C_WaitForSlotEvent                  | Bin 0 -> 17 bytes
 build/fuzz/rpc.in/C_WrapKey                           | Bin 0 -> 50 bytes
 build/fuzz/rpc.in/transcript                          | Bin 146 -> 0 bytes
 build/fuzz/transcript                                 | Bin 5694933 -> 0 bytes
 118 files changed, 0 insertions(+), 0 deletions(-)

commit de69504632b01d72e996f037baf406d994dd4aac
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-02-07

    github: Remove unnecessary SRCDIR envvar

 .github/actions/basic-autotools/action.yaml |  8 ++++----
 .github/actions/basic-meson/action.yaml     |  2 --
 .github/workflows/test.yaml                 | 28 ++++++----------------------
 3 files changed, 10 insertions(+), 28 deletions(-)

commit 58b14b33421064754732501e1eb67c90d8a24744
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-02-07

    github: Use runuser instead of su for building and testing
    
    Also run the install phase as root to emulate the practical situation.

 .github/actions/basic-autotools/action.yaml | 23 +++++++++++++++--------
 .github/actions/basic-meson/action.yaml     | 15 ++++++++-------
 .github/workflows/test.yaml                 |  7 ++++---
 3 files changed, 27 insertions(+), 18 deletions(-)

commit 58b7336ca3891fb36ac2fa2b35298f2c57fb1561
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-02-06

    github: Use composite action to simplify the main recipe

 .github/actions/basic-autotools/action.yaml |  39 ++++++++
 .github/actions/basic-meson/action.yaml     |  38 +++++++
 .github/workflows/test.yaml                 | 148 +++++-----------------------
 3 files changed, 103 insertions(+), 122 deletions(-)

commit 98a7787565ef6bdf18617640968ffb717697254b
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-02-06

    github: Use pre-built container image for building

 .github/workflows/test.yaml | 57 ++++++---------------------------------------
 1 file changed, 7 insertions(+), 50 deletions(-)

commit c680fca15ebc1765ba1d07c9fc5c226fd00019e5
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-02-06

    README.md: Add GitHub workflow status

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 23beb5974246b7c85ed4e3b800f2590855187cf6
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-02-06

    travis: Remove configurations other than FreeBSD

 .travis.yml | 36 ------------------------------------
 1 file changed, 36 deletions(-)

commit 36eb32316b7b67b1d3b4838ee5560becd4d345bd
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-02-06

    autotools: Fix for VPATH build
    
    Since adbb94ea3ec3c39b71c05eff8ef86cc85a075955, we always
    generate *.asn.h file at build time.  This caused a build problem if
    p11-kit is built with an out-of-tree build directory.
    
    Reported by Pavel Heimlich in:
    https://github.com/p11-glue/p11-kit/issues/348

 trust/Makefile.am | 4 ++++
 1 file changed, 4 insertions(+)

commit 805f0ec64070ae942e7f208c2d171a6b47960081
Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   2020-10-30

    github actions: Initial CI setup
    
    Signed-off-by: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>

 .github/workflows/test.yaml | 244 ++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 244 insertions(+)

commit fc852e1a04628a4b3f46a0b34f1ed164fda571e4
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-01-28

    modules: p11_kit_initialize_module: Remove redundant module unref
    
    For unmanaged modules, p11_module_release_inlock_reentrant simply
    decrease the reference count.  However, it should have been
    incremented only if initialize_module_inlock_reentrant call above
    succeeds.

 p11-kit/modules.c | 1 -
 1 file changed, 1 deletion(-)

commit 6a7558b23793cb25aad1a2cfc1310c9eb80d028f
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-01-28

    server: Account for NUL byte at the end of Unix domain socket path

 p11-kit/server.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2ab82c324aa67a57927b7f59efa06d93ee5bbfcf
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-12-15

    compat: Expose FreeBSD specific issetugid, getresuid, and getresgid

 common/compat.c | 9 +++++++++
 1 file changed, 9 insertions(+)

commit bd14b7d65b4bf2929e8793debeeba42cd7d2c757
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-12-15

    compat: Remove <unistd.h> inclusion from compat.h
    
    The header should be included from the C files instead for Unix
    specific features.

 common/compat.c          | 5 +++--
 common/compat.h          | 1 -
 common/test-compat.c     | 3 +++
 common/vsock.c           | 3 +++
 p11-kit/conf.c           | 3 +++
 p11-kit/test-managed.c   | 1 +
 p11-kit/test-rpc.c       | 3 +++
 p11-kit/test-transport.c | 1 +
 trust/test-token.c       | 3 +++
 trust/token.c            | 3 +++
 10 files changed, 23 insertions(+), 3 deletions(-)

commit 1515a8dad4131cff456be57a281b2b5eb766f229
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-12-13

    compat: Avoid unused variables warning in fdwalk emulation

 common/compat.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit 40fbf74b02b8ad6625e3aa49d2cdef2b52e47a04
Author: Daiki Ueno <ueno@gnu.org>
Date:   2021-01-25

    compat: Pacify ASan complaints on intentionally leaked buffer
    
    Reported by Viktor Ashirov in:
    https://bugzilla.redhat.com/show_bug.cgi?id=1905581

 common/compat.c  | 25 +++++++++++++++++++------
 common/library.c |  9 +++++++++
 2 files changed, 28 insertions(+), 6 deletions(-)

commit a91266ef087532e2332c75c4fd9244df66f30b64
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-12-18

    meson: Link trust/client modules explicitly to -ldl
    
    This adds the -ldl link flag missing in the meson build, but present
    in the autotools build.  Although the use-case is unlikely, this
    allows those modules to be linked as a normal shared library to a
    program.

 p11-kit/meson.build | 1 +
 trust/meson.build   | 2 +-
 2 files changed, 2 insertions(+), 1 deletion(-)

commit 507c394cfcf4edffc5e4450c5d737e545c26b857
Author: Daniel Engberg <daniel.engberg.lists@pyret.net>
Date:   2020-12-12

    p11-kit/lists.c: Add stdint.h to fix compilation
    
    Add stdint.h otherwise compilation fails on FreeBSD 13-CURRENT with "use of undeclared identifier 'SIZE_MAX'"
    
    Signed-off-by: Daniel Engberg <daniel.engberg.lists@pyret.net>

 p11-kit/lists.c | 1 +
 1 file changed, 1 insertion(+)

commit 7f032183dfd36c1f91d2400ceb5bbc90376a310c
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-14

    Follow-up to arithmetic overflow fix
    
    Check if nmemb is zero in p11_rpc_message_alloc_extra_array to avoid a
    division by zero trap. Additionally, change the reallocarray
    compatibility shim so that it won't assert when resizing an array to
    zero, and add the same nmemb != 0 check there.

 common/compat.c       | 4 ++--
 p11-kit/rpc-message.c | 2 +-
 2 files changed, 3 insertions(+), 3 deletions(-)

commit 6c1c94bd2360f5778beb397ba5508d5084b7f0ee
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-07

    Check for arithmetic overflows before allocating

 p11-kit/iter.c        |  4 ++--
 p11-kit/lists.c       |  2 ++
 p11-kit/proxy.c       |  2 +-
 p11-kit/rpc-message.c | 13 +++++++++++++
 p11-kit/rpc-message.h |  4 ++++
 p11-kit/rpc-server.c  |  8 ++++----
 trust/index.c         |  4 ++--
 7 files changed, 28 insertions(+), 9 deletions(-)

commit 7625cfcebccf1c02d17e9295e1d883ea688ea264
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-07

    Check attribute length against buffer size
    
    If an attribute's length does not match the length of the byte array
    inside it, one length was used for allocation, and the other was used
    for memcpy. This additional check will instead return an error on
    malformed messages.

 p11-kit/rpc-message.c | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit 69d751ca9df9ac101adfb1e5aa7e83e3358106ba
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-06

    Fix bounds check in p11_rpc_buffer_get_byte_array
    
    This bounds check should be using off, not *offset, because it has been
    advanced four bytes from reading a uint32 earlier in the function.
    Additionally, the pointer that is returned is computed using off, not
    *offset.

 p11-kit/rpc-message.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit bb3a3cb1cb4ae8341fa1cf1cc4e9f282c7c74b76
Author: David Cook <divergentdave@gmail.com>
Date:   2020-11-06

    Fix buffer overflow in log_token_info
    
    The utcTime field in CK_TOKEN_INFO is not null terminated, so a length
    must be provided when copying it. This call to p11_buffer_add with a
    length of -1 was reading past the end of the string, and off the end of
    the stack.

 p11-kit/log.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ee45d7df8cbd28b1a5cc6304c7d420ca94afb145
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-11-28

    common: Don't assume __STDC_VERSION__ is always defined
    
    Old compilers may not define __STDC_VERSION__:
    https://sourceforge.net/p/predef/wiki/Standards/
    
    Reported by dirkf in:
    https://github.com/p11-glue/p11-kit/issues/337

 common/compat.h | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f60d22f8cadc4f9b40aa3ee00ab575a8f5a00f74
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-12-03

    compat: getauxval: correct compiler macro for FreeBSD
    
    It should be __FreeBSD__ instead of __FREEBSD__:
    https://sourceforge.net/p/predef/wiki/OperatingSystems/

 common/compat.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 255a6a01f383db7c4c510f22c20db6e7011d38b1
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-12-03

    compat: fdwalk: add guard for Linux specific local variables

 common/compat.c | 7 ++++---
 1 file changed, 4 insertions(+), 3 deletions(-)

commit dfb85f5e8d84d3bd55d4a735aea2e642b8c00a5e
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-12-03

    meson: Add missing libtasn1 dependency

 trust/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1895415899d1a578f3e64682a8f1ce8a52a9394f
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-12-02

    travis: Add freebsd build

 .travis.yml                       | 1 +
 .travis/freebsd/after_failure.sh  | 3 +++
 .travis/freebsd/before_install.sh | 5 +++++
 .travis/freebsd/script.sh         | 6 ++++++
 4 files changed, 15 insertions(+)

commit 7e7f5b1a02f7fc67313289bde347739ff5438c4a
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-11-06

    anchor: Prefer persistent format when storing anchor
    
    When a new certificate is stored with "trust anchor --store" from a
    .p11-kit file, the command treated it as a PEM file, while it should
    preserve extra fields in the file.

 trust/anchor.c        |  7 ++++---
 trust/test-extract.sh | 27 ++++++++++++++++++++++++---
 2 files changed, 28 insertions(+), 6 deletions(-)

commit bd7702ff1b4e154e643a444746c5023fed6116ee
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-11-29

    travis: Run "make check" along with "make distcheck" for coverage

 .travis/autotools/script.sh | 5 +++++
 1 file changed, 5 insertions(+)

commit 550bb23fc2edc9b5704ffd7d7bfd301627418ea4
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-11-29

    travis: Use python3 as the default Python interpreter

 .travis/autotools/after_success.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ea0528177b2a4faaa3b28f93e64162ead5d54ccd
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-11-29

    travis: Route to Ubuntu 20.04 base image
    
    Fedora 33 image doesn't work well under the the default image based on
    Ubuntu 16.04.

 .travis.yml | 7 +++++++
 1 file changed, 7 insertions(+)

commit 6ea0ff7be226b4b1cd0eef0a127d48298ead5393
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-11-07

    meson: Set -fstack-protector for MinGW64 cross build
    
    This fixes CI failures caused by:
    https://sourceforge.net/p/mingw-w64/bugs/818/

 build/cross_file_mingw64.txt | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit e1899c41220aa5a2dbb373d5ce740b25ef4fd384
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-11-27

    meson: expand ternary operator in function call for compatibility
    
    While the minimum version requirement of meson is 0.49, the current
    meson.build causes the parser crash, because of the use of a ternary
    operator inside a function call:
    https://github.com/mesonbuild/meson/issues/5003

 meson.build | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit 8e58477c68c77ef2c29a3fc7d728220929c0996f
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-11-20

    meson: Use custom_target for generating external XML entities
    
    configure_file() adds a trailing newline, and thus the resulting
    document contains unwanted spaces between the resolved entities and
    the following text.  Instead, use custom_target() along with 'echo -n'
    to generate the XML entity files.

 doc/manual/meson.build | 35 ++++++++++++++++++++++-------------
 1 file changed, 22 insertions(+), 13 deletions(-)

commit 75fd5515553a299831099a0a5ec98afc441d0cf9
Author: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
Date:   2020-11-16

    meson: Allow building manpages without gtk-doc
    
    Fixes https://github.com/p11-glue/p11-kit/issues/331

 doc/manual/meson.build | 30 +++++++++++++++---------------
 1 file changed, 15 insertions(+), 15 deletions(-)

commit ce66cf00b6b207c1d452af23cb062ca0adf57dac
Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   2020-10-27

    Rename is_path_component to is_path_separator
    
    Thanks to Daiki Ueno for noticing the misnaming.

 common/path.c | 26 +++++++++++++-------------
 1 file changed, 13 insertions(+), 13 deletions(-)

commit e5a1f444b7d299e77dd57862f3cc5783e697a10e
Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   2020-10-27

    Use is_path_component in one more place

 common/path.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1eac9a1c41828d5da4b640746e0002c7ab964e8e
Author: Alexander Sosedkin <asosedkin@redhat.com>
Date:   2020-10-27

    Remove more duplicate separators in p11_path_build
    
    Makes p11_path_build remove duplicate separators more thoroughly,
    e.g., after a "" or in the first argument.

 common/path.c      | 26 +++++++++++++++++++-------
 common/test-path.c | 22 ++++++++++++++++++++++
 2 files changed, 41 insertions(+), 7 deletions(-)

commit de661c41a1e7e52296c91b9caa0bff8e4885c751
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-10-22

    common: Fix infloop in p11_path_build
    
    If p11_path_build is called with 2 or more arguments and the non-first
    argument is an empty string (""), it previously fell into an infloop.
    
    Reported by Karel Srot.

 common/path.c      | 4 +++-
 common/test-path.c | 4 ++++
 2 files changed, 7 insertions(+), 1 deletion(-)

commit 47fabc2366d917e255241c41a6cfc179af372644
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-10-04

    Use inclusive language on certificate distrust

 bash-completion/trust                              |   2 +-
 build/certs/Makefile                               |   2 +-
 common/pkcs11x.h                                   |   2 +-
 doc/manual/p11-kit-devel.xml                       |   2 +-
 doc/manual/p11-kit-trust.xml                       |   8 +--
 doc/manual/trust.xml                               |  24 ++++-----
 trust/builder.c                                    |   6 +--
 trust/enumerate.c                                  |  60 ++++++++++-----------
 trust/enumerate.h                                  |   6 +--
 trust/extract-openssl.c                            |   2 +-
 trust/extract.c                                    |   8 +--
 .../input/{blacklist => blocklist}/self-server.der | Bin
 trust/list.c                                       |   6 +--
 trust/oid.h                                        |  11 ++--
 trust/parser.c                                     |  18 +++----
 trust/parser.h                                     |   2 +-
 trust/test-enumerate.c                             |   6 +--
 trust/test-extract.sh                              |  16 +++---
 trust/test-openssl.c                               |   4 +-
 trust/test-parser.c                                |   4 +-
 trust/test-token.c                                 |  16 +++---
 trust/token.c                                      |  16 +++---
 22 files changed, 110 insertions(+), 111 deletions(-)

commit 0a1263a41d4c482f50aa5c4643f9de38fda44bbd
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-10-05

    proxy: C_CloseAllSessions: Make sure that calloc args are non-zero
    
    This prevents efence warning if either of the calloc arguments is
    zero.  While it is is safe on glibc systems, POSIX says the behavior
    is implementation-defined.
    
    Reported by Paul Wouters.

 p11-kit/proxy.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 08fcec713c1d3038f706d049910bd13a8c811fb5
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-10-05

    build: Use calloc in a consistent manner

 common/dict.c   | 6 +++---
 p11-kit/proxy.c | 4 ++--
 2 files changed, 5 insertions(+), 5 deletions(-)

commit 565ba5d6de58d4b210435b786ae0d753e044901c
Author: John Hein <dkeabg7vp4@snkmail.com>
Date:   2020-09-23

    meson: Allow override of default bashcompdir.
    Fixes meson regression (issue #322).  Pass -Dbashcompdir=/xxx to meson.

 bash-completion/meson.build | 16 ++++++++++------
 meson_options.txt           |  4 ++++
 2 files changed, 14 insertions(+), 6 deletions(-)

commit 56251aa50783cdd465877d28c8f017ae16c61f79
Author: Tavian Barnes <tavianator@tavianator.com>
Date:   2020-09-06

    common: Check for a NULL locale before freeing it
    
    If newlocale() fails, (locale_t) 0 ends up being passed to freelocale(),
    resulting in a segfault when the library is unloaded.

 common/library.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 2c40a4a55efa8c1bce0f7aadd5135be705565610
Author: Anders Kaseorg <andersk@mit.edu>
Date:   2020-08-30

    p11_test_copy_setgid: Skip setgid tests on nosuid filesystems
    
    Some build environments build packages from a build directory mounted
    nosuid, causing p11_test_copy_setgid to fail.  Skip the test in this
    case.
    
    Signed-off-by: Anders Kaseorg <andersk@mit.edu>

 common/test.c | 8 ++++++++
 1 file changed, 8 insertions(+)

commit 8b5a10e7ed74b6839e5e415d47b263d26c63e572
Author: Rosen Penev <rosenp@gmail.com>
Date:   2020-08-27

    unix-peer: replace incorrect include1
    
    Fixes musl warning:
    
    warning: #warning redirecting incorrect #include <sys/errno.h> to <errno.h> [-Wcpp]

 common/unix-peer.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit a26d0b052c32fbd9c7ef468bd4188fa8fa03499a
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-21

    test-compat: Skip getprogname test if BUILDDIR contains a symlink

 common/test-compat.c | 15 +++++++++++++++
 1 file changed, 15 insertions(+)

commit 7f59a79179b978e867c9def56475bfb877024312
Author: Xℹ Ruoyao <xry111@mengyan1223.wang>
Date:   2020-08-19

    add trust-extract-compat into EXTRA-DIST

 trust/Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit 1a21df391691d9a9c7b5ebc77022385f7feb266b
Author: Xℹ Ruoyao <xry111@mengyan1223.wang>
Date:   2020-08-19

    meson: install trust-extract-compat

 trust/meson.build | 3 +++
 1 file changed, 3 insertions(+)

commit 49e9b47c9546525e29b25c707068770e12add45f
Author: Xℹ Ruoyao <xry111@mengyan1223.wang>
Date:   2020-08-19

    rename trust-extract-compat.in to trust-extract-compat
    
    There is no substitution in this file, so it's unnecessary to have a .in
    file.

 configure.ac                                            | 1 -
 trust/{trust-extract-compat.in => trust-extract-compat} | 0
 2 files changed, 1 deletion(-)

commit fd8b56f3ee971f94dc6fc95411fc01e1c12153ab
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-18

    autotools: Fix SUFFIXES usage
    
    SUFFIXES must be defined in the top-level Makefile.am, when
    non-recursive make is used.

 Makefile.am         | 2 ++
 p11-kit/Makefile.am | 2 +-
 trust/Makefile.am   | 2 +-
 3 files changed, 4 insertions(+), 2 deletions(-)

commit 3c1304caae967b7cca40aae70c47c7f5138ea945
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-18

    Release 0.23.21

 NEWS         | 6 ++++++
 configure.ac | 2 +-
 meson.build  | 2 +-
 3 files changed, 8 insertions(+), 2 deletions(-)

commit 43961d4e9bdceee241ce25877aad327d4daa5a10
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-18

    packit: Adjust to doing propose-update through /packit comment

 .packit.yaml | 30 +++++++++++++++---------------
 1 file changed, 15 insertions(+), 15 deletions(-)

commit b40f27af28406810d0f42a29b98086fb02173f0c
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-18

    README.md: Fix whitespace problem

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 76f94b4ad111c4150a16d36aafd30ab8aa274a68
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-18

    conf: Add internal option to forcibly enable user config
    
    Some tests need user config enabled, though it is disabled under
    certain conditions (e.g., running as root) and makes those tests fail.

 p11-kit/conf.c            | 5 ++++-
 p11-kit/test-conf.c       | 7 +++++++
 p11-kit/test-deprecated.c | 4 ++++
 p11-kit/test-modules.c    | 4 ++++
 p11-kit/test-transport.c  | 4 ++++
 5 files changed, 23 insertions(+), 1 deletion(-)

commit 46c2ff05bf92e73735575aeb8bb9b9bec545f33c
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-18

    SECURITY.md: Split from README.md

 README.md   | 17 +----------------
 SECURITY.md |  5 +++++
 2 files changed, 6 insertions(+), 16 deletions(-)

commit da01718924623c1502eb45b7c946d6df798ea1be
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-18

    README.md: Add LGTM badges

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit adbb94ea3ec3c39b71c05eff8ef86cc85a075955
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-15

    trust: Remove generated *.asn.h files from repository

 .gitignore          |   1 +
 configure.ac        |   1 +
 trust/Makefile.am   |  25 ++--
 trust/basic.asn.h   |  13 --
 trust/meson.build   |  43 +++---
 trust/openssl.asn.h |  26 ----
 trust/pkix.asn.h    | 366 ----------------------------------------------------
 7 files changed, 45 insertions(+), 430 deletions(-)

commit 015fe112def654cac562b85ca864dc279ca4e897
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-15

    uri: Limit characters in vendor query attribute names

 p11-kit/uri.c | 9 +++++++--
 1 file changed, 7 insertions(+), 2 deletions(-)

commit 6f58217fd0590a52137b0d350d07cb4408a1bd77
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-15

    compat: Define static assertion macro

 common/compat.h       | 7 +++++++
 p11-kit/rpc-message.c | 8 ++------
 2 files changed, 9 insertions(+), 6 deletions(-)

commit 4e597e1858a3842798e8400eb2ac886612c1c6bf
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-14

    rpc-transport: Remove pointless FIXME comments
    
    Those actually shouldn't be closed.

 p11-kit/rpc-transport.c | 2 --
 1 file changed, 2 deletions(-)

commit d3dc234ce2ff08d0d7f29b4c464fb5a3406c341d
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-14

    trust: p11_index_snapshot: Remove redundant integer range check

 trust/index.c | 3 ---
 1 file changed, 3 deletions(-)

commit 4e9ca11deaab88f1297c812af55dfb0036d1e207
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-14

    build: Add header guards
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/init.h | 5 +++++
 1 file changed, 5 insertions(+)

commit a88e7c1cc9b23f1310f3dd1a6922e270aed524eb
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-14

    common/frob-getprogname: Avoid shadowing function parameter
    
    Signed-off-by: Daiki Ueno <ueno@gnu.org>

 common/frob-getprogname.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit d70d572610cd3ec7e246e898e93300615a02b267
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-14

    server: Avoid shadowing global variable

 p11-kit/server.c | 15 ++++++---------
 1 file changed, 6 insertions(+), 9 deletions(-)

commit 82374159ca3a5c0c252b2862a32dd96baeee1812
Author: David Halls <dahalls@gmail.com>
Date:   2019-12-14

    If server returns already initialized, don't mark as not initialized

 p11-kit/rpc-client.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 15f15549bf41dfe665583d4c1fe316a524939075
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-02

    common: Get program name based on executable path if possible
    
    Some programs (e.g., Chromium) pack command line arguments into argv[0].
    Check if it is the case by reading /proc/self/exe and extract the
    program name.
    
    Logic borrowed from:
    <https://github.com/mesa3d/mesa/commit/759b94038987bb983398cd4b1d2cb1c8f79817a9>.

 .gitignore                |   1 +
 common/Makefile.am        |   7 +++
 common/compat.c           |  29 +++++++++++
 common/frob-getprogname.c | 120 ++++++++++++++++++++++++++++++++++++++++++++++
 common/meson.build        |   5 ++
 common/test-compat.c      |  15 ++++++
 6 files changed, 177 insertions(+)

commit d10c5a35695df82f81f22c1e7d026be07c21aec5
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-02

    trust: Avoid uninitialized variable in session_for_store_on_module
    
    This suppresses the cppcheck error:
      trust/anchor.c:243,error,uninitvar,Uninitialized variable: count
    
    Also fixes calloc invocation when the slot count is 0.

 trust/anchor.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit e4f65d88076bf915dd969efd03b7d994196b7fa9
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-02

    test: Avoid uninitialized variable
    
    This suppresses the cppcheck error:
      p11-kit/test-deprecated.c:481,error,uninitvar,Uninitialized variable: manufacturerID

 p11-kit/test-deprecated.c | 1 +
 1 file changed, 1 insertion(+)

commit 5b6c66ec1121527a5db4339ff509a8fe6fdbc262
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-02

    mock: Avoid uninitialized variable in test_find_objects
    
    This suppresses the cppcheck errors:
      p11-kit/test-mock.c:769,error,uninitvar,Uninitialized variable: count
      p11-kit/test-mock.c:776,error,uninitvar,Uninitialized variable: count
      p11-kit/test-mock.c:783,error,uninitvar,Uninitialized variable: count

 p11-kit/test-mock.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6242c67ed70ee95174267259ca804fd671725d91
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-08-02

    constants: Tighten handling of failure case in lookup_info
    
    This suppresses the cppcheck error:
      common/constants.c:649,error,invalidFunctionArg,Invalid bsearch() argument nr 3. The value is -1 but the valid values are '0:'.

 common/constants.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 5e98a5471fa9cf136e092c279c72ff53ddebf76d
Author: Kai Takahashi <www.carrotsoft@gmail.com>
Date:   2020-08-02

    Avoid using setenv() for MinGW users.
    
    Signed-off-by: Kai Takahashi <www.carrotsoft@gmail.com>

 common/tool.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 714b216bbbaecf188685dddd98dd184e6c2721f4
Author: Albert Chin-A-Young <china@thewrittenword.com>
Date:   2020-07-25

    p11-kit/modules.c: Avoid passing 0 as first argument to calloc().
      Solves an issue #303 for AIX.

 p11-kit/modules.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 7f5ef7c04a24ede94a31a7e7820d9d03b9522bd5
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-06-12

    anchor: Exit with non-zero code, if any error occurs
    
    Suggested by Nikos Mavrogiannopoulos in:
    https://github.com/p11-glue/p11-kit/issues/300

 trust/anchor.c | 35 ++++++++++++++++++++++++-----------
 1 file changed, 24 insertions(+), 11 deletions(-)

commit 51cd2fdd844772eae874e1d6060a8cae6ad15760
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-06-12

    tool: Don't override P11_KIT_DEBUG if it is already set

 common/tool.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit a9e5fe3968759f4b4e7948c231917ffda18f0c7b
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-06-12

    tool: Print messages by default

 common/tool.c | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit 71fdb9f5c4362c00bd9684793775f8ccc7ba6166
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-06-12

    debug: Remove unused debug_inited flag

 common/debug.c | 2 --
 1 file changed, 2 deletions(-)

commit 56be8eae5cc337659eaddb07c502e901be8db203
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-06-12

    meson: Fix typo

 doc/manual/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 47e0c1fec418df1bbf2a056f1e983b64e3e23df0
Author: Daiki Ueno <ueno@gnu.org>
Date:   2020-05-30

    trust/*.asn: Drop standard types

 trust/basic.asn.h   |   2 +-
 trust/openssl.asn   |   3 --
 trust/openssl.asn.h |   8 ++---
 trust/pkix.asn      |  26 --------------
 trust/pkix.asn.h    | 102 ++++++++++++++++------------------------------------
 5 files changed, 34 insertions(+), 107 deletions(-)

commit adf2685b23b8a631e8092aaf707cd1bcf7b230bb
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-05-17

    README.md: Fix typo

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7eb041e573a5dd55cea97427ab1807772c0a7c83
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-05-17

    README.md: Revamp and add build instruction
    
    Also mention the required options for local installation.
    Suggested by Andrew Johnson in:
    https://github.com/p11-glue/p11-kit/issues/295

 README.md | 31 ++++++++++++++++++++++---------
 1 file changed, 22 insertions(+), 9 deletions(-)

commit 4ea7cf7e819bbf8415a2aad2c99e7aa0f7fa143d
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-05-17

    meson: Add option to control bash-completion installation

 bash-completion/meson.build | 2 +-
 meson_options.txt           | 4 ++++
 2 files changed, 5 insertions(+), 1 deletion(-)

commit e0053798510a56057b7a77bb3c59e68725888200
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-04-13

    test-token: Check if the path is actually writable
    
    Instead of assuming a normal user cannot write to "/", this creates an
    unwritable directly and checks if it is writable; otherwise the test
    case is skipped.
    
    Reported by Jeffrey Walton in:
    https://github.com/p11-glue/p11-kit/issues/288

 trust/test-token.c | 63 ++++++++++++++++++++++++++++++++++++++++++------------
 1 file changed, 49 insertions(+), 14 deletions(-)

commit c1c71b03e08ffb9384438e7f94b1b8f699dce2cd
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-04-13

    test: Make p11_test_{skip,todo} actually work

 common/test.c | 6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit 825fd4e4526589eb73a54ada18127196fb65fde3
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-04-13

    meson: Add option to disable building test programs
    
    Suggested by Daniel Engberg in:
    https://github.com/p11-glue/p11-kit/issues/285

 common/meson.build  |  88 +++++++++---------
 meson_options.txt   |   4 +
 p11-kit/meson.build | 252 +++++++++++++++++++++++++++-------------------------
 trust/meson.build   | 148 +++++++++++++++---------------
 4 files changed, 256 insertions(+), 236 deletions(-)

commit 3de74dc6d916ce3dd2f76f0403be189387fe4d89
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-04-13

    meson: Add option to disable NLS support
    
    Suggested by Daniel Engberg in:
    https://github.com/p11-glue/p11-kit/issues/284

 meson.build       | 4 +++-
 meson_options.txt | 4 ++++
 2 files changed, 7 insertions(+), 1 deletion(-)

commit 99aa8329841b986380cc4f515d57f118f40158c4
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-04-13

    test-rpc: Suppress compiler warning on ILP32 platforms
    
    On ILP32 platforms CK_ULONG is 32-bit and 64-bit values are truncated.
    This patch determins the usable value from SIZEOF_UNSIGNED_LONG.
    Also, for consistency, use UINTxx_MAX for other accessors.
    
    Reported by Jeffrey Walton in:
    https://github.com/p11-glue/p11-kit/issues/289

 p11-kit/test-rpc.c | 47 ++++++++++++++++++++++++++++-------------------
 1 file changed, 28 insertions(+), 19 deletions(-)

commit 3eb79b75c2ee9870352fe4acc1ef6c8783364800
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-02-07

    rpc: Add missing null checks in attribute value serializers
    
    To get the length of an attribute value, the client calls
    C_GetAttributeValue with attr->pValue set to NULL and attr->ulValueLen
    set to -1.  In the RPC level, this is already indicated with a
    'validity' flag, but there were a couple of places where attr->pValue
    is non-NULL.
    
    This was uncovered by:
    https://bugzilla.redhat.com/show_bug.cgi?id=1766340

 p11-kit/rpc-message.c | 23 ++++++++++++++---------
 1 file changed, 14 insertions(+), 9 deletions(-)

commit 04cbdcf546f88d666fcb214ce42e777fa7840732
Author: Alvin Chen <sonoma001@gmail.com>
Date:   2020-03-02

    Update pkcs11 header to allow TPM2-PKCS11 to compile

 common/pkcs11.h | 2 ++
 1 file changed, 2 insertions(+)

commit 51c0781410cb1292d7efbafee23ee5876c9bd2e4
Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   2020-02-18

    test-proxy: Add test for slot ID reuse
    
    The test covers a case where duplicate slots IDs were assigned to two
    different slots in the mapping.
    
    Signed-off-by: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>

 p11-kit/Makefile.am       |   7 ++-
 p11-kit/meson.build       |   3 +-
 p11-kit/mock-module-ep8.c | 110 ++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/test-proxy.c      |  39 ++++++++++++++++
 4 files changed, 157 insertions(+), 2 deletions(-)

commit c8f8053edc9098fdb36fbb34165b8d92ed596798
Author: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>
Date:   2020-02-17

    proxy: Fix slot ID reuse, avoiding duplicating IDs
    
    Previously, when re-mapping the slots, a slot ID could be assigned to
    more than one device, causing errors when searching for the right
    mapping (it would use the first found).
    
    Also assign new slot IDs for new found slots, avoiding previously used
    slot IDs.  The last assigned slot ID is stored in the proxy structure
    in a new added field last_id.
    
    Signed-off-by: Anderson Toshiyuki Sasaki <ansasaki@redhat.com>

 p11-kit/proxy.c | 56 +++++++++++++++++++++++++++++++++++++-------------------
 1 file changed, 37 insertions(+), 19 deletions(-)

commit da22fd9f2a54d707db7f3021f22416b4af496ae8
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-30

    packit: Enable Fedora package building with Packit

 .packit.yaml | 24 ++++++++++++++++++++++++
 1 file changed, 24 insertions(+)

commit 762cdaa2cd5c5ec09cc844f9a6bdc551c7f6c8ed
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-29

    Release 0.23.20

 NEWS         | 3 +++
 configure.ac | 2 +-
 meson.build  | 2 +-
 3 files changed, 5 insertions(+), 2 deletions(-)

commit ab180d64b909594bdafc9596f67a1913275c6474
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-29

    Revert "Fix RPC calls: ATTRIBUTE buf not null but length 0"
    
    This reverts commit 65409c0ebd5d9a4aaf55254256dcc878862a0be1.

 p11-kit/rpc-message.c |  8 +-------
 p11-kit/rpc-server.c  | 22 +++-------------------
 2 files changed, 4 insertions(+), 26 deletions(-)

commit 17a26f0948944635453a54d44c2565ed7ba91a14
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-29

    Revert "Fix RPC calls: BYTE buffer not null and length 0"
    
    This reverts commit 8cb21a6a09d18156c9002b97687e5ac0bfa0fc92.

 p11-kit/rpc-client.c  | 2 +-
 p11-kit/rpc-message.c | 6 ++----
 p11-kit/rpc-message.h | 3 +--
 p11-kit/rpc-server.c  | 7 ++-----
 4 files changed, 6 insertions(+), 12 deletions(-)

commit 83aaa2200bfa141b0c9e1c4f5af98252f8e826cc
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-29

    Revert "Fix C_GetSlotList() when length is 0"
    
    This reverts commit 1ede9b8d33c4bc9a4194ffca22ac6d7351f6bcf5.
    
    It turned out that this breaks compatibility of the RPC protocol.  The
    right fix to the original issue would be probably to add a new call ID
    associated with a different signature and add a fallback mechanism in
    both client and server.

 p11-kit/rpc-client.c  |  2 +-
 p11-kit/rpc-message.c |  6 ++----
 p11-kit/rpc-message.h |  3 +--
 p11-kit/rpc-server.c  |  7 ++-----
 p11-kit/test-server.c | 36 ------------------------------------
 5 files changed, 6 insertions(+), 48 deletions(-)

commit 69a420aaa70af5b89508b5140edb0ee4e166605b
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-21

    Release 0.23.19

 NEWS         | 9 +++++++++
 configure.ac | 2 +-
 meson.build  | 2 +-
 3 files changed, 11 insertions(+), 2 deletions(-)

commit 251dfdfd765e709b7d54420c685e19f70a5e9803
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-22

    travis: Tighten autotools build steps

 .travis/autotools/script.sh | 29 ++++++++++++++++++++++++++++-
 1 file changed, 28 insertions(+), 1 deletion(-)

commit e9dbeeea96b0b709631d1b6d62f9877f4872993b
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-22

    travis: Do 'make distcheck' in autotools build

 .travis/autotools/script.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 2a1ee21ca31a62274e0932572f972bf3340f8bde
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-21

    build: Add --with-bash-completion configure option
    
    This is needed for 'make distcheck' to not install those files in the
    system locations.

 Makefile.am  |  1 +
 configure.ac | 12 +++++++++---
 2 files changed, 10 insertions(+), 3 deletions(-)

commit cee7c2ad81d21795783ec28a67247cff740de2ce
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-21

    build: Only distribute XZ-compressed tarballs

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5092f8dd5463b89642e29ca5ae7ea08aa30d5d66
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-21

    build: Add more files to .gitignore

 .gitignore | 2 ++
 1 file changed, 2 insertions(+)

commit a96af650e1ac2f5faecc9354ac30d128a7e93b9f
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-21

    meson: Expose only C_GetFunctionList from the mock modules

 p11-kit/meson.build | 4 ++++
 1 file changed, 4 insertions(+)

commit ba3c7d16760d177be43960c9eb9572817c60c4df
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-21

    mock: Handle memory allocation error in C_Initialize

 common/mock.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 62b09608e3a311c8b8ae924805f936f8af593bfa
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-15

    meson: Use cc.has_type for types instead of cc.has_header_symbol

 meson.build | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 45cd66e3a16f0102a50f33ebb4a58aac09f40f92
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-15

    meson: Check if <stdbool.h> exists

 meson.build | 10 ++++++++++
 1 file changed, 10 insertions(+)

commit 5fe875dc598e2dc50ba8e888099c116fe12999d3
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-15

    meson: Check program_invocation_short_name declaration
    
    Pointed by Rosen Penev in #268.

 meson.build | 5 +++++
 1 file changed, 5 insertions(+)

commit 869b657c7bfbd2f91331d5aabcf572cba6043d37
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-15

    meson: Check endianness

 meson.build | 4 ++++
 1 file changed, 4 insertions(+)

commit 1f8d523e5db688deff13329b4cba1dd6181d76a3
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-15

    build: Fix type mismatch in reallocarray usage

 common/attrs.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 1def8077a2bc1fc2a6bd3685a9d94a9a51f40e23
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-10-31

    trust: Support CKA_NSS_{SERVER,EMAIL}_DISTRUST_AFTER
    
    These new attributes are introduced in:
    https://bugzilla.mozilla.org/show_bug.cgi?id=1465613
    
    The value of the attribute can be either false (represented as a
    single octed "\x00"), or a UTCTime in a restricted form (i.e.,
    "YYMMDDHHMMSSZ").  For future proof, we also support GeneralizedTime
    in the form "YYYYMMDDHHMMSSZ".

 common/constants.c   |  2 ++
 common/pkcs11x.h     |  2 ++
 trust/builder.c      | 78 ++++++++++++++++++++++++++++++++++++++++++++++++++++
 trust/test-builder.c | 75 ++++++++++++++++++++++++++++++++++++++++++++++++++
 4 files changed, 157 insertions(+)

commit e8b453383ace97fc1adfc213dc718e7b62fafd96
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-14

    build: Remove auto-generated gettext files from repository

 po/en@boldquot.header  | 25 -------------------------
 po/en@quot.header      | 22 ----------------------
 po/insert-header.sin   | 23 -----------------------
 po/remove-potcdate.sin | 19 -------------------
 4 files changed, 89 deletions(-)

commit 8d92053df8a2bfed89a6f3e835386e13c7f95b61
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-14

    build: Use AM_GNU_GETTEXT_REQUIRE_VERSION
    
    AM_GNU_GETTEXT_REQUIRE_VERSION was introduced a while back to instruct
    autopoint to pull the latest version of gettext infrastructure.  Use
    it instead of hacking around gettextize call in autogen.sh.

 autogen.sh   | 13 -------------
 configure.ac |  4 ++++
 2 files changed, 4 insertions(+), 13 deletions(-)

commit 5bb71e914532b8350dfc14697c4fa89e714e5812
Author: David Woodhouse <dwmw@amazon.co.uk>
Date:   2020-01-06

    rpc: Add vsock transport
    
    This allows PKCS#11 remoting between virtual machines, so a software
    token can be isolated into a microVM.

 common/Makefile.am      |   1 +
 common/meson.build      |   3 +-
 common/vsock.c          | 122 ++++++++++++++++++++++++++++++++++++++++++++++++
 common/vsock.h          |  46 ++++++++++++++++++
 configure.ac            |  15 ++++++
 meson.build             |   9 ++++
 p11-kit/rpc-transport.c |  97 ++++++++++++++++++++++++++++++++++++++
 p11-kit/server.c        | 118 ++++++++++++++++++++++++++++++++++++++++------
 8 files changed, 395 insertions(+), 16 deletions(-)

commit 877de5fadaf0067272e8d0eb24893d7c823afe08
Author: David Woodhouse <dwmw@amazon.co.uk>
Date:   2020-01-06

    rpc: Check for socket init failure
    
    In some cases, rpc_unix_init() or rpc_exec_init() can return NULL but
    p11_rpc_transport_new() doesn't check and may dereference it.

 p11-kit/rpc-transport.c | 2 ++
 1 file changed, 2 insertions(+)

commit 96af147637f0dc10792c3abdcec1894c361229da
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-09

    build: Suppress cppcheck false-positive on tracking array length

 p11-kit/proxy.c | 2 ++
 1 file changed, 2 insertions(+)

commit e931efd17950786ee61cbfc70ddf94d02ae473ba
Author: Daiki Ueno <dueno@redhat.com>
Date:   2020-01-08

    build: Fix realloc usage
    
    As realloc() doesn't touch the original memory block, we need to use a
    local variable to avoid potential memory leak in failure cases.
    
    Pointed by David Woodhouse.

 common/attrs.c   |  6 ++++--
 p11-kit/filter.c |  9 +++++----
 p11-kit/iter.c   | 20 ++++++++++++++------
 p11-kit/proxy.c  |  7 +++++--
 trust/index.c    | 12 ++++++++++--
 5 files changed, 38 insertions(+), 16 deletions(-)

commit 6563ad8ececec05f2b6269b509d4e12c07d2a87e
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-10-26

    CONTRIBUTING.md: Mention contribution rules and coding style

 CONTRIBUTING.md | 35 +++++++++++++++++++++++++++++++++++
 HACKING         | 16 ----------------
 Makefile.am     |  2 +-
 3 files changed, 36 insertions(+), 17 deletions(-)

commit 65409c0ebd5d9a4aaf55254256dcc878862a0be1
Author: Vincent JARDIN <vjardin@free.fr>
Date:   2019-10-22

    Fix RPC calls: ATTRIBUTE buf not null but length 0
    
    Let's add a support for cases when the buffer != NULL but the
    length is 0. According to Oasis, buffer = NULL and length = 0
    means a query of the length so the subsequent calls with a
    buffer != NULL should fill then buffer when length is long enough.
    If not, according to Oasis, one should get a CKR_BUFFER_TOO_SMALL.
    
    See the previous commit for IN_ULONG_BUFFER(). This patch is
    follow a similar design pattern.
    
    Fix: issue #257

 p11-kit/rpc-message.c |  8 +++++++-
 p11-kit/rpc-server.c  | 22 +++++++++++++++++++---
 2 files changed, 26 insertions(+), 4 deletions(-)

commit 8cb21a6a09d18156c9002b97687e5ac0bfa0fc92
Author: Vincent JARDIN <vjardin@free.fr>
Date:   2019-10-22

    Fix RPC calls: BYTE buffer not null and length 0
    
    Let's add a support for cases when the buffer != NULL but the
    length is 0. According to Oasis, buffer = NULL and length = 0
    means a query of the length so the subsequent calls with a
    buffer != NULL should fill buffer when length is long enough.
    If not, according to Oasis, one should get a CKR_BUFFER_TOO_SMALL.
    
    This current fix is for IN_BYTE_BUFFER(), same
    for IN_ATTRIBUTE_BUFFER().
    
    See the previous commit for IN_ULONG_BUFFER(). This patch is
    strictly using the same design pattern.
    
    Fix: issue #257
    
    Suggested-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/rpc-client.c  | 2 +-
 p11-kit/rpc-message.c | 6 ++++--
 p11-kit/rpc-message.h | 3 ++-
 p11-kit/rpc-server.c  | 7 +++++--
 4 files changed, 12 insertions(+), 6 deletions(-)

commit 1ede9b8d33c4bc9a4194ffca22ac6d7351f6bcf5
Author: Vincent JARDIN <vjardin@free.fr>
Date:   2019-10-21

    Fix C_GetSlotList() when length is 0
    
    Let's add a support for cases when the buffer != NULL but the
    length is 0. According to Oasis, buffer = NULL and length = 0
    means a query of the length so the subsequent calls with a
    buffer != NULL should fill buffer when length is long enough.
    If not, according to Oasis, one should get a CKR_BUFFER_TOO_SMALL.
    
    This current fix is for IN_ULONG_BUFFER(), same
    should be applied for IN_BYTE_BUFFER() and for IN_ATTRIBUTE_BUFFER().
    
    Include a test_no_slots()
    
    Fix: issue #257
    
    Suggested-by: Daiki Ueno <dueno@redhat.com>

 p11-kit/rpc-client.c  |  2 +-
 p11-kit/rpc-message.c |  6 ++++--
 p11-kit/rpc-message.h |  3 ++-
 p11-kit/rpc-server.c  |  7 +++++--
 p11-kit/test-server.c | 36 ++++++++++++++++++++++++++++++++++++
 5 files changed, 48 insertions(+), 6 deletions(-)

commit 9763fc8edcc5dd41e07ddf068dce6bc429dfe6b6
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2019-10-23

    test-proxy: Implement reproducer for bad prefix list matching

 p11-kit/test-proxy.c | 7 +++++++
 1 file changed, 7 insertions(+)

commit 298ad811540c538fea1906528fe8cf8a6784e5ee
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2019-10-23

    modules: Implement correct search in list
    
    The current version of matching was failing, when the list contained
    also a searched string with some suffix, for example, when we ran from
    p11-kit and the p11-kit-proxy was first in the list and p11-kit later,
    it was not matched, because the test did not find a separator after
    the first match, decided that it does not match and did not try further.
    
    example program p11-kit
    example enable-in: p11-kit-proxy,p11-kit

 p11-kit/modules.c | 26 ++++++++++++++++++--------
 1 file changed, 18 insertions(+), 8 deletions(-)

commit 7c94eab51d08650eaa66184344325d42e812973c
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-10-23

    autotools: Fix bash-completion installation

 Makefile.am         | 13 ++++---------
 configure.ac        |  5 ++++-
 p11-kit/Makefile.am |  4 ++++
 trust/Makefile.am   |  4 ++++
 4 files changed, 16 insertions(+), 10 deletions(-)

commit ef2716d18e1098effb8f3a90653c6264b2fec426
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2019-10-22

    Install bash completion in the CI

 .travis/autotools/before_install.sh | 2 +-
 .travis/cppcheck/before_install.sh  | 2 +-
 .travis/linux/before_install.sh     | 2 +-
 .travis/osx/before_install.sh       | 2 +-
 4 files changed, 4 insertions(+), 4 deletions(-)

commit 387594893ee8d09267a7b788f3dae6905093d3c9
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2019-10-21

    Add simple bash completion for provided commands

 Makefile.am                 |  8 ++++++
 bash-completion/meson.build | 11 ++++++++
 bash-completion/p11-kit     | 19 +++++++++++++
 bash-completion/trust       | 67 +++++++++++++++++++++++++++++++++++++++++++++
 configure.ac                |  7 +++++
 meson.build                 |  1 +
 6 files changed, 113 insertions(+)

commit b879b9b8395d0a99dbc9b8ae8057dc84bdd551e6
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2019-10-22

    configure: Fix typo to avoid errors during configure

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 6b33efaa82848bac7fd73888963a106cf4c03151
Author: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>
Date:   2019-10-07

    common: add Russian PKCS#11 extensions to pkcs11x.h header
    
    Add values defined to support Russian GOST cryptography to pkcs11x.h
    header.
    
    Signed-off-by: Dmitry Eremin-Solenikov <dbaryshkov@gmail.com>

 common/pkcs11x.h | 36 ++++++++++++++++++++++++++++++++++++
 1 file changed, 36 insertions(+)

commit a92894c80d880b6047327a276395b1f88fc733ee
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-30

    autotools: Add more files from meson build in distribution

 Makefile.am | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit b0ebe7555c291808db29377ba79cb8326301f0a6
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-30

    autotools: Add more files from meson build in distribution

 p11-kit/Makefile.am | 7 +++++++
 1 file changed, 7 insertions(+)

commit 3530d4946f9b9233bb0c132f3eda77c5f593fe9a
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-30

    build: Fix 'make distcheck'

 Makefile.am            | 3 ++-
 doc/manual/Makefile.am | 1 -
 p11-kit/Makefile.am    | 1 +
 3 files changed, 3 insertions(+), 2 deletions(-)

commit 25df8dfd2fac77d8c00d87a114d6d89dd945055f
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-30

    Release 0.23.18

 NEWS         | 5 +++++
 configure.ac | 2 +-
 meson.build  | 2 +-
 3 files changed, 7 insertions(+), 2 deletions(-)

commit fde84c52f4ffd0b274ce92e5f935060e86f0a5f7
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-25

    rpc: Allow empty CK_DATE value
    
    Unlike other data types, CK_DATE value may be empty (and that is the
    default).  Treat it as a valid value and serialize/deserialize
    accordingly.
    
    Reported by Vincent JARDIN in:
    https://github.com/p11-glue/p11-kit/issues/244

 p11-kit/rpc-message.c | 23 +++++++++++++----------
 p11-kit/test-rpc.c    | 23 +++++++++++++++++++++++
 2 files changed, 36 insertions(+), 10 deletions(-)

commit df2b7b0a3c1ad3c6f54ff6c84ecc1f04976e65f7
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-18

    build: Fix undefined behavior in left shift
    
    Spotted by UBSan.

 p11-kit/rpc-message.c | 2 +-
 trust/utf8.c          | 2 +-
 2 files changed, 2 insertions(+), 2 deletions(-)

commit 94179adeebb24f390cad6abed1f1f8f89c41f451
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-11

    autotools: Use symbol versioning if possible
    
    The meson build already using it for:
    https://github.com/mesonbuild/meson/issues/3047
    
    Suggested by Jan Alexander Steffens

 configure.ac        | 3 +++
 p11-kit/Makefile.am | 9 +++++++--
 2 files changed, 10 insertions(+), 2 deletions(-)

commit 783bfcb40bafc7e2b64ec80a99add15112a2e8f9
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-11

    build: Import ld-version-script.m4 from gnulib

 .gitignore                    |  1 +
 build/m4/ld-version-script.m4 | 48 +++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 49 insertions(+)

commit 5240551119b99618aa4de95b88c1c2076d7ec87a
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-10

    build: Add meson files in autotools distribution

 Makefile.am            | 2 +-
 common/Makefile.am     | 2 ++
 doc/manual/Makefile.am | 1 +
 p11-kit/Makefile.am    | 1 +
 trust/Makefile.am      | 3 ++-
 5 files changed, 7 insertions(+), 2 deletions(-)

commit 201e9d838befb1e4641228a79212a37c81774e8f
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-13

    travis: Run ninja install as root
    
    This is to avoid meson calling pkexec, which doesn't work inside docker.

 .travis/linux/script.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 17b2edb1354c5d5080172af45ce55408c5e51d59
Author: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
Date:   2019-09-10

    meson: Add missing prefix to system path defines

 p11-kit/meson.build | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 64a7722aeab2eafcbc57c9145b3fb556e4b1a61b
Author: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
Date:   2019-09-10

    meson: Install p11-kit-server units

 p11-kit/meson.build | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit e5b0dfc2aca0d22c123a85c6cab96772af1f85fb
Author: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
Date:   2019-09-10

    meson: Build and install man pages

 doc/manual/meson.build | 185 +++++++++++++++++++++++++++++++------------------
 meson.build            |   5 +-
 meson_options.txt      |   4 ++
 3 files changed, 122 insertions(+), 72 deletions(-)

commit 901749a2039ce5b0e6388295d364b22b80c37e58
Author: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
Date:   2019-09-10

    meson: Don't prefix p11_user_config

 p11-kit/meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b1d1fb011fad3e5b21665e6767fc267e0241ecf0
Author: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
Date:   2019-09-10

    meson: PKCS#11 modules should only export C_GetFunctionList

 p11-kit/meson.build    | 10 ++++++++++
 p11-kit/p11-module.def |  2 ++
 p11-kit/p11-module.map |  6 ++++++
 trust/meson.build      |  6 +++++-
 4 files changed, 23 insertions(+), 1 deletion(-)

commit cc38f6aa61f6122f182d7099f5c88548b36a0843
Author: Jan Alexander Steffens (heftig) <jan.steffens@gmail.com>
Date:   2019-09-10

    meson: Install p11-kit-client module

 p11-kit/meson.build | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit f2ee0a01272f4bbd018fb438344615cca8a74185
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-09

    meson: Fix dictionary syntax
    
    Reported by Jan Alexander Steffens.

 doc/manual/meson.build | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit f00183944fad943216ac5842f6b23ab5c4149e50
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-09

    Release 0.23.17

 NEWS         | 8 ++++++++
 configure.ac | 2 +-
 meson.build  | 2 +-
 3 files changed, 10 insertions(+), 2 deletions(-)

commit 2dea838a5dc284db29b0f8558cd3e1f1822f47ed
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-09

    uri: Supress cppcheck false-positive

 p11-kit/uri.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 8db6d7eee38bbf1f511da6128d108a62833f84d0
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-09

    uri: Check return value of insert_attribute

 p11-kit/uri.c | 6 +++++-
 1 file changed, 5 insertions(+), 1 deletion(-)

commit d6c88b4735284394e73ad0228559fc8aca948318
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-09-09

    meson: Update project version

 meson.build | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ead7a4a28f0505aa5602877538ef8be9970245b2
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-07-07

    build: Fix typo in checking program_invocation_short_name decl
    
    The decl should be in errno.h, not error.h.

 configure.ac | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 99cdf3dc86ec7148e08351b63d8ee5f2f2a7f4d3
Author: Rosen Penev <rosenp@gmail.com>
Date:   2019-07-01

    common: Fix uClibc-ng compilation
    
    program_invocation_short_name is const under uClibc-ng.

 configure.ac | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 5a89453fafab796d33c37dd6861c102fc28ebde2
Author: Alon Bar-Lev <alon.barlev@gmail.com>
Date:   2019-07-01

    trust: do not allow daylight to invalidate date validation
    
    Issue: 235
    Signed-off-by: Alon Bar-Lev <alon.barlev@gmail.com>

 trust/builder.c | 1 +
 1 file changed, 1 insertion(+)

commit 787888e181543f5a85eb69d6a3caf14f9a4262b2
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-19

    build: Declare dependency chain between static libs in common
    
    In common/ there are sub-libraries namely libp11-common.a,
    libp11-library.a, libp11-tool.a, and libp11-test.a.
    
    All the latter 3 libs use the symbols from libp11-common.a, it would
    make sense to declare a dependency against it.

 common/meson.build  | 17 ++++++-----------
 p11-kit/meson.build | 22 ++++++++++------------
 trust/meson.build   | 10 +++-------
 3 files changed, 19 insertions(+), 30 deletions(-)

commit eb5eb7aea7fc41a2c15d853cd57c7c030644f4ee
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-19

    build: Make threads dependency more explicit

 common/meson.build  |  6 ++++--
 meson.build         | 12 ++++--------
 p11-kit/meson.build |  4 ++--
 3 files changed, 10 insertions(+), 12 deletions(-)

commit daf1a84de39c4cdbd308c6a0b80b437689a222c7
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-02

    .travis.yml: Use meson for building

 .travis.yml                         | 12 ++++++------
 .travis/autotools/after_failure.sh  |  3 +++
 .travis/autotools/after_success.sh  | 13 +++++++++++++
 .travis/autotools/before_install.sh |  9 +++++++++
 .travis/autotools/install.sh        | 14 ++++++++++++++
 .travis/autotools/script.sh         | 12 ++++++++++++
 .travis/linux/after_failure.sh      |  2 +-
 .travis/linux/after_success.sh      | 10 ++++------
 .travis/linux/before_install.sh     |  4 +++-
 .travis/linux/script.sh             | 33 +++++++++++++++++++++++----------
 build/cross_file_mingw64.txt        | 18 ++++++++++++++++++
 11 files changed, 106 insertions(+), 24 deletions(-)

commit 4f956698b64ac6eb8e5e8b7d143ceb11f1133814
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-05-15

    build: Add meson build support
    
    This adds support for meson as an alternative build system.

 .dir-locals.el                |   3 +-
 common/meson.build            |  99 ++++++++++++
 doc/manual/meson.build        |  75 +++++++++
 doc/manual/sysdir.xml.in      |   1 +
 doc/manual/userdir.xml.in     |   1 +
 doc/manual/version.xml.in     |   1 +
 meson.build                   | 368 ++++++++++++++++++++++++++++++++++++++++++
 meson_options.txt             |  47 ++++++
 p11-kit/gen-pkcs11-gnu.sh     |  16 ++
 p11-kit/gen-virtual-fixed.sh  |  28 ++++
 p11-kit/libp11-kit-0.dll.def  | 101 ++++++++++++
 p11-kit/libp11-kit.map        | 105 ++++++++++++
 p11-kit/meson.build           | 299 ++++++++++++++++++++++++++++++++++
 p11-kit/meson_post_install.sh |  15 ++
 p11-kit/pkcs11-gnu.c          |   3 +
 po/meson.build                |   1 +
 trust/meson.build             | 162 +++++++++++++++++++
 17 files changed, 1324 insertions(+), 1 deletion(-)

commit 411a7a6d31cd5584ff9837260d77d8c306d3b557
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-01

    trust: Fix mismatched return values

 trust/pem.c  | 2 +-
 trust/x509.c | 4 ++--
 2 files changed, 3 insertions(+), 3 deletions(-)

commit 58481dbb0b0ee1384e62878283a398d96e0ff5f2
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-02

    po: Remove en@{,bold}quot from LINGUAS

 po/LINGUAS | 2 --
 1 file changed, 2 deletions(-)

commit cbdbfaaf255083091decc280058caa87db19aeb9
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-01

    build: Don't hardcode module path

 Makefile.am               |  4 +++-
 p11-kit/Makefile.am       | 12 ++++++++----
 p11-kit/test-deprecated.c |  2 +-
 p11-kit/test-init.c       |  2 +-
 p11-kit/test-server.c     | 12 ++++++------
 p11-kit/test-server.sh    |  4 +++-
 p11-kit/test-transport.c  |  6 +++---
 7 files changed, 25 insertions(+), 17 deletions(-)

commit 084347319f6e832ec2c36d7b27a64c8f2614f084
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-01

    build: Move check_PROGRAMS into subdirectories

 .gitignore               | 12 ++++++------
 common/Makefile.am       | 12 ++++++------
 common/test-compat.c     |  4 ++--
 p11-kit/Makefile.am      | 32 ++++++++++++++++----------------
 p11-kit/test-conf.c      |  2 +-
 p11-kit/test-messages.sh |  2 +-
 p11-kit/test-server.c    |  4 ++--
 p11-kit/test-server.sh   |  4 ++--
 p11-kit/test-transport.c |  6 +++---
 9 files changed, 39 insertions(+), 39 deletions(-)

commit 6bebd5747aa49d4a124d23d4967f65a771799fe5
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-01

    tests: Add tmpdir argument to p11_test_copy_setgid
    
    To prevent BUILDDIR being embedded in the library.

 common/test-compat.c | 4 ++--
 common/test.c        | 7 +++++--
 common/test.h        | 3 ++-
 p11-kit/test-conf.c  | 2 +-
 4 files changed, 10 insertions(+), 6 deletions(-)

commit 51382cd59c89e862443421a9d697a709f2244f36
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-16

    tests: Fix memleaks in test-jks.c

 trust/test-jks.c | 16 ++++++++++++----
 1 file changed, 12 insertions(+), 4 deletions(-)

commit 9c2022d292c00ccbe2413b53b7c91cf4ba4d7c14
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-03

    tests: Skip tests calling getauxval(AT_SECURE) if binary is on /tmp

 common/test-compat.c | 5 +++--
 p11-kit/test-conf.c  | 5 +++--
 2 files changed, 6 insertions(+), 4 deletions(-)

commit fd908a787cc868043067f5fab492f8e05b6d99ce
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-16

    tests: Fix temp file permission before deleting
    
    On mingw64/wine, unlink fails if the file has no write bit.

 trust/test-module.c | 22 +++++++++++++---------
 1 file changed, 13 insertions(+), 9 deletions(-)

commit 2b3581c234f0097a2598395d1e0012b4ddd9a5ba
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-17

    tests: Don't assume / is not writable on Windows in test-token.c

 trust/test-token.c | 12 +++++++-----
 1 file changed, 7 insertions(+), 5 deletions(-)

commit 6708ccf6126734b4d98cc849bc4542c45ffce191
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-15

    conf: Skip root UID check on Windows

 p11-kit/conf.c | 2 ++
 1 file changed, 2 insertions(+)

commit 1e8ca781b983cb31d62e21a3a61f25be1fcc694f
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-05-20

    virtual: Rename virtual-fixed.c to virtual-fixed-generated.h
    
    Previously the generated .c file was included in another source file,
    which is not supported in some build systems (e.g., meson).

 .gitignore                     | 2 +-
 .travis/linux/after_success.sh | 2 +-
 p11-kit/Makefile.am            | 6 +++---
 p11-kit/virtual.c              | 2 +-
 4 files changed, 6 insertions(+), 6 deletions(-)

commit 045d7546fc317deefc2d84d524a211ce6ab4869b
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-03

    common: Make issetugid check simpler

 common/compat.c |  7 ++-----
 configure.ac    | 16 +---------------
 2 files changed, 3 insertions(+), 20 deletions(-)

commit bbb7f046ff430d33267487cb6f8a0e24d2eab832
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-06-02

    common: Fix vasprintf emulation
    
    va_list must be saved when calling vsnprintf() in a loop.

 common/compat.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

commit 5fc2d67b5ebb3daddb350d7ac60ede74dd99fcc6
Author: Simon Haggett <simon.haggett@gmail.com>
Date:   2019-06-13

    rpc: On UNIX wait on condition variable instead of FD if header is for a different thread.
    
    If rpc_socket_read() receives a header for a different thread, it tries to yield by
    releasing the read mutex and waiting on the socket's read FD. On Linux systems, this has
    been observed to cause a performance problem in cases where multiple threads are being
    used. Threads expecting a different header can rapidly unlock and relock the read mutex,
    as they resume when sock->read_code hasn't changed. This can result in contention on the
    read mutex, which delays the thread that is expecting to consume the header.
    
    This fix updates rpc_socket_read() on UNIX to wait on a condition variable instead of the
    socket's read FD. The condition variable is signalled when sock->read_code changes. This
    allows waiting threads to only resume once the header and payload have been consumed by
    their target thread. This fix only targets UNIX platforms, as the Windows version that
    p11-kit targets by default (Windows 2000) does not provide support for condition
    variables.
    
    Signed-off-by: Simon Haggett <simon.haggett@gmail.com>

 common/compat.h         | 13 +++++++++++++
 p11-kit/rpc-transport.c | 47 +++++++++++++++++++++++++++++++++++------------
 2 files changed, 48 insertions(+), 12 deletions(-)

commit c689917b393379d288b868f70b2f7b7f6aafe430
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-05-23

    tests: Avoid uninitialized value in test-proxy.c

 p11-kit/test-proxy.c | 4 ++++
 1 file changed, 4 insertions(+)

commit 330148bef17a39075a0af5e446c9502bf3a225ff
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-05-22

    build: Suppress compiler warning
    
    Remove unused "global" variable.

 p11-kit/proxy.c | 1 -
 1 file changed, 1 deletion(-)

commit 0eb1f6782c5315fc6b46861bc9f92a765e229e14
Author: Raphael Medaer <raphael@medaer.me>
Date:   2019-05-22

    doc: Add 'server' command in help
    
    'server' is the last common command which is not in CLI help.
    IMHO, adding this small documentation could help to promote usage of
    pkcs11 forwarding.

 p11-kit/p11-kit.c | 1 +
 1 file changed, 1 insertion(+)

commit 9a546b4571f20b271058990e94833f35e4ec39c0
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-05-22

    Release 0.23.16

 NEWS         | 10 ++++++++++
 configure.ac |  2 +-
 2 files changed, 11 insertions(+), 1 deletion(-)

commit 381d16e651d5bcace316fbab4095c8dea8c43a92
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-05-16

    proxy: Support C_WaitForSlotEvent() if CKF_DONT_BLOCK is specified
    
    While fully implementing C_WaitForSlotEvent() would require a separate
    thread to monitor events, it is straightforward to implement the
    function if the CKF_DONT_BLOCK flag is given.
    
    Suggested by David Ward.

 p11-kit/Makefile.am       |  7 ++++-
 p11-kit/mock-module-ep7.c | 70 +++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/proxy.c           | 64 +++++++++++++++++++++++++++++++++----------
 p11-kit/test-proxy.c      | 40 +++++++++++++++++++++++++++
 4 files changed, 166 insertions(+), 15 deletions(-)

commit 68ce31aae9a22d18b28f4aa44b3e1006b7fe3aa7
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-05-17

    conf: Ignore user configuration if the program is running as root
    
    Suggested by Bastien Nocera:
    https://bugzilla.redhat.com/show_bug.cgi?id=1688583

 p11-kit/conf.c | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit 58cede114664e839b53d923863bff604ce58b1a7
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-05-15

    proxy: Refresh slot list on every C_GetSlotList call
    
    Previously, the proxy module calculated the slot list only once at the
    C_Initialize() call.  That was causing a usability limitation when the
    user attaches HSM after starting an application.
    
    Suggested by David Ward.

 p11-kit/Makefile.am       |   7 ++-
 p11-kit/mock-module-ep6.c |  76 ++++++++++++++++++++++++++++
 p11-kit/proxy.c           | 123 +++++++++++++++++++++++++++++-----------------
 p11-kit/test-proxy.c      |  34 ++++++++++++-
 4 files changed, 192 insertions(+), 48 deletions(-)

commit 793cc3b78f17bb5a3c151eba1144b73a5d51be3e
Author: Simon Haggett <simon.haggett@gmail.com>
Date:   2019-03-12

    modules: Fix index used in call to p11_dict_remove()
    
    This fixes a call to p11_dict_remove() in managed_steal_sessions_inlock() to use
    the correct index in the stolen array (i, rather than at). This avoids an
    assert, which was encountered on a host serving a PKCS#11 module to a remote
    Linux client.
    
    Signed-off-by: Simon Haggett <simon.haggett@gmail.com>

 p11-kit/modules.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit cbe95e35f8309493094c93d882d0c18e8063f292
Author: Tom Sutcliffe <tomsci@me.com>
Date:   2019-03-09

    Fix Win32 p11_dl_error crash
    
    Caused by returning a buffer that wasn't allocated with malloc and
    needed to be freed with LocalFree() instead. The fix is to strdup
    msg_buf so what's returned can be free()d.

 common/compat.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 4a925177a81c2566d2a81a0a450607a5ff4d9048
Author: Stefano Garzarella <sgarzare@redhat.com>
Date:   2019-02-27

    modules: check gl.modules before iterates on it when freeing
    
    In some circumstances, as described in the BZ, can happen that
    free_modules_when_no_refs_unlocked() is called multiple times
    when the module destructor is invoked.
    We should check gl.modules before iterates on it in the
    free_modules_when_no_refs_unlocked() functions, to avoid
    a SIGSEGV.
    
    Bugzilla: https://bugzilla.redhat.com/show_bug.cgi?id=1680963

 p11-kit/modules.c | 18 ++++++++++--------
 1 file changed, 10 insertions(+), 8 deletions(-)

commit e2170b295992cb7fdf115227a78028ac3780619f
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-02-18

    trust: Ignore unreadable content in anchors
    
    This amends eb503f3a1467f21a5ecc9ae84ae23b216afc102f.  Instead of
    failing C_FindObjectsInit, treat any errors internally and accumulates
    the successfully loaded certificates.
    
    Reported by Andrej Kvasnica in:
    https://bugzilla.redhat.com/show_bug.cgi?id=1675441

 trust/module.c      |  3 +--
 trust/test-module.c | 77 +++++++++++++++++++++++++++++++++++++++++++++++++++++
 trust/token.c       | 23 +++++++---------
 3 files changed, 88 insertions(+), 15 deletions(-)

commit 2a474e1fe8f4bd8b4ed7622e5cf3b2718a202562
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-01-28

    extract-jks: Prefer _p11_extract_jks_timestamp to SOURCE_DATE_EPOCH
    
    Give _p11_extract_jks_timestamp precedence over SOURCE_DATE_EPOCH so
    that the test results are not affected by the envvar settings.

 trust/extract-jks.c | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 1ba80c67c492f25581ed97c8c31ffb5f20636d06
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-01-14

    Release 0.23.15

 NEWS         | 8 ++++++++
 configure.ac | 2 +-
 2 files changed, 9 insertions(+), 1 deletion(-)

commit f277a1469aef05d3542e8ae9fd3f5dbadbe12463
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-01-11

    pem: Fix assert condition
    
    If the PEM header is "-----BEGIN -----", *type should be an empty
    string and the parser shouldn't fail.  Reported by Han Han in:
    https://bugzilla.redhat.com/show_bug.cgi?id=1665172

 trust/pem.c      |  2 +-
 trust/test-pem.c | 18 ++++++++++++++++++
 2 files changed, 19 insertions(+), 1 deletion(-)

commit bebf4f3442ea5cdaa3a9fa2d0fee366e7264a227
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-01-09

    test: Add test that exercises duplicated certs in JKS

 trust/extract-jks.c            |   2 +-
 trust/fixtures/duplicated.jks  | Bin 0 -> 2122 bytes
 trust/fixtures/duplicated1.der | Bin 0 -> 1010 bytes
 trust/fixtures/duplicated2.der | Bin 0 -> 1010 bytes
 trust/fixtures/multiple.jks    | Bin 2556 -> 2567 bytes
 trust/test-jks.c               |  58 ++++++++++++++++++++++++++++++++++++++---
 6 files changed, 55 insertions(+), 5 deletions(-)

commit 7289639cf41df1840002e865bf700f50afec523c
Author: Daiki Ueno <dueno@redhat.com>
Date:   2019-01-09

    trust: Fix alias generation in JKS extractor
    
    When there is a duplicate, the JKS extractor previously assigned
    somewhat obscure name "-<digit>" (not "<name>-<digit>").

 trust/extract-jks.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 5e6a92b67ddade14a54769b05cc717043bc56b78
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-12-25

    trust: Continue parsing if the file cannot be read as persist format
    
    A corrupted file that contains "[p11-kit-object-v1]" can be a valid
    PEM certs file.  Continue with the next format if it cannot be read as
    a persistent format.

 trust/parser.c | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 4aa6ef9e82f6bb14746a47a7d56789d5e982a1f5
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-12-25

    trust: p11_token_load: Treat parse error as failure
    
    Those conditions can happen when the trust file is corrupted, so it
    makes more sense to treat them as a failure instead of programmer
    error.

 trust/token.c | 9 ++++++---
 1 file changed, 6 insertions(+), 3 deletions(-)

commit eb503f3a1467f21a5ecc9ae84ae23b216afc102f
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-12-25

    trust: Fail if trust anchors are not loaded from a file
    
    If the trust path is a file, treat parse error as fatal and abort the
    C_FindObjectsInit call.

 trust/module.c | 11 ++++++++---
 trust/token.c  |  6 +++---
 2 files changed, 11 insertions(+), 6 deletions(-)

commit 0dd62395788ae566d3adef967611bce214a04435
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-12-23

    trust: Propagate library verbosity to module through init_args
    
    Previously, even when the -v option is used with the 'trust' command,
    the messages from p11-kit-trust.so module were suppressed because the
    verbosity setting is not propagated to the module.

 common/message.c           |  8 ++++----
 p11-kit/modules.c          | 29 +++++++++++++++++++++++------
 p11-kit/p11-kit.h          |  3 ++-
 trust/enumerate.c          | 11 +++++++++--
 trust/module.c             |  5 +++++
 trust/p11-kit-trust.module |  4 ++++
 6 files changed, 47 insertions(+), 13 deletions(-)

commit 95faa51a23fc416e718dbd740adfce31f642530b
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-12-29

    build: Fix typo spotted by codespell

 ChangeLog                     | 2 +-
 NEWS                          | 8 ++++----
 common/pkcs11.h               | 2 +-
 common/test-lexer.c           | 2 +-
 doc/manual/Makefile.am        | 2 +-
 p11-kit/iter.c                | 2 +-
 p11-kit/modules.c             | 2 +-
 p11-kit/rpc-message.c         | 6 +++---
 p11-kit/rpc-server.c          | 4 ++--
 p11-kit/test-pin.c            | 2 +-
 p11-kit/test-virtual.c        | 2 +-
 trust/test-enumerate.c        | 2 +-
 trust/test-parser.c           | 2 +-
 trust/test-token.c            | 4 ++--
 trust/trust-extract-compat.in | 2 +-
 15 files changed, 22 insertions(+), 22 deletions(-)

commit 4ee6545d0188e495f195b7fe5abbe9cc382a626d
Author: Jakub Jelen <jjelen@redhat.com>
Date:   2018-12-06

    doc: Make log-calls match the rest of the document style

 doc/manual/pkcs11.conf.xml | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b9eceda29965af989ad2150082454ae353266fa5
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-11-23

    build: Simplify assertions
    
    Let it leak memory when we assert, so not to confuse static analyzers
    as if this is the normal case.

 common/test.c | 6 ------
 1 file changed, 6 deletions(-)

commit b92e8c7f5c082a55073903d53293e6aeecb9d0ed
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-11-22

    travis: Add cppcheck profile

 .travis.yml                        |  4 ++++
 .travis/cppcheck/after_failure.sh  |  3 +++
 .travis/cppcheck/before_install.sh |  9 +++++++++
 .travis/cppcheck/install.sh        | 14 ++++++++++++++
 .travis/cppcheck/script.sh         |  3 +++
 5 files changed, 33 insertions(+)

commit d293fd54c754190da333496df070992e2d803a87
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-11-22

    travis: Allow profile override

 .travis.yml | 20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit f0c82b07f8b31a4b86de32436cb4f5053de16336
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-11-22

    build: Suppress cppcheck errors

 common/test-tests.c  |  2 ++
 common/test.c        |  4 ++++
 p11-kit/server.c     |  8 ++++++--
 trust/test-bundle.c  |  9 ++++++---
 trust/test-openssl.c |  9 ++++++---
 trust/test-save.c    | 22 +++++++++++++++-------
 trust/test-trust.c   |  4 +++-
 7 files changed, 42 insertions(+), 16 deletions(-)

commit 8287689158403090b5828a568b122b5b3a3ce987
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-22

    tests: Ensure p11_proxy_module_cleanup is called
    
    Reported and suggested in #197.

 p11-kit/test-proxy.c | 2 ++
 1 file changed, 2 insertions(+)

commit f758142178b4cc5c650dde75152bfb85ac992178
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-15

    url: Prefer upper-case letters in hex characters when encoding
    
    This makes it more compliant with RFC 3986, where the use of
    upper-case letters is recommended (as "SHOULD").
    
    Suggested by Sumit Bose.

 common/test-path.c |  2 +-
 common/test-url.c  | 28 ++++++++++++++++++++++++++++
 common/url.c       | 24 +++++++++++++++++-------
 p11-kit/test-uri.c | 14 +++++++-------
 4 files changed, 53 insertions(+), 15 deletions(-)

commit e81f6af7ed3b39b8df0bb7ce150619ea8178d47c
Author: Harald Hoyer <harald@redhat.com>
Date:   2018-11-02

    trust/extract-jks.c: also honor SOURCE_DATE_EPOCH time
    
    For reproducible builds, accept a define timestamp for the java
    keystore.
    
    See https://reproducible-builds.org/docs/source-date-epoch/

 trust/extract-jks.c | 38 ++++++++++++++++++++++++++++++++++----
 1 file changed, 34 insertions(+), 4 deletions(-)

commit 1d6913d5a551b6bd8efaa1705178e49f1527aa7e
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-30

    build: Require pkg.m4 >= 0.29 at bootstrap

 configure.ac | 2 ++
 1 file changed, 2 insertions(+)

commit 6e1046de2233fba7875d3d6a1b260192678dd0ad
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-19

    virtual: Prefer fixed closures to libffi closures
    
    On some circumstances (such as when loading p11-kit-proxy from httpd),
    it is known that creation of libffi closure always fails, due to
    SELinux policy.  Although this is harmless, it pollutes the journal
    and gives wrong hints when troubleshooting.  This patch changes the
    order of preference of libffi vs pre-compiled closures to avoid that.

 p11-kit/virtual.c | 19 ++++++++++++++-----
 1 file changed, 14 insertions(+), 5 deletions(-)

commit 83e92c2f9575707083d8b0c70ef330e285d70836
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-17

    trust: Check index->buckets is allocated on cleanup

 trust/index.c | 8 +++++---
 1 file changed, 5 insertions(+), 3 deletions(-)

commit 6417780ebbbbb0f01ddb001b239347655fb98578
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-17

    rpc-server: Check calloc failure

 p11-kit/rpc-server.c | 4 ++++
 1 file changed, 4 insertions(+)

commit da73c2804b3ca962fa51473bb4c303a5ed32d4a1
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-16

    trust: Set umask before calling mkstemp

 trust/save.c | 3 +++
 1 file changed, 3 insertions(+)

commit 033cd90806cb1e2eab7e799703757abc2f07052e
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-16

    proxy: Fix null dereference when reusing slots

 p11-kit/proxy.c | 5 ++++-
 1 file changed, 4 insertions(+), 1 deletion(-)

commit 1f78cb0b4dd193ec1f1b2b424a497a6c2edec043
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-16

    rpc-server: p11_kit_remote_serve_tokens: Fix memleak

 p11-kit/rpc-server.c | 5 +++++
 1 file changed, 5 insertions(+)

commit 213ea0815ef45411bf6c134918b79d2aad69c1dc
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-16

    build: Check return value of p11_rpc_buffer_get_uint64

 p11-kit/rpc-client.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit 06323aed926ddc67bd18ed98e5af92035a8e3d39
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-16

    build: Check return value of p11_dict_set

 p11-kit/proxy.c      | 3 ++-
 p11-kit/rpc-server.c | 6 +++++-
 trust/module.c       | 3 ++-
 3 files changed, 9 insertions(+), 3 deletions(-)

commit b10dadce5a3c921149b2c9fe0dec614f8076ebda
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-16

    build: Free memory before return{,_val}_if_* macros

 p11-kit/iter.c  |  5 ++++-
 p11-kit/proxy.c | 10 ++++++++--
 trust/asn1.c    | 15 ++++++++++++---
 trust/builder.c |  5 ++++-
 trust/index.c   | 10 ++++++++--
 trust/persist.c |  5 ++++-
 trust/save.c    | 29 +++++++++++++++++++++++++----
 trust/session.c | 10 ++++++++--
 trust/token.c   |  5 ++++-
 9 files changed, 77 insertions(+), 17 deletions(-)

commit c76197ddbbd0c29adc2bceff2ee9f740f71d134d
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-16

    build: Call va_end() always when leaving the function

 common/attrs.c  | 4 +++-
 common/compat.c | 5 ++++-
 common/path.c   | 5 ++++-
 trust/parser.c  | 4 +++-
 4 files changed, 14 insertions(+), 4 deletions(-)

commit 8a8db182af533a43b4d478d28af8623035475d68
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-10-16

    debug: Work around cppcheck false-positives
    
    https://trac.cppcheck.net/ticket/8794

 common/debug.h | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit f4a9fa674e17cc470d9280237032f18a70313d8e
Author: Leonardo Brondani Schenkel <leo@tradeshift.com>
Date:   2018-05-28

    common: use /proc only on Linux
    
    Non-Linux systems do not have /proc, so do not attempt to open it and
    eliminate an unnecessary access() syscall on those systems.

 common/compat.c | 2 ++
 1 file changed, 2 insertions(+)

commit 7f1df14e041c6de9603a4720753ca8f31e32b4ff
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-31

    pkcs11: Don't redefine CKM_CAMELLIA_KEY_GEN
    
    Also reorder the CKM_CAMELLIA_* definitions.

 common/pkcs11.h | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit 3770793f026e46a000d2d8816d56122598289d5c
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-28

    Release 0.23.14

 NEWS         | 6 ++++++
 configure.ac | 2 +-
 2 files changed, 7 insertions(+), 1 deletion(-)

commit c1b565413dae632a4ab78cea08ed103d9418921b
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-22

    virtual: Tighten error handling when fixed closures are exhausted

 p11-kit/virtual.c | 17 ++++++++---------
 1 file changed, 8 insertions(+), 9 deletions(-)

commit 347a8793d23036433ab0ba39049f0e832bb05b3d
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-22

    virtual: Don't be too loud about recoverable failure

 p11-kit/virtual.c | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 9a7892ef3fd9d4bd70df41fb0200782dc6134c70
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-24

    trust: Factor out module initialization into separate file
    
    This prevents double call to p11_library_init() in test-module.c, once
    from the ELF constructor, and secondly from the test itself.

 trust/Makefile.am   |  2 +-
 trust/module-init.c | 43 ++++++++++++++++++++++++++++++++++++++++++
 trust/module.c      | 54 -----------------------------------------------------
 3 files changed, 44 insertions(+), 55 deletions(-)

commit 0d7fbd5189ba1414d84326ddc8e4cff98f66a44b
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-27

    common: Factor out common initializer code into a header

 common/Makefile.am    |  1 +
 common/init.h         | 94 +++++++++++++++++++++++++++++++++++++++++++++++++++
 p11-kit/client-init.c | 60 +++-----------------------------
 p11-kit/proxy-init.c  | 59 +++-----------------------------
 4 files changed, 103 insertions(+), 111 deletions(-)

commit 0961cf527f1414bf5a900d958ee776cdd28f3525
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-24

    travis: Manually install cpp-coveralls
    
    To accommodate the gcov format change in gcc 8.1:
    https://github.com/eddyxu/cpp-coveralls/pull/127
    which is not yet available in the pip version.

 .travis/linux/after_success.sh | 8 ++++++--
 1 file changed, 6 insertions(+), 2 deletions(-)

commit 2066e7c57a7ae82e35fee3deaa06d89498d749a3
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-23

    travis: Check valgrind exit code more strictly

 .travis/linux/script.sh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 7a844d8e8c1c87401b161094023cf309ca111095
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-21

    README.md: Add CII Best Practices badge

 README.md | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f2a17c5e1dbc75a0142c6330bab588deb0060151
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-21

    README.md: Mention contact method for security issues

 README.md | 5 +++++
 1 file changed, 5 insertions(+)

commit b9ef1c5f4dbdfbab504479fdc899e344ff7bb44a
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-17

    Revert "build: Explicitly link threaded test programs to libpthread"
    
    This reverts commit dc4a6eaddbb36a344cc6a9c7eb12cab9df4899b0.

 configure.ac        | 10 ----------
 p11-kit/Makefile.am |  8 ++++----
 2 files changed, 4 insertions(+), 14 deletions(-)

commit 35b39cb2bf6d50a117a9e4c8e18100d19716ea71
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-17

    Revert "build: Stop linking the library with libpthread when possible"
    
    This reverts commit 50f8906e63c9413a7687bab6608496d83c29a222.

 configure.ac | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit 56f3b9370747a7a33a9d56ff9365c89700dd0e67
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-17

    Revert "common: Prefer __register_atfork() to pthread_atfork() if possible"
    
    This reverts commit ce3cec7f8742254b8627b9db48973b81e91cbfc8.

 common/library.c | 19 +------------------
 configure.ac     |  2 --
 2 files changed, 1 insertion(+), 20 deletions(-)

commit a877b0eca3d59f7f8cd126047c0e899df6018858
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-17

    Revert "build: Link to libpthread, if pthread_atfork() needs to be used"
    
    This reverts commit 541d79cb651cfd3238b9aa41fce70208df8e9496.

 NEWS             |  2 +-
 common/library.c | 10 ++++------
 configure.ac     |  7 +------
 3 files changed, 6 insertions(+), 13 deletions(-)

commit f69746d140cec20516c223825523fb0ade53384a
Author: Alexander Bokovoy <abokovoy@redhat.com>
Date:   2018-08-14

    Update pkcs11 header to allow SoftHSMv2 to compile
    
    Replace vendor-specific values with the IDs from PKCS11 v3.0 for those
    constants that were already standardized.

 common/pkcs11.h | 238 +++++++++++++++++++++++++++++++++++++++++++++++++++-----
 1 file changed, 220 insertions(+), 18 deletions(-)

commit abc542bd5abf46c5170f8a0c3dcc62eff0c9cfde
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-13

    travis: Check that proxy module can be loaded and unloaded

 .travis/linux/before_install.sh | 2 +-
 .travis/linux/script.sh         | 1 +
 2 files changed, 2 insertions(+), 1 deletion(-)

commit 34416ed787d804e0d293e47f2d10dc62ddea407c
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-13

    proxy: Avoid invalid memory access when unloading proxy module
    
    When loading and unloading p11-kit-proxy.so with pkcs11-tool, it
    accesses already free'd memory area:
    
    $ valgrind pkcs11-tool --module p11-kit-proxy.so -L
    ==25173== Invalid read of size 8
    ==25173==    at 0x64BF493: p11_proxy_module_cleanup (proxy.c:1724)
    ==25173==    by 0x64BD028: _p11_kit_fini (proxy-init.c:65)
    ==25173==    by 0x401477C: _dl_close_worker (in /usr/lib64/ld-2.27.so)
    ==25173==    by 0x4014E1D: _dl_close (in /usr/lib64/ld-2.27.so)
    ==25173==    by 0x5E08C4E: _dl_catch_exception (in /usr/lib64/libc-2.27.so)
    ==25173==    by 0x5E08CDE: _dl_catch_error (in /usr/lib64/libc-2.27.so)
    ==25173==    by 0x58B1724: _dlerror_run (in /usr/lib64/libdl-2.27.so)
    ==25173==    by 0x58B1113: dlclose (in /usr/lib64/libdl-2.27.so)
    ==25173==    by 0x11E5A7: ??? (in /usr/bin/pkcs11-tool)
    ==25173==    by 0x110023: ??? (in /usr/bin/pkcs11-tool)
    ==25173==    by 0x5CF624A: (below main) (in /usr/lib64/libc-2.27.so)
    ==25173==  Address 0x61231c8 is 552 bytes inside a block of size 584 free'd
    ==25173==    at 0x4C2FDAC: free (vg_replace_malloc.c:530)
    ==25173==    by 0x6548492: p11_virtual_unwrap (virtual.c:2902)
    ==25173==    by 0x64BF492: p11_proxy_module_cleanup (proxy.c:1723)

 p11-kit/proxy.c | 17 ++++-------------
 1 file changed, 4 insertions(+), 13 deletions(-)

commit 541d79cb651cfd3238b9aa41fce70208df8e9496
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-10

    build: Link to libpthread, if pthread_atfork() needs to be used
    
    On non-glibc systems (e.g., FreeBSD), pthread_atfork() stub is
    provided as a nop and our fork detection mechanism doesn't work.  Pull
    in the actual implementation from libpthread in that case.
    
    Signed-off-by: Daiki Ueno <dueno@redhat.com>

 NEWS             |  2 +-
 common/library.c | 10 ++++++----
 configure.ac     |  7 ++++++-
 3 files changed, 13 insertions(+), 6 deletions(-)

commit 6a8da20c0432499480731548256294844cade631
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-10

    build: Don't install systemd unit files when "make distcheck"

 Makefile.am | 1 +
 1 file changed, 1 insertion(+)

commit ef001069d069df43de029f3b84206676badd8a4e
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-10

    Release 0.23.13

 NEWS         | 7 +++++++
 configure.ac | 2 +-
 2 files changed, 8 insertions(+), 1 deletion(-)

commit ce3cec7f8742254b8627b9db48973b81e91cbfc8
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-09

    common: Prefer __register_atfork() to pthread_atfork() if possible

 common/library.c | 19 ++++++++++++++++++-
 configure.ac     |  2 ++
 2 files changed, 20 insertions(+), 1 deletion(-)

commit 50f8906e63c9413a7687bab6608496d83c29a222
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-07-13

    build: Stop linking the library with libpthread when possible

 configure.ac | 6 +++---
 1 file changed, 3 insertions(+), 3 deletions(-)

commit ebfd7da82d7b9eea81067479861aac2d2c07cc29
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-07-20

    common: Use thread-local storage class when possible
    
    This eliminates the unconditional use of pthread_{get,set}specific()
    and pthread_key_{create,delete}(), which glibc doesn't provide the stubs.

 common/library.c | 22 ++++++++++++++++++++++
 configure.ac     | 12 ++++++++++++
 2 files changed, 34 insertions(+)

commit dc4a6eaddbb36a344cc6a9c7eb12cab9df4899b0
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-07-20

    build: Explicitly link threaded test programs to libpthread
    
    Some test programs use pthread_create(), which glibc doesn't provide
    the stub.  Link those programs with -lpthread.

 configure.ac        | 10 ++++++++++
 p11-kit/Makefile.am |  8 ++++----
 2 files changed, 14 insertions(+), 4 deletions(-)

commit f04c2a84ad2a017a778fa2f23719318acb9ca89f
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-07-20

    common, p11-kit, trust: Use pthread_once only when necessary
    
    If the ELF constructor is usable, we don't really need the once-init
    function because it is guaranteed that the code runs only once in the
    constructor.

 common/library.c      |  4 +++-
 common/library.h      | 10 ++++++++++
 p11-kit/client-init.c |  2 +-
 p11-kit/proxy-init.c  |  2 +-
 trust/module.c        |  2 +-
 5 files changed, 16 insertions(+), 4 deletions(-)

commit 5b18e77e9dbb6a598812427ba07ad6df63eb7a67
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-07-20

    common: Use static mutex initializer when possible
    
    This eliminates the use of pthread_mutexattr_* functions, which glibc
    doesn't provide the stubs.

 common/compat.c  |  4 +++-
 common/compat.h  | 18 +++++++++++++++++-
 common/library.c | 14 ++++++++++----
 3 files changed, 30 insertions(+), 6 deletions(-)

commit 22cb49b9105657cafb98624be37f05b169f73dd6
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-08-01

    server: Avoid FD leak in error cases
    
    Spotted by coverity.

 p11-kit/server.c | 3 +++
 1 file changed, 3 insertions(+)

commit 19aaf573580e52265f57f9b7af7a03bfdfaf71e0
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-07-19

    trust: Clarify C_Login behavior that returns an error

 trust/module.c | 11 +++++++++++
 1 file changed, 11 insertions(+)

commit ab27346ceb5d4e856671a033ac1f6521c86514a1
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-07-10

    proxy: Fail early if there is no slot mappings

 p11-kit/proxy.c      |  2 ++
 p11-kit/test-proxy.c | 42 ++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 44 insertions(+)

commit fb5742cdecfde1c13d9ce610cdec050792cc57ca
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-07-09

    travis: Install pip for coveralls

 .travis.yml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit b6d20ac16da7128089031248eed4afe08f6934d3
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-06-27

    rpc-server: p11_kit_remote_serve_tokens: Allow exporting all modules
    
    This patch removes the restriction of p11_kit_remote_serve_tokens()
    that were not capable of serving tokens across multiple modules.

 p11-kit/Makefile.am   |   5 +-
 p11-kit/remote.h      |   2 +-
 p11-kit/rpc-server.c  | 209 ++++++++++++++++++++++++++++++++++----------------
 p11-kit/test-server.c |  83 +++++++++++++++-----
 4 files changed, 210 insertions(+), 89 deletions(-)

commit 9d2ce267e6714c6a565a9ded3aa0001918d1ae1d
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-06-27

    build: Use separate p11-kit-{remote,server} executable for testing
    
    Otherwise, the p11-kit-remote program called from p11-kit-server would
    load the system modules instead of the local fixtures.

 .gitignore            |  2 ++
 p11-kit/Makefile.am   | 26 ++++++++++++++++++++++++++
 p11-kit/server.c      |  2 +-
 p11-kit/test-server.c |  4 ++--
 4 files changed, 31 insertions(+), 3 deletions(-)

commit 8d8bff0a2edf4659b641dde1333eb6a7c695671c
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-06-25

    proxy: Allow proxy to be created from the library
    
    Previously, to aggregate multiple modules into one, there was no other
    way than loading the proxy module.  From the p11-kit applications,
    however, it is not possible to load that module because of the
    recursive loading check (p11_proxy_module_check).
    
    This patch adds another means to aggregate modules, through a library
    function p11_proxy_module_create.

 p11-kit/proxy.c | 40 +++++++++++++++++++++++++++++++++++++++-
 p11-kit/proxy.h |  3 +++
 2 files changed, 42 insertions(+), 1 deletion(-)

commit a65696b3e79acb602bd0c000f8524d3cc8998187
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-06-25

    proxy: Turn global variables module local

 p11-kit/proxy.c | 35 ++++++++++++++---------------------
 1 file changed, 14 insertions(+), 21 deletions(-)

commit c53888a802eed4baa4aff54060334d2fdbfc7648
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-07-13

    build: Make reallocarray detection robuster
    
    On NetBSD, reallocarray is not declared until _OPENBSD_SOURCE is
    defined.  Reported by Patrick Welche in:
    https://lists.freedesktop.org/archives/p11-glue/2018-July/000691.html

 common/compat.h | 2 +-
 configure.ac    | 1 +
 2 files changed, 2 insertions(+), 1 deletion(-)

commit 53a7e915b2694bc1957d98493a7aee9abfa3c6c5
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-06-20

    server: Enable socket activation through systemd
    
    This enables socket activation of "p11-kit server" through systemd.
    The feature provided is essentially the same as commit
    a4fb2bb5 (reverted), but implemented with "p11-kit server" and
    libsystemd API instead of wrapping "p11-kit remote" in the unit file.
    
    Note that, while it exposes all tokens through the socket, it doesn't
    increase attack surface beyond the PKCS#11 binary interface provided
    by p11-kit-proxy.so, because the service is per-user.

 .gitignore                        |  2 +-
 configure.ac                      | 23 +++++++++++++++++++++++
 p11-kit/Makefile.am               | 22 ++++++++++++++++++++++
 p11-kit/p11-kit-server.service.in | 15 +++++++++++++++
 p11-kit/p11-kit-server.socket     | 11 +++++++++++
 p11-kit/server.c                  | 33 ++++++++++++++++++++++++---------
 6 files changed, 96 insertions(+), 10 deletions(-)

commit d4a4039f97b2e1f67d09d7cd8c05fb2dd129b23c
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-31

    build: Ease issetugid() check when cross-compiling
    
    When cross-compiling, the configure check for issetugid() aborts,
    because of the pessimistic default of AC_RUN_IFELSE.  This patch
    provides the non-pessimistic default to AC_RUN_IFELSE and wrap the
    macro invocation with AC_CACHE_CHECK so that the user can override the
    check by setting ac_cv_issetugid_openbsd=yes, as suggested in:
    https://www.gnu.org/savannah-checkouts/gnu/autoconf/manual/autoconf-2.69/html_node/Runtime.html#Runtime

 configure.ac | 16 +++++++++-------
 1 file changed, 9 insertions(+), 7 deletions(-)

commit 3dd5810143e51dabdc58069e55b09a950349fa08
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-28

    Release 0.23.12

 NEWS         | 5 +++++
 configure.ac | 2 +-
 2 files changed, 6 insertions(+), 1 deletion(-)

commit f696eddecaa1f1cd1687ab5dbb942128aaca1903
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-29

    travis: Add build scripts for macOS

 .travis.yml                   | 1 +
 .travis/osx/after_failure.sh  | 3 +++
 .travis/osx/before_install.sh | 5 +++++
 .travis/osx/script.sh         | 6 ++++++
 4 files changed, 15 insertions(+)

commit a21898570d3e713155f0d8048bc6350f069f58ff
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-29

    travis: Use matrix

 .travis.yml                     | 84 +++++++++++++++++++++--------------------
 .travis/linux/after_failure.sh  |  3 ++
 .travis/linux/after_success.sh  |  9 +++++
 .travis/linux/before_install.sh |  9 +++++
 .travis/linux/install.sh        | 14 +++++++
 .travis/linux/script.sh         | 11 ++++++
 6 files changed, 90 insertions(+), 40 deletions(-)

commit 35637892e517d0e8e08dbe214f638317499ea0f5
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-29

    test: Avoid unnecessary memory allocation

 common/test-runtime.c | 7 +++----
 1 file changed, 3 insertions(+), 4 deletions(-)

commit ccb0c207964189742e97acfd817fb3c6b99e5865
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-29

    common: Fix runtime directory detection when given prefix is long

 common/runtime.c | 14 +++++++-------
 1 file changed, 7 insertions(+), 7 deletions(-)

commit 71b62aa1cdbdec3724c8e451f621309994dc59a0
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-29

    common: Don't rely on issetugid() when it is broken
    
    On macOS and FreeBSD, issetugid() has different semantics from the
    original OpenBSD implementation and cannot reliably detect if the
    process made setuid/setgid:
    https://gist.github.com/nicowilliams/4daf74a3a0c86848d3cbd9d0cdb5e26e
    
    This should fix:
    https://bugs.freedesktop.org/show_bug.cgi?id=67451
    https://bugs.freedesktop.org/show_bug.cgi?id=100287

 common/compat.c |  2 +-
 configure.ac    | 15 ++++++++++++++-
 2 files changed, 15 insertions(+), 2 deletions(-)

commit 79f928492dba6a46c63e77d6b22c17c23e66403b
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-28

    build: Don't use locale funcs if locale_t is not defined in locale.h
    
    On macOS, locale_t is not defined in <locale.h>.  Although it is
    defined in <xlocale.h>, we rather not use locales at all for POSIX
    compliance.

 common/compat.h       |  6 ++++++
 common/debug.c        |  4 ++--
 common/library.c      |  6 +++---
 common/message.c      |  4 ++--
 common/test-message.c |  6 +++---
 configure.ac          | 11 ++++++++---
 6 files changed, 24 insertions(+), 13 deletions(-)

commit cd0a2de679a81829b7323bc5db46222b9eaab1d9
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-28

    pkcs11: Exercise GNU calling convention at compile time

 .gitignore          |  1 +
 p11-kit/Makefile.am | 32 ++++++++++++++++++++++++++++++++
 p11-kit/iter.h      | 10 ++++++++++
 p11-kit/uri.h       |  4 ++++
 4 files changed, 47 insertions(+)

commit e4c5d3b34941bdc433072a492a0a7fdbddba0cc2
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-25

    build: Simplify README inclusion
    
    Use symlink in the repository, instead of copying.

 .gitignore  | 1 -
 Makefile.am | 7 +------
 README      | 1 +
 3 files changed, 2 insertions(+), 7 deletions(-)

commit 65dd5469ad164465583167c63114478587db59fd
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-24

    NEWS: Mention latest changes

 NEWS | 2 ++
 1 file changed, 2 insertions(+)

commit 8b90031aeb495116a87851dca50845b8df0d1e90
Author: Daiki Ueno <dueno@redhat.com>
Date:   2018-05-25
